// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1;

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.Ubidreams = (_ref = scope.Ubidreams) != null ? _ref : {};

  scope.Ubidreams.ConnectivityWatcher = (_ref1 = scope.Ubidreams.ConnectivityWatcher) != null ? _ref1 : {};

  scope.Ubidreams.ConnectivityWatcher.contract = {
    getConnectionStatus: function() {},
    hasConnection: function() {}
  };

  scope.Ubidreams.ConnectivityWatcher.impl = {
    _notificationType: '*',
    getComponentName: function() {
      return "ConnectivityWatcher";
    },
    configure: function(hub, configuration) {
      this.hub = hub;
      if (!((configuration != null ? configuration.attempts : void 0) == null)) {
        this.max_attempts = configuration.attempts;
      }
      this.hub.requireService({
        component: this,
        contract: scope.ContextDetector.contract,
        field: "hCD",
        optional: true
      });
      this.hub.provideService({
        component: this,
        contract: Ubidreams.ConnectivityWatcher.contract
      });
      this.hub.subscribe(this, "ConnectivityWatcher/notifyOn", Uju.bind(this, function(evt) {
        var _ref2;
        if ((_ref2 = evt.type) === 'WIFI' || _ref2 === '*') {
          return this._notificationType = evt.type;
        }
      }));
    },
    start: function() {
      var connectionType;
      if ((this.hCD == null) || this.hCD.isHybrid() === true) {
        switch (this.getConnectionStatus()) {
          case Connection.UNKNOWN:
            connectionType = 'Unknown connection';
            break;
          case Connection.ETHERNET:
            connectionType = 'Ethernet connection';
            break;
          case Connection.WIFI:
            connectionType = 'WiFi connection';
            break;
          case Connection.CELL_2G:
            connectionType = 'Cell 2G connection';
            break;
          case Connection.CELL_3G:
            connectionType = 'Cell 3G connection';
            break;
          case Connection.CELL_4G:
            connectionType = 'Cell 4G connection';
            break;
          case Connection.CELL:
            connectionType = 'Cell generic connection';
            break;
          case Connection.NONE:
            connectionType = 'No network connection';
            break;
          default:
            connectionType = "Error in connection type";
        }
        document.addEventListener("offline", Uju.bind(this, function() {
          return this._onConnectionChange(false);
        }), false);
        document.addEventListener("online", Uju.bind(this, function() {
          return this._onConnectionChange(true);
        }), false);
      } else {
        console.warn("ConnectivityWatcher :: start :: Desktop or unknown environment detected, 'hasConnection' will always return 'true' and 'getConnectionStatus' will return 'undefined'");
      }
    },
    stop: function() {},

    /* === CONTRACT IMPLEMENTATION === */

    /*
      * @return <enum> connection type
     */
    getConnectionStatus: function() {
      if ((this.hCD == null) || this.hCD.isHybrid() === true) {
        return navigator.connection.type;
      }
      return void 0;
    },

    /*
      * @return <boolean> connection availability
     */
    hasConnection: function() {
      if ((this.hCD == null) || this.hCD.isHybrid() === true) {
        if (this._notificationType === '*') {
          return navigator.connection.type !== Connection.NONE;
        } else if (this._notificationType === 'WIFI') {
          return navigator.connection.type === Connection.WIFI;
        }
      }
      return true;
    },

    /* === PRIVATE METHODS === */

    /*
      * Watch the connection availability and publish an event on the hub to notify other components
      * If the connection availability changes, we wait some seconds before publishing anything, to make sure
      * @param <boolean> status: true if connection available
     */
    _onConnectionChange: function(status) {
      if (status === true) {
        return this.hub.publish(this, "ConnectivityWatcher/connection/recovered", {});
      } else {
        return this.hub.publish(this, "ConnectivityWatcher/connection/lost", {});
      }
    }
  };

}).call(this);
