// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.FileManager = (_ref1 = scope.NumSync.FileManager) != null ? _ref1 : {};

  scope.NumSync.FileManager.contract = {
    init: function() {},
    getRootPath: function() {},
    delUserData: function() {},
    getRootFolders: function() {},
    getShares: function() {},
    getRootFolderInfo: function() {},
    getFileInfo: function() {},
    getFolderContent: function() {},
    getFolderInfo: function() {},
    getPublicLink: function() {},
    getPublicLinks: function() {},
    getFile: function() {},
    downloadFile: function() {},
    createRootFolder: function() {},
    createFolder: function() {},
    uploadFile: function() {},
    createPublicLink: function() {},
    createShare: function() {},
    createSharees: function() {},
    updateCloudFolder: function() {},
    updateFolder: function() {},
    updateFile: function() {},
    updatePublicLink: function() {},
    updateSharee: function() {},
    deleteCloudFolder: function() {},
    deleteFolder: function() {},
    deleteFile: function() {},
    deletePublicLink: function() {},
    deleteShare: function() {},
    deleteSharee: function() {},
    saveUploadQueue: function() {},
    getUploadQueue: function() {}
  };

  scope.NumSync.FileManager.impl = {
    hub: null,
    hFS: null,
    hRest: null,
    hCW: null,
    i18n: null,
    root_path: null,
    getComponentName: function() {
      return "FileManager";
    },
    configure: function(hub, config) {
      this.hub = hub;
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.FileSystem.contract,
        field: "hFS",
        optional: false
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.RESTapi.contract,
        field: "hRest"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.ConnectivityWatcher.contract,
        field: "hCW"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
      return this.hub.provideService({
        component: this,
        contract: scope.NumSync.FileManager.contract
      });
    },
    start: function() {},
    stop: function() {},

    /*
      * Retrieve path to user's NumSync folder in file system. The folder is created if not existing
      * @param <string> user_id : a user ID
      * @param <json> opts : callbacks
     */
    init: function(user_id, opts) {
      var path;
      path = user_id + "/";
      return this.hFS.getDirectoryEntry(path, Uju.bind(this, function() {
        this.root_path = path;
        this.hub.registerComponent(scope.Ubidreams.FileWatcher.impls.cordova, {
          rootpath: String(user_id),
          handleChange: true,
          analyzeOnStart: true
        });
        if ((opts != null ? opts.onSuccess : void 0) != null) {
          return opts.onSuccess();
        }
      }), function(error) {
        if ((opts != null ? opts.onError : void 0) != null) {
          return opts.onError(error);
        } else {
          return console.error("FileManager :: init :: " + error);
        }
      });
    },

    /*
      * @return <string> @root_path
     */
    getRootPath: function() {
      return this.root_path;
    },

    /*
      * Delete user data from an id
      * @param <string> user_id : a user ID
      * @param <json> opts : callbacks
     */
    delUserData: function(user_id, opts) {
      var path;
      path = user_id + "/";
      return this.hFS.removeDirectory(path, Uju.bind(this, function() {
        if ((opts != null ? opts.onSuccess : void 0) != null) {
          return opts.onSuccess();
        }
      }), function(error) {
        if ((opts != null ? opts.onError : void 0) != null) {
          return opts.onError(error);
        } else {
          return console.error("FileManager :: delUserData :: " + error);
        }
      });
    },

    /*
      * Retrieve cloud folders
      * @param <json> opts: callbacks
     */
    getRootFolders: function(opts) {
      return this._retrieveJSON({
        WS: "cloudFolders",
        method: "get"
      }, opts);
    },

    /*
      * Retrieve shared folders
      * @param <json> opts: callbacks
     */
    getShares: function(opts) {
      return this._retrieveJSON({
        WS: "shares",
        method: "get"
      }, opts);
    },

    /*
      * Retrieve a root folder's info
      * @param <string> id: a cloud folder ID
      * @param <json> opts: callbacks
     */
    getRootFolderInfo: function(id, opts) {
      return this._retrieveJSON({
        WS: "cloudFolders/" + id,
        file: "sharedCloudFolders/" + id,
        method: "head",
        header: "cloudFolderInfos"
      }, opts);
    },

    /*
      * Get file info
      * @param <string> id: a cloud folder ID
      * @param <string> path: a folder path
      * @param <json> opts : callbacks
     */
    getFileInfo: function(cloudFolderId, path, opts) {
      return this.hRest.headJSON("files/" + cloudFolderId + "/" + path, "fileInfos", Uju.bind(this, this._onComplete, opts));
    },

    /*
      * Get a folder's informations
      * @param <string> idCloudFolder: a cloud folder ID
      * @param <string> path: [Optional] a folder subpath
      * @param <json> opts : callbacks
     */
    getFolderInfo: function(cloudFolderId, path, opts) {
      return this.hRest.headJSON("folders/" + cloudFolderId + "/" + path, "folderInfos", Uju.bind(this, this._onComplete, opts));
    },

    /*
      * Get a folder's content
      * @param <string> idCloudFolder: a cloud folder ID
      * @param <string> path: [Optional] a folder subpath
      * @param <json> opts : callbacks
     */
    getFolderContent: function(idCloudFolder, path, opts) {
      var file, ws;
      ws = "folders/" + idCloudFolder;
      file = idCloudFolder;
      if ((path != null) && path !== ".") {
        ws += "/" + path;
        file += "/" + path;
      }
      file += "/folderContent";
      return this._retrieveJSON({
        WS: ws,
        file: file,
        method: "get",
        failIfUndefined: true
      }, opts);
    },

    /*
      * list all public links
      *
     */
    getPublicLinks: function(opts) {
      var ws;
      ws = "publicLinks";
      return this._retrieveJSON({
        WS: ws,
        method: 'get'
      }, opts);
    },

    /*
      * Retrieve a public link
      * @param <string> idCloudFolder: a cloud folder ID
      * @param <string> path: a file subpath
      * @param <json> opts : callbacks
     */
    getPublicLink: function(idCloudFolder, path, opts) {
      var file, ws;
      ws = "publicLinks/path/" + idCloudFolder;
      file = idCloudFolder;
      if ((path != null) && path !== ".") {
        ws += "/" + path;
        file += "/" + path;
      }
      file += ".link";
      return this._retrieveJSON({
        WS: ws,
        file: file,
        method: "get",
        failIfUndefined: true
      }, opts);
    },

    /*
      * Retrieve a file in octet
      * @param <string> idCloudFolder: a cloud folder ID
      * @param <string> path: a folder path
      * @param <json> opts : callbacks = {
      *   <function> onSuccess
      *   <function> onProgress
      *   <function> onError
      *   <function> abort
      *   <function> onDownload(start)
      * }
     */
    getFile: function(idCloudFolder, path, opts) {
      var URI, downloadFile, filePath;
      filePath = idCloudFolder + "/" + path;
      URI = this.hRest.getBaseUrl() + "files/" + idCloudFolder + "/" + path;
      downloadFile = Uju.bind(this, opts.onDownload, Uju.bind(this, function(modal) {
        return this.downloadFile(URI, filePath, {
          onSuccess: opts.onSuccess,
          onProgress: opts.onProgress,
          modal: modal
        });
      }));
      return this.hFS.getFileEntry(this.root_path + filePath, Uju.bind(this, function(fileEntry) {
        return fileEntry.file(Uju.bind(this, function(file) {
          if (this.hCW.hasConnection()) {
            return this.hFS.getFileEntry(this.root_path + filePath + ".modified", Uju.bind(this, function(modifiedEntry) {
              return this.getFileInfo(idCloudFolder, path, {
                onSuccess: Uju.bind(this, function(data) {
                  if (data.lastModified > file.lastModifiedDate) {
                    return typeof opts.onDownload === "function" ? opts.onDownload(Uju.bind(this, function(modal) {
                      return downloadFile();
                    })) : void 0;
                  } else {
                    return opts.onSuccess(file);
                  }
                }),
                onError: opts.onError
              });
            }), Uju.bind(this, function(error) {
              return downloadFile();
            }), false);
          } else {
            return opts.onSuccess(file);
          }
        }));
      }), Uju.bind(this, function(error) {
        if (this.hCW.hasConnection()) {
          return downloadFile();
        } else {
          return typeof opts.onError === "function" ? opts.onError(this.i18n.getTranslation("offline_feature")) : void 0;
        }
      }), false);
    },

    /*
      * Download file method
      * @param <string> URI
      * @param <string> filePath
      * @param <json> opts : callbacks = {
      *   <function> onSuccess
      *   <function> onProgress
      *   <function> onFail
      *   <enyo> modal : the enyo download modal
      * }
     */
    downloadFile: function(URI, filePath, opts) {
      var path;
      if (this.hCW.hasConnection()) {
        path = this.root_path + filePath;
        return this.hFS.downloadFile(URI, path, {
          onSuccess: Uju.bind(this, function(entry) {
            if (typeof opts.onSuccess === "function") {
              opts.onSuccess(entry, opts.modal);
            }
            return entry.getMetadata(Uju.bind(this, function(meta) {
              return this.hFS.writeText(path + ".modified", new Date(meta.modificationTime).getTime(), null, function(err) {
                return console.error("FileManager :: downloadFile :: Couldn't writeText for FileWatcher: " + err.code);
              });
            }), function(err) {
              return console.error("FileManager :: downloadFile :: Couldn't get file's metadata: " + err.code);
            });
          }),
          onProgress: function(event, abort) {
            return typeof opts.onProgress === "function" ? opts.onProgress(event, abort, opts.modal) : void 0;
          },
          onFail: Uju.bind(this, function(error) {
            if (error.code !== FileTransferError.ABORT_ERR) {
              return typeof opts.onError === "function" ? opts.onError(this.i18n.getTranslation("download_error", [this.hRest.getErrorMessageFromStatus(error.http_status)]), error.http_status) : void 0;
            }
          }),
          headers: {
            token: this.hRest.getToken()
          },
          disableSecurity: true
        });
      } else {
        return typeof opts.onError === "function" ? opts.onError(this.i18n.getTranslation("offline_feature")) : void 0;
      }
    },

    /*
      * Create a root folder
      * @param <json> payload: data to send
      * @param <json> opts: callbacks
     */
    createRootFolder: function(payload, opts) {
      return this.hRest.postJSON("cloudFolders", payload, Uju.bind(this, this._onComplete, {
        onSuccess: opts.onSuccess,
        onError: opts.onError,
        onResponse: opts.onResponse,
        header: "cloudFolderInfos"
      }), "cloudFolderInfos");
    },

    /*
      * Create a folder
      * @param <string> idCloudFolder: a cloud folder ID
      * @param <string> path: a folder subpath
      * @param <json> opts : callbacks
     */
    createFolder: function(idCloudFolder, path, opts) {
      return this.hRest.postJSON("folders", {
        idCloudFolder: idCloudFolder,
        path: path
      }, Uju.bind(this, this._onComplete, {
        onSuccess: opts.onSuccess,
        onError: opts.onError,
        onResponse: opts.onResponse,
        header: "folderinfos"
      }), "folderinfos");
    },

    /*
      * Upload a file
      * @param <string> fileFullPath : full path retreived from a FileEntry
      * @param <json> fileInfo : File info to pass as a header to the Rest API
      * @param <json> opts : callbacks and options to pass to the cordova FileUploadOptions instance
     */
    uploadFile: function(fileFullPath, fileInfo, opts) {
      var baseUrl, token;
      if (this.hCW.hasConnection()) {
        baseUrl = this.hRest.getBaseUrl();
        token = this.hRest.getToken();
        this.hFS.uploadFile(baseUrl + "files", fileFullPath, {
          fileKey: "content",
          fileName: fileInfo.path.split("/").pop(),
          mimeType: "application/octect-stream",
          headers: {
            fileInfos: JSON.stringify(fileInfo),
            token: token
          },
          onSuccess: opts != null ? opts.onSuccess : void 0,
          onError: opts != null ? opts.onError : void 0,
          onProgress: opts != null ? opts.onProgress : void 0,
          chunkedMode: false,
          trustAllHosts: true,
          httpMethod: opts != null ? opts.httpMethod : void 0
        });
        return true;
      }
      return false;
    },

    /*
      * Create a public link
      * First POST then PUT, then send notification
      * @param <string> idCloudFolder: a cloud folder ID
      * @param <string> path: a folder path
      * @param <json> payload: data to send
      *   {
      *     update: <json> publicLink data
      *     notify: <json> {emails, message} an array of emails and an message to send them
      *   }
      * @param <json> opts : callbacks
     */
    createPublicLink: function(idCloudFolder, path, payload, opts) {
      var errorHandler;
      errorHandler = function(response) {
        if (opts != null) {
          if (typeof opts.onError === "function") {
            opts.onError(response);
          }
        }
        return opts != null ? typeof opts.onResponse === "function" ? opts.onResponse(response) : void 0 : void 0;
      };
      return this.hRest.postJSON("publicLinks/path/" + idCloudFolder + "/" + path, {}, Uju.bind(this, this._onComplete, {
        onSuccess: Uju.bind(this, function(publicLink) {
          return this.updatePublicLink(publicLink.id, payload.update, {
            onSuccess: Uju.bind(this, function(response) {
              return this.notifySharees(publicLink.id, payload.notify, {
                onResponse: function(response_) {
                  return opts != null ? typeof opts.onResponse === "function" ? opts.onResponse({
                    data: response,
                    invalidEmails: response_.data
                  }) : void 0 : void 0;
                }
              });
            }),
            onError: errorHandler
          });
        }),
        onError: errorHandler
      }));
    },

    /*
      * Notify emails that a public has been shared with them
      * @param <string> id: a public link ID
      * @param <json> payload: data to send
      * @param <json> opts : callbacks (only onResponse)
     */
    notifySharees: function(id, payload, opts) {
      var _ref2;
      if (payload != null ? (_ref2 = payload.emails) != null ? _ref2.length : void 0 : void 0) {
        return this.hRest.postJSON("publicLinks/id/" + id + "/notification", payload, Uju.bind(this, this._onComplete, opts));
      } else {
        return opts != null ? typeof opts.onResponse === "function" ? opts.onResponse({}) : void 0 : void 0;
      }
    },

    /*
      * Share a folder
      * @param <string> idCloudFolder: a cloud folder ID
      * @param <string> path: a folder path
      * @param <json> payload: data to send (emails, message, shareType)
      * @param <json> opts : callbacks
     */
    createShare: function(idCloudFolder, path, payload, opts) {
      var WS;
      WS = "shares/path/" + idCloudFolder;
      if (path && path !== ".") {
        WS += "/" + path;
      }
      return this.hRest.postJSON(WS, payload, Uju.bind(this, this._onComplete, opts));
    },

    /*
      * Add accounts to a share
      * @param <string> shareId: a share id
      * @param <json> payload: data to send
      * @param <json> opts : callbacks
     */
    createSharees: function(shareId, payload, opts) {
      return this.hRest.postJSON("shares/id/" + shareId + "/accounts", payload, Uju.bind(function(response) {
        var email, okEmails, sharesByAccount, _i, _len;
        okEmails = payload.emails.filter(function(item) {
          return response.data.indexOf(item) === -1;
        });
        sharesByAccount = [];
        for (_i = 0, _len = okEmails.length; _i < _len; _i++) {
          email = okEmails[_i];
          sharesByAccount.push({
            type: "ShareByAccount",
            email: email,
            shareType: payload.shareType
          });
        }
        return opts != null ? typeof opts.onResponse === "function" ? opts.onResponse({
          data: {
            sharesByAccount: sharesByAccount,
            unauthorizedEmails: response.data
          }
        }) : void 0 : void 0;
      }));
    },

    /*
      * Update a cloud folder
      * @param <json> payload : data to send
      * @param <json> opts : callbacks
     */
    updateCloudFolder: function(payload, opts) {
      return this.hRest.putJSON("cloudFolders", payload, Uju.bind(this, this._onComplete, {
        onSuccess: opts.onSuccess,
        onError: opts.onError,
        onResponse: opts.onResponse,
        header: "cloudFolderInfos"
      }));
    },

    /*
      * Update a folder
      * @param <string> idCloudFolder: a cloud folder ID
      * @param <string> path: a folder path
      * @param <json> payload: data to send
      * @param <json> opts : callbacks
     */
    updateFolder: function(idCloudFolder, path, payload, opts) {
      return this.hRest.putJSON("folders/" + idCloudFolder + "/" + path, payload, Uju.bind(this, this._onComplete, {
        onSuccess: opts.onSuccess,
        onError: opts.onError,
        onResponse: opts.onResponse,
        header: "folderInfos"
      }));
    },

    /*
      * Update a file
      * @param <string> idCloudFolder: a cloud folder ID
      * @param <string> path: a folder path
      * @param <json> payload: data to send
      * @param <json> opts : callbacks
     */
    updateFile: function(idCloudFolder, path, payload, opts) {
      return this.hRest.putJSON("files/" + idCloudFolder + "/" + path, payload, Uju.bind(this, this._onComplete, {
        onSuccess: opts.onSuccess,
        onError: opts.onError,
        onResponse: opts.onResponse,
        header: "fileInfos"
      }));
    },

    /*
      * Update a public link
      * @param <string> id: a public link ID
      * @param <json> payload: data to send
      * @param <json> opts : callbacks
     */
    updatePublicLink: function(id, payload, opts) {
      payload.id = id;
      return this.hRest.putJSON("publicLinks", payload, Uju.bind(this, this._onComplete, opts));
    },

    /*
      * Update a sharee's right for a given share
     */
    updateSharee: function() {},

    /*
      * Delete a cloud folder
      * @param <string> id: a cloud folder ID
      * @param <json> opts : callbacks
     */
    deleteCloudFolder: function(id, opts) {
      return this.hRest["delete"]("cloudFolders/" + id, Uju.bind(this, this._onComplete, opts));
    },

    /*
      * Delete a folder
      * @param <string> idCloudFolder: a cloud folder ID
      * @param <string> path: a folder path
      * @param <json> opts : callbacks
     */
    deleteFolder: function(idCloudFolder, path, opts) {
      return this.hRest["delete"]("folders/" + idCloudFolder + "/" + path, Uju.bind(this, this._onComplete, opts));
    },

    /*
      * Delete a file
      * @param <string> idCloudFolder: a cloud folder ID
      * @param <string> path: a folder path
      * @param <json> opts : callbacks
     */
    deleteFile: function(idCloudFolder, path, opts) {
      return this.hRest["delete"]("files/" + idCloudFolder + "/" + path, Uju.bind(this, this._onComplete, opts));
    },

    /*
      * Delete a public link
      * @param <string> id: Public link ID
      * @param <json> opts : callbacks
     */
    deletePublicLink: function(id, opts) {
      return this.hRest["delete"]("publicLinks/id/" + id, Uju.bind(this, this._onComplete, opts));
    },

    /*
      * Delete a share
      * @param <string> id: share ID
      * @param <json> opts : callbacks
     */
    deleteShare: function(id, opts) {
      return this.hRest["delete"]("shares/id/" + id, Uju.bind(this, this._onComplete, opts));
    },

    /*
      * Remove an account from a share
     */
    deleteSharee: function() {},

    /*
      * Persist upload queue
      * @param <array> uploading: current request to persist
      * @param <array> queue: awaiting requests to persist
      * @param <array> failures: failed requests to retry
      * @param <json> opts : callbacks
     */
    saveUploadQueue: function(uploading, queue, failures, opts) {
      return this.hFS.writeText(this.root_path + "uploadQueue.json", JSON.stringify({
        uploading: uploading,
        queue: queue,
        failures: failures
      }), opts != null ? opts.onSuccess : void 0, opts != null ? opts.onError : void 0);
    },

    /*
      * Retrieve saved upload queue
      * @param <json> opts : callbacks
     */
    getUploadQueue: function(opts) {
      return this.hFS.readAsJsonFile(this.root_path + "uploadQueue.json", {
        onSuccess: function(result) {
          if (result == null) {
            result = {
              uploading: null,
              queue: null
            };
          }
          return opts != null ? opts.onSuccess(result.uploading, result.queue, result.failures) : void 0;
        },
        onFail: opts != null ? opts.onError : void 0
      });
    },

    /*
      * Triggered when a REST/WS request has completed
      * @param <json> opts:
      * {
      *   <function> onSuccess: [Optional] Success callback
      *   <function> onError: [Optional] Error callback
      *   <function> onResponse: [Optional] Called whenever a call returns
      *   <string> header: [Optional] response header to give to success callback
      * }
      * @param <json> response: Response object with the following structure:
      *   {<json> data, <json> status, <json> xhr}
      *   or
      *   {<json> error: {<string> message, <int> status (error code)}}
     */
    _onComplete: function(opts, response) {
      var responseHeader;
      if (opts == null) {
        opts = {};
      }
      if (response.error == null) {
        if (opts.header != null) {
          responseHeader = response.xhr.getResponseHeader(opts.header);
        }
        if (typeof opts.onSuccess === "function") {
          opts.onSuccess(response.data, responseHeader);
        }
      } else {
        if (opts.onError != null) {
          opts.onError(response.error.message, response.error.status);
        } else if (opts.onResponse == null) {
          console.error("FileManager :: _onComplete :: No error callback. Error is : " + response.error.message);
        }
      }
      if (Uju.isFunction(opts.onResponse)) {
        return opts.onResponse(response, responseHeader);
      }
    },

    /*
      * Retrieve the result of a webservice and save it in the FS after calling the callbacks / retrieve from the FS
      * @param <json> params: {
      *   <string> WS: WS to call
      *   <string> method: 'GET' or 'HEAD'
      *   <string> header: header for HEAD requests
      *   <string> file: name of the file to read/save
      *   <json> query: a of key/value pairs that must match
      * @param <json> opts: callbacks and other opts for restAPI/FS
     */
    _retrieveJSON: function(params, opts) {
      var args, callback, method;
      if (params.file == null) {
        params.file = params.WS;
      }
      params.file = this.root_path + params.file;
      if (this.hCW.hasConnection()) {
        callback = Uju.bind(this, function(response) {
          var _ref2;
          this._onComplete(opts, response);
          if ((this.hFS != null) && (response.error == null)) {
            if (!params.noPersistence) {
              if ((_ref2 = this.hFS) != null) {
                _ref2.writeText(params.file, JSON.stringify(response.data), void 0, function(err) {
                  return console.warn("FileManager :: _retrieveJSON :: Couldn't write to file '" + params.file + "': ", err);
                });
              }
            }
          }
          return this._updateFS(params.file, response.data);
        });
        args = [params.WS];
        if (params.method === "head") {
          args.push(params.header);
          method = "headJSON";
        } else {
          method = "getJSON";
        }
        args.push(callback);
        return this.hRest[method].apply(this.hRest, args);
      } else {
        return this.hFS.readAsJsonFile(params.file, {
          onSuccess: Uju.bind(this, function(response) {
            var item, key, match, val, _i, _len, _ref2;
            if (params.query != null) {
              for (_i = 0, _len = response.length; _i < _len; _i++) {
                item = response[_i];
                match = true;
                _ref2 = params.query;
                for (key in _ref2) {
                  val = _ref2[key];
                  if (item[key] !== val) {
                    match = false;
                    break;
                  }
                }
                if (match) {
                  this._onComplete(opts, {
                    data: item
                  });
                  return;
                }
              }
            } else {
              if (response != null) {
                return this._onComplete(opts, {
                  data: response
                });
              } else {
                return this._onComplete(opts, {
                  error: {
                    message: this.i18n.getTranslation("offline_feature"),
                    status: 0
                  }
                });
              }
            }
          }),
          onFail: Uju.bind(this, function(err) {
            console.error("FileManager :: Retrieve from FS :: Error: " + err);
            return this._onComplete(opts, {
              error: {
                message: this.i18n.getTranslation("offline_feature"),
                status: 0
              }
            });
          }),
          failIfUndefined: opts != null ? opts.failIfUndefined : void 0
        });
      }
    },

    /*
      * Remove outdated folders.files from the fileSystem
     */
    _updateFS: function(file, data) {

      /*
        * Check if the file/directory is still on the server
        * @return <boolean> true if the entry is to be removed
       */
      var directory, isToBeRemoved, remove, _ref2, _ref3, _ref4;
      isToBeRemoved = function(name) {
        var item, _i, _len;
        if (name === "folderContent") {
          return false;
        }
        for (_i = 0, _len = data.length; _i < _len; _i++) {
          item = data[_i];
          if (name === item.path.split("/").pop()) {
            return false;
          }
        }
        return true;
      };

      /*
        * Remove an entry
       */
      remove = function(entry_) {
        if (entry_.isFile) {
          return entry_.remove();
        } else {
          return entry_.removeRecursively();
        }
      };
      if (data != null) {
        if (new RegExp(/^([0-9])+\/cloudFolders$/).test(file)) {
          return (_ref2 = this.hFS) != null ? _ref2.getDirectoryEntries(this.root_path, function(entries) {
            var entry, ids, item, _i, _len, _ref3, _results;
            ids = (function() {
              var _i, _len, _results;
              _results = [];
              for (_i = 0, _len = data.length; _i < _len; _i++) {
                item = data[_i];
                _results.push(String(item.id));
              }
              return _results;
            })();
            _results = [];
            for (_i = 0, _len = entries.length; _i < _len; _i++) {
              entry = entries[_i];
              if (entry.isDirectory && (_ref3 = entry.name, __indexOf.call(ids, _ref3) < 0)) {
                _results.push(entry.removeRecursively());
              } else {
                _results.push(void 0);
              }
            }
            return _results;
          }) : void 0;
        } else if (new RegExp(/\/folderContent$/).test(file)) {
          directory = file.split("/");
          directory.pop();
          directory = directory.join("/");
          return (_ref3 = this.hFS) != null ? _ref3.getDirectoryEntries(directory, Uju.bind(this, function(entries) {
            var associatedEntry, entry, _i, _len, _ref4, _ref5, _results;
            _results = [];
            for (_i = 0, _len = entries.length; _i < _len; _i++) {
              entry = entries[_i];
              associatedEntry = entry.name.replace(/(\.modified|.link)$/, "");
              if (!new RegExp(/(\.modified|.link)$/).test(entry.name)) {
                if (isToBeRemoved(entry.name)) {
                  remove(entry);
                  if ((_ref4 = this.hFS) != null) {
                    _ref4.removeFile(entry.name + ".modified");
                  }
                  _results.push((_ref5 = this.hFS) != null ? _ref5.removeFile(entry.name + ".link") : void 0);
                } else {
                  _results.push(void 0);
                }
              } else {
                if (isToBeRemoved(associatedEntry)) {
                  _results.push(remove(entry));
                } else {
                  _results.push(void 0);
                }
              }
            }
            return _results;
          })) : void 0;
        }
      } else {
        if (new RegExp(/.link$/).test(file)) {
          return (_ref4 = this.hFS) != null ? _ref4.removeFile(file) : void 0;
        }
      }
    }
  };

}).call(this);
