// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref;

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.Ubidreams = scope.Ubidreams || {};

  scope.Ubidreams.FileWatcher = scope.Ubidreams.FileWatcher || {};

  scope.Ubidreams.FileWatcher.impls = (_ref = scope.Ubidreams.FileWatcher.impls) != null ? _ref : {};

  scope.Ubidreams.FileWatcher.contract = {
    startAnalysis: function(root_folder) {}
  };

  scope.Ubidreams.FileWatcher.impls.cordova = {
    name: "FileWatcher",
    srv_fs: null,
    rootPath: ".",
    handleChange: false,
    analyzeOnStart: false,
    getComponentName: function() {
      return this.name;
    },
    configure: function(hub, conf) {
      this.hub = hub;
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.FileSystem.contract,
        field: "srv_fs"
      });
      this.hub.provideService({
        component: this,
        contract: scope.Ubidreams.FileWatcher.contract
      });
      if (conf != null) {
        if (conf.rootpath != null) {
          this.rootPath = conf.rootpath;
        }
        if (conf.handleChange != null) {
          this.handleChange = conf.handleChange;
        }
        if (conf.analyzeOnStart != null) {
          this.analyzeOnStart = conf.analyzeOnStart;
        }
      }
      return document.addEventListener("resume", Uju.bind(this, function() {
        return this.startAnalysis(this.rootPath);
      }), false);
    },
    start: function() {
      if (this.analyzeOnStart) {
        this.startAnalysis(this.rootPath);
      }
    },
    stop: function() {},

    /*
      * See @_analyze
     */
    startAnalysis: function(rootFolder) {
      var folder;
      folder = this.rootPath;
      if (rootFolder != null) {
        folder = rootFolder;
      }
      return this._analyze(folder);
    },

    /*
      * Scan a folder's tree
      * @param <string> dir: path of the folder to scan
     */
    _analyze: function(dir) {
      var directoryReader;
      if (Uju.isString(dir)) {
        return this.srv_fs.getDirectoryEntries(dir, Uju.bind(this, this._onListOfFiles), function(err) {
          return console.error(("FileWatcher :: _analyze :: Couldn't get directory '" + dir + "' entries: ") + err);
        });
      } else {
        directoryReader = dir.createReader();
        return directoryReader.readEntries(Uju.bind(this, this._onListOfFiles), function(err) {
          return console.error(("FileWatcher :: _analyze :: Couldn't get directory '" + dir + "' entries: ") + err);
        });
      }
    },

    /*
      * Success callback from reading a directory's content
      * @param content
     */
    _onListOfFiles: function(content) {
      var f, ref_modified_f, ref_modified_ts, _i, _len, _results;
      ref_modified_ts = Uju.bind(this, this._getLastAppModifiedFromFile);
      ref_modified_f = Uju.bind(this, this._getLastModifiedFromFile);
      _results = [];
      for (_i = 0, _len = content.length; _i < _len; _i++) {
        f = content[_i];
        if (f != null ? f.isDirectory : void 0) {
          _results.push(this._analyze(f));
        } else if (f != null ? f.isFile : void 0) {
          if (new RegExp(/\.modified$/).test(f.name)) {
            _results.push(async.auto({
              modified_ts: function(cb) {
                return ref_modified_ts(cb, f);
              },
              modified_f: function(cb) {
                return ref_modified_f(cb, f);
              },
              compare_ts: ["modified_ts", "modified_f", Uju.bind(this, this._compareTs)]
            }));
          } else {
            _results.push(void 0);
          }
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    },

    /*
      * Get timestamp from .modified file + keep reference to the fileEntry for further edit
      * Pass the file content (timestamp) and the fileentry_ref to the callback
     */
    _getLastAppModifiedFromFile: function(cb, f) {
      return this.srv_fs.readAsTextFile(this._squeeze(f.fullPath), function(txt) {
        return cb(null, {
          entry: f,
          modified: txt
        });
      }, function() {
        return cb(".modified File Not Found");
      });
    },

    /*
      * Get the corresponding file metadata Date Modification based on the .modified path
      * Pass the modified date as Timestamp to the callback
     */
    _getLastModifiedFromFile: function(cb, f) {
      var file_path;
      file_path = this._squeeze(f.fullPath).replace(/\.modified$/, "");
      return this.srv_fs.getFileEntry(file_path, function(entry) {
        return entry.getMetadata(function(meta) {
          return cb(null, new Date(meta.modificationTime).getTime());
        }, null);
      }, function() {
        return cb("reference File not found");
      }, false);
    },

    /*
      * Compare the timestamps and change the .modified content if needed
     */
    _compareTs: function(cb, results) {
      var res_file_ts, res_mod_file_obj;
      res_mod_file_obj = results["modified_ts"];
      res_file_ts = results["modified_f"];
      if ((res_mod_file_obj != null) && res_mod_file_obj.modified < res_file_ts) {
        this.hub.publish(this, "FileWatcher/fileChanged", {
          file_path: res_mod_file_obj.entry.fullPath.replace(/\.modified$/, ""),
          modifiedOn: res_file_ts
        });
        if (this.handleChange) {
          this.srv_fs.writeText(this._squeeze(res_mod_file_obj.entry.fullPath), res_file_ts, null, function() {
            return console.error("FileWatcher :: _compareTs :: Edition failed for file '" + res_mod_file_obj.entry.fullPath + "'");
          });
        }
      }
      return cb(null);
    },

    /*
      * Get the path relative to the 'NumSync' root folder
     */
    _squeeze: function(fullPath) {
      var pathArray;
      if (!fullPath) {
        return fullPath;
      }
      pathArray = fullPath.split("/");
      pathArray.splice(0, pathArray.indexOf("NumSync") + 1);
      return pathArray.join("/");
    }
  };

}).call(this);
