// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1;

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.ImportHandler = (_ref1 = scope.NumSync.ImportHandler) != null ? _ref1 : {};

  scope.NumSync.ImportHandler.contract = {
    checkImport: function() {},
    addHandler: function(inFunction) {},
    runImport: function(url, targetEntry) {}
  };

  scope.NumSync.ImportHandler.impl = {
    h_FM: null,
    i18n: null,
    urlToImport: null,
    getComponentName: function() {
      return 'ImportHandler';
    },
    configure: function(hub, configuration) {
      this.hub = hub;
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.FileManager.contract,
        field: "h_FM",
        optional: true
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
      this.hub.provideService({
        component: this,
        contract: scope.NumSync.ImportHandler.contract
      });
      return window.handleOpenURL = Uju.bind(this, this._onOpenURL);
    },
    start: function() {},
    stop: function() {},
    checkImport: function() {
      if (this.urlToImport != null) {
        this._openFilesTreeLight();
        return this.urlToImport = null;
      }
    },
    addHandler: function(inFunction) {
      return inFunction(Uju.bind(this, this._onOpenURL));
    },
    runImport: function(url, targetEntry) {
      return this._performImport(url, targetEntry);
    },

    /*
      * Triggered when app is opened from another
      * @param <string> url
     */
    _onOpenURL: function(url) {
      return this.urlToImport = url;
    },

    /*
      * Open the files tree light modal
     */
    _openFilesTreeLight: function() {
      return enyo.Signals.send("requestFilesTreeLight", {
        widgetConf: {
          onDropFile: Uju.bind(this, this._performImport, this.urlToImport)
        }
      });
    },

    /*
      * Perform import
      * @param <string> urlToImport
      * @param <Entry> targetEntry : the model of the current folder entry where the file will be imported
      * @param <function> close : to close the files tree light (if import is done from it)
     */
    _performImport: function(urlToImport, targetEntry, close) {
      var id, infos, path;
      infos = targetEntry.getPayload();
      id = infos.id || infos.idCloudFolder;
      path = infos.path || "";
      path += infos.path != null ? "/" : "";
      return window.resolveLocalFileSystemURI(urlToImport, Uju.bind(this, this._uploadEntry, id, path, close), Uju.bind(this, function(error) {
        var filePath, unresolved;
        unresolved = error["unresolved-url"];
        if (unresolved != null) {
          filePath = id + "/" + path + unresolved.split("/").pop();
          return this.h_FM.downloadFile(unresolved, filePath, {
            onSuccess: Uju.bind(this, this._uploadEntry, id, path, close)
          });
        }
      }));
    },

    /*
      * Upload an entry when file is dropped
      * @param <int> idCloudFolder
      * @param <string> path
      * @param <function> close : to close the files tree light
      * @param <File> entry : a file entry from File cordova plugin
     */
    _uploadEntry: function(idCloudFolder, path, close, entry) {
      return entry.file(Uju.bind(this, function(file) {
        if (typeof close === "function") {
          close();
        }
        path += file.name;
        this.hub.publish(this, "Upload/file", {
          file: {
            idCloudFolder: idCloudFolder,
            path: path
          },
          filePath: entry.fullPath
        });
        return enyo.Signals.send("showModal", {
          clean: false,
          modal: {
            kind: "NumSync.Notification",
            type: NumSync.Notification.types.SUCCESS,
            message: this.i18n.getTranslation("import_success"),
            timeout: 3000
          }
        });
      }));
    }
  };

}).call(this);
