// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.Main = (_ref1 = scope.NumSync.Main) != null ? _ref1 : {};

  scope.NumSync.Main.contract = {
    logout: function(forgetMe, noReload) {}
  };

  scope.NumSync.Main.impl = (function(_super) {
    __extends(impl, _super);

    impl.prototype.hCtx = null;

    impl.prototype.i18n = null;

    function impl() {
      impl.__super__.constructor.call(this);
      this.ui = "NumSync.Main.ui";
      this.subWidgets = [
        {
          className: "NumSync.PushMenu",
          config: {
            field: "push"
          }
        }
      ];
    }

    impl.prototype.configure = function(hub, conf) {
      impl.__super__.configure.call(this, hub, conf);
      this.hub.requireService({
        component: this,
        contract: scope.ContextDetector.contract,
        field: "hCtx"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
      this.hub.requireService({
        component: this,
        contract: Ubidreams.BrowserStorage.contract,
        field: "hBS"
      });
      this.hub.provideService({
        component: this,
        contract: scope.NumSync.Main.contract
      });
      this.hub.subscribe(this, "ConnectivityWatcher/connection/lost", Uju.bind(this, function() {
        return this._onConnectionChange(false);
      }));
      return this.hub.subscribe(this, "ConnectivityWatcher/connection/recovered", Uju.bind(this, function() {
        return this._onConnectionChange(true);
      }));
    };

    impl.prototype.start = function() {
      impl.__super__.start.call(this);
      this.hub.registerComponent(Ubidreams.Navigation.impl, {
        container: this.widget.$.content,
        namespace: "NumSync",
        homePage: "home"
      });
      this.hub.registerComponent(NumSync.EntryHelper.impl);
      if (this.hCtx.isHybrid()) {
        this.hub.registerComponent(scope.NumSync.Upload.impl);
      }
      this.registeredSubWidgets["push"].drawWidget(this.widget.$.pushMenu);
      return this.widget.configurePushMenu();
    };


    /*
      * Logout method
      * @param <boolean> forgetMe : if true remove token and user cookies else remove only token - default is false
     */

    impl.prototype.logout = function(forgetMe, noReload) {
      return this._clearCache(forgetMe, noReload);
    };


    /*
      * Clear cache
      * @param <boolean> clearAll : if true remove the user cookie and the token cookie else remove only the user cookie
     */

    impl.prototype._clearCache = function(clearAll, noReload) {
      this.hBS.del("token");
      if (clearAll === true) {
        this.hBS.del("user");
      }
      if (noReload !== false) {
        return location.reload();
      }
    };


    /*
      * On connection change
      * @param <boolean> connectionStatus: true if connection available
     */

    impl.prototype._onConnectionChange = function(connectionStatus) {
      return enyo.Signals.send("showModal", {
        clean: false,
        modal: {
          kind: "NumSync.Notification",
          type: NumSync.Notification.types.INFO,
          message: this.i18n.getTranslation("connection_" + (connectionStatus ? "on" : "off"))
        }
      });
    };

    return impl;

  })(scope.Ubidreams.widgets.Abstract.impl);

  enyo.kind({
    name: "NumSync.Main.ui",
    id: "body-wrapper",
    components: [
      {
        name: "pushMenu"
      }, {
        name: "main",
        id: "main",
        components: [
          {
            name: "pushScrim",
            classes: "enyo-fit",
            showing: false
          }, {
            name: "content",
            classes: "scroller-content"
          }
        ]
      }
    ],
    configurePushMenu: function() {
      this.$.pushScrim.applyStyle("-webkit-box-shadow", "0 0 15px 1px rgba(0,0,0,0.3)");
      this.$.pushScrim.applyStyle("box-shadow", "0 0 15px 1px rgba(0,0,0,0.3)");
      this.$.pushScrim.applyStyle("z-index", "1500");
      this.$.pushScrim.applyStyle("height", "100%");
      this._pushMenu = this.$.pushMenu.getClientControls()[0];
      this._pushMenu.setPushControl(this.$.main);
      return this._pushMenu.setScrimControl(this.$.pushScrim);
    }
  });

}).call(this);
