// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.Ubidreams = (_ref = scope.Ubidreams) != null ? _ref : {};

  scope.Ubidreams.ModalsHandler = (_ref1 = scope.Ubidreams.ModalsHandler) != null ? _ref1 : {};

  scope.Ubidreams.ModalsHandler.impl = (function(_super) {
    __extends(impl, _super);

    function impl() {
      impl.__super__.constructor.call(this);
      this.ui = "Ubidreams.ModalsHandler.ui";
    }

    impl.prototype.start = function() {
      impl.__super__.start.call(this);
      return scope.NumSync.modalsHandler = this.widget;
    };


    /*
      * Return a subWidget, based on its field
      * @param field: <string>
     */

    impl.prototype._getSubWidget = function(field) {
      return this.registeredSubWidgets[field];
    };

    return impl;

  })(scope.Ubidreams.widgets.Abstract.impl);


  /*
    * Wrapper kind
    *
    * This kind handles modals (create/show/hide/destroy) and scrim
   */

  enyo.kind({
    name: "Ubidreams.ModalsHandler.ui",
    components: [
      {
        kind: "enyo.Signals",
        showModal: "_onModalRequest"
      }, {
        kind: "enyo.Signals",
        closeModals: "_sgnlcloseModals"
      }, {
        kind: "enyo.Signals",
        closeCurrentModal: "_sgnlCloseCurrent"
      }, {
        kind: "enyo.Signals",
        offsetModal: "_offsetForPushMenu"
      }
    ],
    _modalsCounter: 0,
    _currentModal: void 0,
    _nextModal: void 0,

    /*
      * Configure Android backButton to close current modal
     */
    create: function() {
      this.inherited(arguments);
      return NumSync.backActions.modalsHandler = Uju.bind(this, function() {
        return this._closeCurrentModal();
      });
    },

    /*
      * Implemented to show the push menu
     */
    _offsetForPushMenu: function(inSender, inEvent) {
      var modal, _i, _len, _ref2, _results;
      _ref2 = this.getClientControls();
      _results = [];
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        modal = _ref2[_i];
        if (modal.scrim || modal.fullscreen) {
          _results.push(modal.applyOffset(inEvent.offset));
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    },

    /*
      * Close current modal when the "closeCurrentModal" signal is received
      * @param <json> inSender
      * @param <json> inEvent
      * {
      *   force: <boolean> if true, force modal closing
      * }
     */
    _sgnlCloseCurrent: function(inSender, inEvent) {
      return this._closeCurrentModal(inEvent.force);
    },

    /*
      * Close all modals when the "closeModals" signal is received
     */
    _sgnlcloseModals: function() {
      return this._closeModals();
    },

    /*
      * Close current modal
      * @param <boolean> : set to true to force closing
     */
    _closeCurrentModal: function(forceClose) {
      if (this._currentModal != null) {
        this._currentModal.close(forceClose);
        return true;
      }
      return false;
    },

    /*
      * When a modal is requested from the "showModal" signal
      * @param <json> inSender
      * @param <json> inEvent : info about modal to create
      * {
      *   modal: {kind, ...} (options to pass to createComponent)
      *   clean: <boolean> if true, _opened popup will be closed first - default is true
      *   callback: <functon> called with modal as first parameter when created
      * }
     */
    _onModalRequest: function(inSender, inEvent) {
      var modal;
      if (inEvent.clean !== false && inEvent.waitForClosing !== false) {
        this._closeModals(inEvent.modal);
      } else if (inEvent.clean !== false && inEvent.waitForClosing !== true) {
        this._closeModals();
        modal = this._createModal(inEvent.modal);
      } else {
        modal = this._createModal(inEvent.modal);
      }
      if (inEvent.callback != null) {
        return inEvent.callback(modal);
      }
    },

    /*
      * Create modal
      * @param <JSON> modal definition.
      *   It is either a kind definition (i.e {kind: "myKind", classes: "class1 lass2"})
      *   Or a subWidget definition (i.e {className: "Namespace.MyClass", config: {myProperty: 2}})
     */
    _createModal: function(modal_def) {
      var modal, subWidget, wrapper, wrapperDiv, _ref2;
      if (modal_def.kind != null) {
        modal = this.createComponent(modal_def);
      } else {
        if (modal_def.config == null) {
          modal_def.config = {};
        }
        modal_def.config.field = "modal_" + (this._modalsCounter++);
        modal_def.config.container = this;
        modal_def.config.emptyContainer = false;
        this._call("addSubWidget", modal_def);
        subWidget = this._call("_getSubWidget", modal_def.config.field);
        modal = subWidget.__proxy__.widget;
      }
      if (modal.scrim === true && !modal.fullscreen) {
        wrapper = this.createComponent({
          kind: "Ubidreams.widgets.ModalScrim"
        });
        wrapperDiv = wrapper.$.wrapper;
      }
      if (subWidget != null) {
        subWidget.drawWidget(wrapperDiv);
      } else {
        if ((_ref2 = Ubidreams._i18n) != null) {
          _ref2.translate(modal, true);
        }
        if (wrapperDiv != null) {
          modal.setContainer(wrapperDiv);
        }
        modal.render();
      }
      modal.setOwner(this);
      if (wrapper != null) {
        modal.setScrimControl(wrapper);
        wrapper.render();
      }
      this._currentModal = modal;
      if (modal_def === this._nextModal) {
        this._nextModal = void 0;
      }
      return modal;
    },

    /*
      * Close all modals and open a new one if asked
      * @param nextModal: <json> next modal def
     */
    _closeModals: function(nextModal) {
      var modal, modals, _i, _len, _results;
      this._nextModal = nextModal;
      modals = this.getClientControls();
      if (modals.length) {
        _results = [];
        for (_i = 0, _len = modals.length; _i < _len; _i++) {
          modal = modals[_i];
          _results.push(modal.close(true));
        }
        return _results;
      } else if (this._nextModal != null) {
        return this._createModal(this._nextModal);
      }
    },

    /*
      * Called when a modal is opened
      * @param inSender: opened modal
     */
    _onModalOpened: function(inSender) {
      if (inSender.scrim || inSender.fullscreen) {
        return enyo.Signals.send("onModalOpened", {
          modal: inSender
        });
      }
    },

    /*
      * Called when a modal is closed
      * @param inSender: closed modal
     */
    _onModalClosed: function(inSender) {
      var modals;
      if (inSender._call != null) {
        this._call("removeSubWidget", inSender._call("getFieldName"));
      } else {
        inSender.destroy();
      }
      if (inSender._scrim != null) {
        inSender._scrim.destroy();
      }
      modals = this.getClientControls();
      this._currentModal = modals[modals.length - 1];
      if (inSender.scrim || inSender.fullscreen) {
        enyo.Signals.send("onModalClosed", {
          modal: inSender
        });
      }
      if (this._nextModal != null) {
        return this._createModal(this._nextModal);
      } else if (this._currentModal == null) {
        return enyo.Signals.send("onModalsClosed");
      }
    }
  });


  /*
    * This is the kind that wrap a modal
   */

  enyo.kind({
    name: "Ubidreams.widgets.ModalScrim",
    classes: "modal-scrim",
    components: [
      {
        name: "wrapper",
        classes: "enyo-fit",
        style: "overflow: hidden"
      }
    ],
    close: function(forceClose) {
      return this.modal.close(forceClose);
    },
    tap: function(inSender, inEvent) {
      return this.close();
    },
    applyOffset: function(offset) {
      return this.modal.applyOffset(offset);
    },
    setOffset: function(property, offset) {
      this.$.wrapper.addClass("ios7-offset2");
      return this.$.wrapper.applyStyle(property, offset);
    }
  });


  /*
    * This is the kind evey modal implement
   */

  enyo.kind({
    name: "Ubidreams.widgets.Modals",
    classes: "modals",
    published: {
      start: "bottom",
      offset: 0,
      scrim: true,
      swipe: false,
      userClosable: true,
      fullscreen: false
    },
    events: {
      onClose: "",
      onOpen: ""
    },
    handlers: {
      ondragstart: "dragstart",
      ondrag: "drag",
      ondragfinish: "dragend"
    },
    _opened: false,
    _transition: false,
    _isOffest: false,
    _scrim: void 0,
    create: function() {
      var _ref2;
      this.inherited(arguments);
      if (this.swipe && ((_ref2 = this.start) !== "left" && _ref2 !== "right")) {
        console.warn("Modals :: initComponents :: swipe is only available if start position is 'left' or 'right");
        return this.swipe = false;
      }
    },
    rendered: function() {
      this.inherited(arguments);
      return this._configureModal();
    },
    open: function() {
      return this._toggleAnimation(true);
    },
    close: function(forceClose) {
      if (this.userClosable || forceClose === true) {
        return this._toggleAnimation(false);
      }
    },
    applyOffset: function(offset) {
      if (offset > 0) {
        this._isOffest = true;
      } else {
        this._isOffest = false;
      }
      return this._applyTranslate({
        x: offset
      }, true);
    },
    setScrimControl: function(control) {
      this._scrim = control;
      return control.modal = this;
    },

    /*
    * Position modal, set listeners, open it
     */
    _configureModal: function() {
      var height, width;
      if (this._scrim != null) {
        this._scrim.setOffset(this.start, this.offset);
      }
      this.applyStyle("position", "absolute");
      if (!this.scrim) {
        this.applyStyle("z-index", 1000);
      }
      if (this.fullscreen) {
        this.applyStyle("width", "100%");
        this.applyStyle("height", "100%");
      } else {
        if (this.start === "top" || this.start === "bottom") {
          this.applyStyle("width", "100%");
        } else {
          this.applyStyle("height", "100%");
        }
      }
      height = this.getBounds().height;
      width = this.getBounds().width;
      switch (this.start) {
        case "top":
          this.applyStyle("top", 0);
          this.applyStyle("left", 0);
          this._applyTranslate({
            y: -100
          });
          break;
        case "bottom":
          this.applyStyle("bottom", 0);
          this.applyStyle("left", 0);
          this._applyTranslate({
            y: 100
          });
          break;
        case "left":
          this.applyStyle("left", 0);
          this.applyStyle("top", 0);
          this._applyTranslate({
            x: -100
          });
          break;
        case "right":
          this.applyStyle("right", 0);
          this.applyStyle("top", 0);
          this._applyTranslate({
            x: 100
          });
      }
      $(this.hasNode()).unbind("webkitTransitionEnd");
      $(this.hasNode()).bind("webkitTransitionEnd", Uju.bind(this, this._transitionEnd));
      return setTimeout(Uju.bind(this, function() {
        this._toggleTransition(true);
        return this.open();
      }), 50);
    },

    /*
      * Apply 3D translation
      * @param coords: json with option for translation
      * @param px: true for pixes, else %
     */
    _applyTranslate: function(coords, px) {
      var unit, x, y, z;
      unit = px === true ? "px" : "%";
      x = coords.x != null ? coords.x + unit : 0;
      y = coords.y != null ? coords.y + unit : 0;
      z = coords.z != null ? coords.z + unit : 0;
      return enyo.dom.transformValue(this, "translate3d", "" + x + ", " + y + ", " + z);
    },

    /*
      * Toggle animation for opening/closing modal
      * @param openit: <boolean> true if we want to open, false to close
     */
    _toggleAnimation: function(openit) {
      switch (this.start) {
        case "top":
          if (openit) {
            this._applyTranslate({
              y: 0
            });
          } else {
            this._applyTranslate({
              y: -100
            });
          }
          break;
        case "bottom":
          if (openit) {
            this._applyTranslate({
              y: 0
            });
          } else {
            this._applyTranslate({
              y: 100
            });
          }
          break;
        case "left":
          if (openit) {
            this._applyTranslate({
              x: 0
            });
          } else {
            this._applyTranslate({
              x: -100
            });
          }
          break;
        case "right":
          if (openit) {
            this._applyTranslate({
              x: 0
            });
          } else {
            this._applyTranslate({
              x: 100
            });
          }
      }
      return this._opened = openit;
    },

    /*
      * Enable/disable transitions
      * @param flag: boolean
     */
    _toggleTransition: function(flag) {
      this.applyStyle("-webkit-transition", flag === true ? "-webkit-transform .25s" : null);
      this.applyStyle("transition", flag === true ? "transform .25s" : null);
      return this._transition = flag;
    },

    /*
      * Triggered when animation is finished
     */
    _transitionEnd: function(e) {
      var _ref2;
      if ((e != null ? (_ref2 = e.originalEvent) != null ? _ref2.srcElement : void 0 : void 0) === this.hasNode()) {
        if (this._opened) {
          this.owner._onModalOpened(this);
          this.doOpen({});
        } else {
          this.owner._onModalClosed(this);
          this.doClose({});
        }
        e.stopPropagation();
        return false;
      }
    },

    /*
      * Disable transitions on dragstart for swipe
     */
    dragstart: function(inSender, inEvent) {
      if (this.swipe && !this._isOffest && Math.abs(inEvent.dy) < 10) {
        return this._toggleTransition(false);
      }
    },

    /*
      * Make the modal follow the movement
     */
    drag: function(inSender, inEvent) {
      if (this.swipe && !this._transition && !this._isOffest && ((this.start === "left" && inEvent.dx < 0) || this.start === "right" && inEvent.dx > 0)) {
        return this._applyTranslate({
          x: inEvent.dx
        }, true);
      }
    },

    /*
      * On drag end, close the modal or replace it correctly
     */
    dragend: function(inSender, inEvent) {
      var minimum;
      if (this._isOffest) {
        this._isOffest = false;
        enyo.Signals.send("closePushMenu");
        return this.open();
      } else if (this.swipe && !this._transition) {
        inEvent.preventTap();
        this._toggleTransition(true);
        minimum = this.getBounds().width / 4;
        if (minimum <= inEvent.dx * (this.start === "left" ? -1 : 1)) {
          return this.close();
        } else {
          return this.open();
        }
      }
    },

    /*
      * Disable tap propagation
     */
    tap: function(inSender, inEvent) {
      return true;
    }
  });

}).call(this);
