// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1;

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.RESTapi = (_ref1 = scope.NumSync.RESTapi) != null ? _ref1 : {};

  scope.NumSync.RESTapi.error = {
    UNAUTHORIZED: 401,
    FORBIDDEN: 403,
    RESOURCE_NOT_FOUND: 404,
    TOKEN_EXPIRED: 408,
    CONFLICT: 409,
    RESOURCE_ALREADY_EXIST: 410,
    PRECONDITION_FAILED: 412
  };

  scope.NumSync.RESTapi.contract = {
    auth: function(payload, rememberMe, saveToFS, complete) {},
    setToken: function(token) {},
    getToken: function() {},
    getBaseUrl: function() {},
    encodeURI: function(url) {},
    createAccount: function(payload, complete) {},
    getErrorMessageFromStatus: function(status) {},
    getJSON: function(WS, complete) {},
    headJSON: function(WS, responseHeader, complete) {},
    "delete": function(WS, complete) {},
    postJSON: function(WS, payload, complete) {},
    putJSON: function(WS, payload, complete) {}
  };

  scope.NumSync.RESTapi.impl = {
    baseURL: null,
    hAS: null,
    hBS: null,
    i18n: null,
    hUser: null,
    hCtx: null,
    token: null,
    isConnecting: false,
    getComponentName: function() {
      return 'RESTapi';
    },
    configure: function(hub, configuration) {
      this.hub = hub;
      this.hub.requireService({
        component: this,
        contract: AjaxService.contract,
        field: "hAS"
      });
      this.hub.requireService({
        component: this,
        contract: Ubidreams.BrowserStorage.contract,
        field: "hBS"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.UserInfo.contract,
        field: "hUser"
      });
      this.hub.requireService({
        component: this,
        contract: scope.ContextDetector.contract,
        field: "hCtx"
      });
      return this.hub.provideService({
        component: this,
        contract: scope.NumSync.RESTapi.contract
      });
    },
    start: function() {},
    stop: function() {},

    /*
      * Encode URI
      * @param <string> url
     */
    encodeURI: function(url) {
      var i, item, newURL, splittedURL, _i, _len;
      splittedURL = url.split("/");
      newURL = "";
      for (i = _i = 0, _len = splittedURL.length; _i < _len; i = ++_i) {
        item = splittedURL[i];
        if (i !== 0) {
          newURL += "/";
        }
        newURL += encodeURIComponent(item);
      }
      return newURL;
    },

    /*
      * User authentification
      * @param <json> payload with "login", "password"
      * @param <boolean> rememberMe
      * @param <function> complete callback with user "data" as param
     */
    auth: function(payload, rememberMe, complete) {
      this.baseURL = scope.NumSync.config.NUMSYNC_API_BASEURL + '/ws/api/';
      this.isConnecting = true;
      return this.postJSON("accounts/auth", payload, Uju.bind(this, function(response) {
        var data;
        this.isConnecting = false;
        if (response.data != null) {
          this.setToken(response.data.token);
          this.i18n.setLanguage(response.data.locale);
          this.hBS.set("language", response.data.locale);
          data = {
            login: payload.login,
            id: response.data.id,
            locale: response.data.locale
          };
          if (rememberMe === true) {
            this.hBS.set("token", response.data.token || "");
            data.password = payload.password;
          }
          this.hUser.setUserData(data);
          if (!this.hCtx.isHybrid()) {
            return typeof complete === "function" ? complete(response) : void 0;
          } else {
            return this.hUser.getUser(data.id, Uju.bind(this, function(user_) {
              var offline;
              offline = (user_ != null ? user_.offline : void 0) || false;
              this.hBS.set("offline", offline);
              this.hUser.saveUser({
                id: data.id,
                login: data.login,
                password: payload.password,
                language: data.locale,
                offline: offline
              });
              return typeof complete === "function" ? complete(data.id) : void 0;
            }));
          }
        } else {
          return typeof complete === "function" ? complete(response) : void 0;
        }
      }));
    },

    /*
      * Set token method
      * @param <string> token
     */
    setToken: function(token) {
      return this.token = token;
    },

    /*
      * Get the token
     */
    getToken: function() {
      return this.token;
    },

    /*
      * Get the base URL
     */
    getBaseUrl: function() {
      return this.baseURL;
    },

    /*
      * Create a user account
      * @param <json> payload with "login", "password", "name", "firstName", "locale", "timeZone"
      * @param <function> complete callback
     */
    createAccount: function(payload, complete) {
      return this.postJSON("accounts", payload, complete);
    },

    /*
      * GET request
      * @param <string> WS : web service
      * @param <function> complete callback : return {data: <json>} or {error: "an error"}
      * @param <string> responseHeader : response header property {optional}
     */
    getJSON: function(WS, complete, responseHeader) {
      return this.hAS.get({
        url: this.baseURL + this.encodeURI(WS),
        dataType: "json",
        more: {
          headers: {
            token: this.token || ""
          }
        },
        onSuccess: Uju.bind(this, function(data, status, xhr) {
          return typeof complete === "function" ? complete({
            data: data,
            status: status,
            xhr: xhr
          }) : void 0;
        }),
        onError: Uju.bind(this, function(xhr, code, error) {
          return this._checkError(xhr, complete, Uju.bind(this, this.getJSON, WS, complete, responseHeader));
        })
      });
    },

    /*
      * POST request
      * @param <string> WS : web service
      * @param <json> payload : to send with the request
      * @param <function> complete callback : return {data: <json>} or {error: "an error"}
     */
    postJSON: function(WS, payload, complete, expected_header) {
      var headers;
      headers = {
        token: this.token || ""
      };
      if (expected_header != null) {
        headers[expected_header] = "";
      }
      return this.hAS.postJSON({
        url: this.baseURL + this.encodeURI(WS),
        dataType: "json",
        more: {
          headers: headers
        },
        payload: payload,
        onSuccess: Uju.bind(this, function(data, status, xhr) {
          return typeof complete === "function" ? complete({
            data: data,
            status: status,
            xhr: xhr
          }) : void 0;
        }),
        onError: Uju.bind(this, function(xhr, code, error) {
          return this._checkError(xhr, complete, Uju.bind(this, this.postJSON, WS, payload, complete));
        })
      });
    },

    /*
      * PUT request
      * @param <string> WS : web service
      * @param <json> payload : to send with the request
      * @param <function> complete callback : return {data: <json>} or {error: "an error"}
      * @param <json> opts with properties : "headers"
     */
    putJSON: function(WS, payload, complete, opts) {
      var headers;
      if (opts == null) {
        opts = {};
      }
      headers = {
        token: this.token || ""
      };
      if (typeof responseHeader !== "undefined" && responseHeader !== null) {
        headers[responseHeader] = "";
      }
      return this.hAS.ajax({
        url: this.baseURL + this.encodeURI(WS),
        method: "PUT",
        dataType: "json",
        contentType: "application/json",
        more: {
          headers: headers
        },
        payload: JSON.stringify(payload),
        onSuccess: Uju.bind(this, function(data, status, xhr) {
          return typeof complete === "function" ? complete({
            data: data,
            status: status,
            xhr: xhr
          }) : void 0;
        }),
        onError: Uju.bind(this, function(xhr, code, error) {
          return this._checkError(xhr, complete, Uju.bind(this, this.putJSON, WS, payload, complete, opts));
        })
      });
    },

    /*
      * HEAD request
      * @param <string> WS : web service
      * @param <string> responseHeader : response header property
      * @param <function> complete callback : return {data: <json>} or {error: "an error"}
     */
    headJSON: function(WS, responseHeader, complete) {
      var headers;
      headers = {
        token: this.token || ""
      };
      if (responseHeader != null) {
        headers[responseHeader] = "";
      }
      return this.hAS.ajax({
        url: this.baseURL + this.encodeURI(WS),
        method: "HEAD",
        dataType: "json",
        more: {
          headers: headers
        },
        onSuccess: Uju.bind(this, function(data, status, xhr) {
          var result;
          result = xhr.getResponseHeader(responseHeader);
          if (Uju.isString(result)) {
            result = JSON.parse(result);
          }
          if (Uju.isObject(result)) {
            return typeof complete === "function" ? complete({
              data: result,
              status: status,
              xhr: xhr
            }) : void 0;
          } else {
            console.error("_headJSON :: onSuccess :: not a JSON object");
            return this._checkError(xhr, complete);
          }
        }),
        onError: Uju.bind(this, function(xhr, code, error) {
          return this._checkError(xhr, complete, Uju.bind(this, this.headJSON, WS, responseHeader, complete));
        })
      });
    },

    /*
      * DELETE request
     */
    "delete": function(WS, complete) {
      return this.hAS.ajax({
        url: this.baseURL + this.encodeURI(WS),
        method: "DELETE",
        dataType: "json",
        more: {
          headers: {
            token: this.token || ""
          }
        },
        onSuccess: Uju.bind(this, function(data, status, xhr) {
          return typeof complete === "function" ? complete({
            data: data,
            status: status,
            xhr: xhr
          }) : void 0;
        }),
        onError: Uju.bind(this, function(xhr, code, error) {
          return this._checkError(xhr, complete, Uju.bind(this, this["delete"], WS, complete));
        })
      });
    },

    /*
      * Return error message from a status code
      * @param <int> status
     */
    getErrorMessageFromStatus: function(status) {
      var message;
      switch (status) {
        case scope.NumSync.RESTapi.error.UNAUTHORIZED:
          message = this.i18n.getTranslation("error_unauthorized");
          break;
        case scope.NumSync.RESTapi.error.FORBIDDEN:
          message = this.i18n.getTranslation("error_forbidden");
          break;
        case scope.NumSync.RESTapi.error.RESOURCE_NOT_FOUND:
          message = this.i18n.getTranslation("error_resource_not_found");
          break;
        case scope.NumSync.RESTapi.error.TOKEN_EXPIRED:
          message = this.i18n.getTranslation("error_expired_token");
          break;
        case scope.NumSync.RESTapi.error.CONFLICT:
          message = this.i18n.getTranslation("error_conflict");
          break;
        case scope.NumSync.RESTapi.error.RESOURCE_ALREADY_EXIST:
          message = this.i18n.getTranslation("error_already_exists");
          break;
        case scope.NumSync.RESTapi.error.PRECONDITION_FAILED:
          message = this.i18n.getTranslation("error_preconditions");
          break;
        default:
          message = this.i18n.getTranslation("error_unknown");
      }
      return message;
    },

    /*
      * Check error
      * @param <json> xhr : the ajax object
      * @param <function> complete callback : return {error: "an error"}
      * @param <function> replayXHR
     */
    _checkError: function(xhr, complete, replayXHR) {
      var reconnect, user;
      if ((xhr.status === scope.NumSync.RESTapi.error.TOKEN_EXPIRED || xhr.status === scope.NumSync.RESTapi.error.UNAUTHORIZED) && !this.isConnecting) {
        reconnect = true;
      } else {
        reconnect = false;
      }
      if (reconnect === true) {
        user = this.hUser.getUserData();
        if ((user != null) && (user.login != null) && (user.password != null)) {
          return this.auth({
            login: user.login,
            password: user.password
          }, true, Uju.bind(this, function() {
            return replayXHR();
          }));
        } else {
          this.hBS.set("token", "EXPIRED");
          if (typeof complete === "function") {
            complete({
              error: {
                message: this.getErrorMessageFromStatus(xhr.status),
                status: xhr.status
              }
            });
          }
          if (this.debug == null) {
            return location.reload();
          }
        }
      } else {
        return typeof complete === "function" ? complete({
          error: {
            message: this.getErrorMessageFromStatus(xhr.status),
            status: xhr.status
          }
        }) : void 0;
      }
    },

    /*
      * Get response header from an xhr object and corresponding to the given property
      * @param <json> xhr
      * @param <string> property
      * @return <json>
     */
    _getResponseHeader: function(xhr, property) {
      var data;
      data = xhr.getResponseHeader(property);
      if (Uju.isString(data)) {
        data = JSON.parse(data);
      } else {
        data = {};
      }
      return data;
    }
  };

}).call(this);
