// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1;

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.UserInfo = (_ref1 = scope.NumSync.UserInfo) != null ? _ref1 : {};

  scope.NumSync.UserInfo.contract = {
    getUserData: function() {},
    setUserData: function() {},
    getUser: function() {},
    saveUser: function() {},
    deleteUser: function() {},
    setLanguage: function() {},
    setOffline: function() {}
  };

  scope.NumSync.UserInfo.impl = {
    AESkey: "731602E271A509B4B1C8DED7121AE2EC3BAD2F3A70137B7372549CD21A45DA55",
    h_CS: null,
    h_BS: null,
    hFS: null,
    hFM: null,
    i18n: null,
    getComponentName: function() {
      return 'UserInfo';
    },
    configure: function(hub, configuration) {
      this.hub = hub;
      this.hub.requireService({
        component: this,
        contract: scope.CryptoService.CipherService,
        field: "h_CS"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.BrowserStorage.contract,
        field: "h_BS"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.FileSystem.contract,
        field: "hFS",
        optional: true
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.FileManager.contract,
        field: "hFM",
        optional: true
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
      return this.hub.provideService({
        component: this,
        contract: scope.NumSync.UserInfo.contract
      });
    },
    start: function() {},
    stop: function() {},

    /*
      * Retrieve a user from the FS based on its id or login
      * @param <string/int> id: The user id (int) or the user login (string)
      * @param <funciton> callback: Called with the searched user as first param (or null)
     */
    getUser: function(id, callback) {
      var _ref2;
      return (_ref2 = this.hFS) != null ? _ref2.readAsTextFile("users", Uju.bind(this, function(content) {
        var e, key, user, users, _i, _len;
        if (!content) {
          users = null;
        } else {
          try {
            users = JSON.parse(this._decodeAES(content));
          } catch (_error) {
            e = _error;
            users = null;
            console.warn("UserInfo :: getUser :: File 'user' is corrupted. Error: " + e);
          }
        }
        if (users != null) {
          if (Uju.isString(id)) {
            key = "login";
          } else if (Uju.isNumber(id)) {
            key = "id";
          } else {
            callback(null);
            console.warn("UserInfo :: getUser :: Param 'id' must be the user id (integer) or login (string)");
            return;
          }
          for (_i = 0, _len = users.length; _i < _len; _i++) {
            user = users[_i];
            if (user[key] === id) {
              callback(user);
              return;
            }
          }
        }
        return callback(null);
      }), function() {
        return callback(null);
      }) : void 0;
    },

    /*
      * Save a user in the FS
      * @param <json> user_: user
     */
    saveUser: function(user_) {
      var _ref2;
      return (_ref2 = this.hFS) != null ? _ref2.readAsTextFile("users", Uju.bind(this, function(content) {
        var e, existing, i, user, users, _i, _len;
        if (!content) {
          users = [];
        } else {
          try {
            users = JSON.parse(this._decodeAES(content));
          } catch (_error) {
            e = _error;
            users = [];
            console.warn("UserInfo :: saveUser :: File 'user' is corrupted, deleting it. Error: " + e);
          }
        }
        existing = false;
        for (i = _i = 0, _len = users.length; _i < _len; i = ++_i) {
          user = users[i];
          if (user_.id === user.id) {
            existing = true;
            users[i] = user_;
            break;
          }
        }
        if (!existing) {
          users.push(user_);
        }
        return this.hFS.writeText("users", this._encodeAES(JSON.stringify(users)));
      })) : void 0;
    },

    /*
      * Forget current user
      * @param <function> onComplete
     */
    deleteUser: function(onComplete) {
      var id, _ref2;
      id = this.getUserData().id;
      return (_ref2 = this.hFS) != null ? _ref2.readAsTextFile("users", Uju.bind(this, function(content) {
        var e, i, toDelete, user, users, _i, _len;
        if (!content) {
          users = [];
        } else {
          try {
            users = JSON.parse(this._decodeAES(content));
          } catch (_error) {
            e = _error;
            users = [];
            console.warn("UserInfo :: deleteUser :: File 'user' is corrupted, deleting it. Error: " + e);
          }
        }
        toDelete = null;
        for (i = _i = 0, _len = users.length; _i < _len; i = ++_i) {
          user = users[i];
          if (id === user.id) {
            toDelete = i;
            break;
          }
        }
        if (toDelete != null) {
          users.splice(toDelete, 1);
        }
        return async.parallel([
          Uju.bind(this, function(callback) {
            return this.hFS.writeText("users", this._encodeAES(JSON.stringify(users)), Uju.bind(this, function() {
              return callback(null);
            }), Uju.bind(this, function() {
              return callback("signout_error");
            }));
          }), Uju.bind(this, function(callback) {
            return this.hFM.delUserData(id, {
              onSuccess: Uju.bind(this, function() {
                return callback(null);
              }),
              onError: Uju.bind(this, function() {
                return callback("signout_error");
              })
            });
          })
        ], Uju.bind(this, function(error, results) {
          if (error != null) {
            return enyo.Signals.send("showModal", {
              clean: false,
              modal: {
                kind: "NumSync.Notification",
                type: NumSync.Notification.types.ERROR,
                message: this.i18n.getTranslation(error)
              }
            });
          } else {
            return onComplete();
          }
        }));
      })) : void 0;
    },
    setLanguage: function(language) {
      this.h_BS.set("language", language);
      return this.getUser(this.getUserData().id, Uju.bind(this, function(user) {
        user.language = language;
        return this.saveUser(user);
      }));
    },
    setOffline: function(value) {
      this.h_BS.set("offline", value);
      return this.getUser(this.getUserData().id, Uju.bind(this, function(user) {
        user.offline = value;
        return this.saveUser(user);
      }));
    },
    getUserData: function() {
      var data, error;
      data = this.h_BS.get("user");
      if (data != null) {
        data = this._decodeAES(data);
        try {
          data = JSON.parse(data);
        } catch (_error) {
          error = _error;
          console.warn("UserInfo :: getUserData :: Can't parse JSON: " + error);
          return null;
        }
        return data;
      }
      return null;
    },
    setUserData: function(data) {
      return this.h_BS.set("user", this._encodeAES(JSON.stringify(data)));
    },
    _encodeAES: function(content) {
      return this.h_CS.encode(content, this.AESkey, "");
    },
    _decodeAES: function(content) {
      return this.h_CS.decode(content, this.AESkey, "");
    }
  };

}).call(this);
