(function() {
  var scope, _ref;

  scope = typeof window !== "undefined" && window !== null ? window : this;

  /**
      @namespace ContextDetector
  */


  scope.ContextDetector = (_ref = scope.ContextDetector) != null ? _ref : {};

  /**
      @class ContextDetector.contract
  */


  scope.ContextDetector.contract = {
    /**
      @function
      @memberOf ContextDetector.contract
      @return {boolean}
    */

    isHybrid: function() {},
    /**
      @function
      @memberOf ContextDetector.contract
      @return {boolean}
    */

    isFromLocal: function() {},
    /**
      @function
      @memberOf ContextDetector.contract
      @return {boolean}
    */

    isFromHttp: function() {},
    /**
      @function
      @memberOf ContextDetector.contract
      @return {boolean}
    */

    isMobileBrowser: function() {},
    /**
      @function
      @memberOf ContextDetector.contract
      @return {boolean}
    */

    isDesktopBrowser: function() {},
    /**
      @function
      @memberOf ContextDetector.contract
      @return {boolean}
    */

    isAndroid: function() {},
    /**
      @function
      @memberOf ContextDetector.contract
      @return {boolean}
    */

    isIos: function() {
      /**
        @function
        @memberOf ContextDetector.contract
        @return {object}
      */

    },
    getPlatform: function() {}
  };

}).call(this);
;
;
(function() {
  var scope, _ref, _ref1;

  scope = typeof window !== "undefined" && window !== null ? window : this;

  /**
      @namespace ContextDetector
  */


  scope.ContextDetector = (_ref = scope.ContextDetector) != null ? _ref : {};

  /**
      @namespace ContextDetector.impls
  */


  scope.ContextDetector.impls = (_ref1 = scope.ContextDetector.impls) != null ? _ref1 : {};

  /**
      @class ContextDetector.impls.dfl
  */


  scope.ContextDetector.impls.locagent = (function() {

    function locagent() {}

    /**
      @memberOf ContextDetector.impls.dfl
      @field
      @private
      @type {HUBU.Hub}
    */


    locagent.prototype._hub = null;

    /**
      @memberOf ContextDetector.impls.dfl
      @field
      @private
      @type {object}
    */


    locagent.prototype._regexp = {
      /**
        /iPhone|iPod|iPad|Android|BlackBerry/
        @memberOf ContextDetector.impls.dfl
        @field
        @private
        @type {regexp}
      */

      mobileUserAgent: /iPhone|iPod|iPad|Android|BlackBerry/,
      /**
        /iPhone|iPod|iPad/
        @memberOf ContextDetector.impls.dfl
        @field
        @private
        @type {regexp}
      */

      ios: /iPhone|iPod|iPad/,
      /**
        /Android/
        @memberOf ContextDetector.impls.dfl
        @field
        @private
        @type {regexp}
      */

      android: /Android/,
      /**
        /^file:\/\//
        @memberOf ContextDetector.impls.dfl
        @field
        @private
        @type {regexp}
      */

      file: /^file:\/\//,
      /**
        /^http:\/\//
        @memberOf ContextDetector.impls.dfl
        @field
        @private
        @type {regexp}
      */

      http: /^http:\/\//
    };

    /**
      @memberOf ContextDetector.impls.dfl
      @field
      @private
      @type {object}
    */


    locagent.prototype._platform = null;

    /**
      H-ubu component implementation.
      @memberOf ContextDetector.impls.dfl
      @function
      @return {string} "ContextDetector"
    */


    locagent.prototype.getComponentName = function() {
      return "ContextDetector";
    };

    locagent.prototype.configure = function(inHub, inConfig) {
      var context, name, obj, result, v, _i, _len, _ref2, _ref3;
      this._hub = inHub;
      this._hub.provideService({
        component: this,
        contract: scope.ContextDetector.contract
      });
      this._platform = {};
      _ref2 = this._platforms;
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        context = _ref2[_i];
        result = context.regex.exec(navigator.userAgent);
        if (result) {
          if (context.forceVersion != null) {
            v = context.forceVersion;
          } else {
            v = Number(result[1]);
          }
          this._platform[context.platform] = v;
          if (context.extra != null) {
            _ref3 = context.extra;
            for (name in _ref3) {
              obj = _ref3[name];
              this._platform[name] = obj;
            }
          }
        }
      }
    };

    /**
      H-ubu component implementation.
      @memberOf ContextDetector.impls.dfl
      @function
    */


    locagent.prototype.start = function() {};

    /**
      H-ubu component implementation.
      @memberOf ContextDetector.impls.dfl
      @function
    */


    locagent.prototype.stop = function() {};

    /**
      @memberOf ContextDetector.impls.dfl
      @function
    */


    locagent.prototype.isHybrid = function() {
      return this.isFromLocal() && this.isMobileBrowser();
    };

    /**
      @memberOf ContextDetector.impls.dfl
      @function
    */


    locagent.prototype.isFromLocal = function() {
      return this._regexp.file.test(window.location);
    };

    /**
      @memberOf ContextDetector.impls.dfl
      @function
    */


    locagent.prototype.isFromHttp = function() {
      return this._regexp.http.test(window.location);
    };

    /**
      @memberOf ContextDetector.impls.dfl
      @function
    */


    locagent.prototype.isMobileBrowser = function() {
      return this._regexp.mobileUserAgent.test(navigator.userAgent);
    };

    /**
      @memberOf ContextDetector.impls.dfl
      @function
    */


    locagent.prototype.isDesktopBrowser = function() {
      return !this.isMobileBrowser();
    };

    /**
      @memberOf ContextDetector.impls.dfl
      @function
    */


    locagent.prototype.isAndroid = function() {
      return this._regexp.android.test(navigator.userAgent);
    };

    /**
      @memberOf ContextDetector.impls.dfl
      @function
    */


    locagent.prototype.isIos = function() {
      return this._regexp.ios.test(navigator.userAgent);
    };

    locagent.prototype.getPlatform = function() {
      return this._platform;
    };

    locagent.prototype._platforms = [
      {
        platform: "androidChrome",
        regex: /Android .* Chrome\/(\d+)[.\d]+/
      }, {
        platform: "android",
        regex: /Android (\d+)/
      }, {
        platform: "android",
        regex: /Silk\/1./,
        forceVersion: 2,
        extra: {
          silk: 1
        }
      }, {
        platform: "android",
        regex: /Silk\/2./,
        forceVersion: 4,
        extra: {
          silk: 2
        }
      }, {
        platform: "windowsPhone",
        regex: /Windows Phone (?:OS )?(\d+)[.\d]+/
      }, {
        platform: "ie",
        regex: /MSIE (\d+)/
      }, {
        platform: "ios",
        regex: /iP(?:hone|ad;(?: U;)? CPU) OS (\d+)/
      }, {
        platform: "webos",
        regex: /(?:web|hpw)OS\/(\d+)/
      }, {
        platform: "safari",
        regex: /Version\/(\d+)[.\d]+\s+Safari/
      }, {
        platform: "chrome",
        regex: /Chrome\/(\d+)[.\d]+/
      }, {
        platform: "androidFirefox",
        regex: /Android;.*Firefox\/(\d+)/
      }, {
        platform: "firefoxOS",
        regex: /Mobile;.*Firefox\/(\d+)/
      }, {
        platform: "firefox",
        regex: /Firefox\/(\d+)/
      }, {
        platform: "blackberry",
        regex: /BB1\d;.*Version\/(\d+\.\d+)/
      }
    ];

    return locagent;

  })();

}).call(this);
;
