(function() {
  var scope, _ref, _ref1;

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.Ubidreams = (_ref = scope.Ubidreams) != null ? _ref : {};

  scope.Ubidreams.FileSystem = (_ref1 = scope.Ubidreams.FileSystem) != null ? _ref1 : {};

  scope.Ubidreams.FileSystem.contract = {
    getFileEntry: function(inFileName, onSuccess, onFail, create) {},
    getDirectoryEntry: function(inDirectoryName, onSuccess, onFail) {},
    getDirectoryEntries: function(inDirectoryName, onSuccess, onFail) {},
    getRootEntries: function(onSuccess, onFail) {},
    removeFile: function(inFileName, onSuccess, onFail) {},
    removeDirectory: function(inDirectoryName, onSuccess, onFail) {},
    readAsTextFile: function(inFileName, onSuccess, onFail) {},
    readAsJsonFile: function(inFileName, onSuccess, onFail) {},
    writeText: function(inFileName, data, onSuccess, onFail) {},
    appendText: function(inFileName, data, onSuccess, onFail) {},
    readFileIfExists: function(inFileName, inParams) {},
    readAsBinaryFile: function(inFileName, onSuccess, onFail) {},
    downloadFile: function(uri, path, opts) {},
    uploadFile: function(url, fileFullPath, opts) {}
  };

}).call(this);
;
;
(function() {
  var scope, _ref, _ref1, _ref2;

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.Ubidreams = (_ref = scope.Ubidreams) != null ? _ref : {};

  scope.Ubidreams.FileSystem = (_ref1 = scope.Ubidreams.FileSystem) != null ? _ref1 : {};

  scope.Ubidreams.FileSystem.impls = (_ref2 = scope.Ubidreams.FileSystem.impls) != null ? _ref2 : {};

  scope.Ubidreams.FileSystem.impls.cordova = {
    /* LOCAL ATTRIBUTES
    */

    hub: null,
    fs: null,
    dir_root: null,
    baseDirectory: null,
    readyFunction: null,
    /* HUBU COMPONENT CONTRACT IMPLEMENTATION
    */

    getComponentName: function() {
      return "FileSystem";
    },
    configure: function(hub, configuration) {
      this.hub = hub;
      if (!((configuration != null ? configuration.baseDirectory : void 0) == null)) {
        this.baseDirectory = configuration.baseDirectory;
      }
      if (!((configuration != null ? configuration.readyFunction : void 0) == null)) {
        this.readyFunction = configuration.readyFunction;
      }
    },
    start: function() {
      window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, Uju.bind(this, this._fsRetrieved), Uju.bind(this, this._errorHandler));
    },
    stop: function() {},
    /* CONTRACT IMPLEMENTATION
    */

    /*
      # Get a file reference. Create the file if it doesn't exist
      # inFileName: <String> File name with relative or absolute path. The parent directories MUST exist
      # onSuccess: <Function> Success callback
      # onFail: <Function> Error callback
      # create: <Boolean> If true, the file will be created if it doesn't exist. Default: true
    */

    getFileEntry: function(inFileName, onSuccess, onFail, create) {
      var createFile, root_dir, tryCreateDir;
      if (create == null) {
        create = true;
      }
      if (onFail == null) {
        onFail = this._errorHandler;
      }
      root_dir = this.dir_root;
      tryCreateDir = Uju.bind(this, function() {
        var path;
        path = inFileName.split("/");
        if (path.length > 1) {
          path.pop();
          return this.getDirectoryEntry(path.join("/"), function() {
            return createFile(false);
          }, onFail);
        } else {
          return onFail("Can't get file");
        }
      });
      createFile = function(tryDir) {
        return root_dir.getFile(inFileName, {
          create: create,
          exclusive: false
        }, function(entry) {
          return onSuccess(entry);
        }, tryDir ? tryCreateDir : onFail);
      };
      return createFile(true);
    },
    /*
      # Remove a file
      # inFileName: <String> File name with relative or absolute path
      # onSuccess: <Function> Success callback
      # onFail: <Function> Error callback
    */

    removeFile: function(inFileName, onSuccess, onFail) {
      onFail = onFail != null ? onFail : this._errorHandler;
      return this.getFileEntry(inFileName, function(entry) {
        return entry.remove(onSuccess, onFail);
      }, onFail);
    },
    /*
      # Get a directory reference. Create the directory if it doesn't exist
      # inDirectoryName: <String> Directory name with relative or absolute path.
      # onSuccess: <Function> Success callback
      # onFail: <Function> Error callback
    */

    getDirectoryEntry: function(inDirectoryName, onSuccess, onFail) {
      var createDir, path, root, success;
      path = inDirectoryName.split("/").reverse();
      root = this.dir_root;
      if (onFail == null) {
        onFail = this._errorHandler;
      }
      createDir = function(dir) {
        return root.getDirectory(dir, {
          create: true,
          exclusive: false
        }, success, onFail);
      };
      success = function(entry) {
        root = entry;
        if (path.length > 0) {
          return createDir(path.pop());
        } else {
          return onSuccess(entry);
        }
      };
      return createDir(path.pop());
    },
    /*
      # Remove a directory
      # inDirectoryName: <String> Directory name with relative or absolute path
      # onSuccess: <Function> Success callback
      # onFail: <Function> Error callback
    */

    removeDirectory: function(inDirectoryName, onSuccess, onFail) {
      onFail = onFail != null ? onFail : this._errorHandler;
      return this.getDirectoryEntry(inDirectoryName, function(entry) {
        return entry.removeRecursively(onSuccess, onFail);
      }, onFail);
    },
    /*
      # Reads a file as binary
      # inFileName: <String> File name with relative or absolute path.
      # onSuccess: <Function> Success callback
      # onFail: <Function> Error callback
    */

    readAsBinaryFile: function(inFileName, onSuccess, onFail) {
      onFail = onFail != null ? onFail : this._errorHandler;
      return this.getFileEntry(inFileName, function(entry) {
        entry.file(function(file) {
          var reader;
          reader = new FileReader();
          reader.onerror = onFail;
          reader.onabort = onFail;
          reader.onloadend = function(e) {
            return onSuccess(file, e.target.result);
          };
          return reader.readAsBinaryString(file);
        });
        return onFail;
      });
    },
    /*
      # Reads a file as text
      # inFileName: <String> File name with relative or absolute path.
      # onSuccess: <Function> Success callback
      # onFail: <Function> Error callback
    */

    readAsTextFile: function(inFileName, onSuccess, onFail) {
      onFail = onFail != null ? onFail : this._errorHandler;
      return this.getFileEntry(inFileName, function(entry) {
        entry.file(function(file) {
          var reader;
          reader = new FileReader();
          reader.onerror = onFail;
          reader.onabort = onFail;
          reader.onloadend = function(e) {
            return onSuccess(e.target.result, file);
          };
          return reader.readAsText(file);
        });
        return onFail;
      });
    },
    /*
      # Reads a file as json
      # inFileName: <String> File name with relative or absolute path.
      # inParams:
      #   onSuccess: <Function> Success callback
      #   onFail: <Function> Error callback
      #   failIfUndefined: <boolean> default true
    */

    readAsJsonFile: function(inFileName, inParams) {
      var _ref3, _ref4;
      if (inParams == null) {
        inParams = {};
      }
      if ((_ref3 = inParams.onFail) == null) {
        inParams.onFail = this._errorHandler;
      }
      if ((_ref4 = inParams.failIfUndefined) == null) {
        inParams.failIfUndefined = false;
      }
      return this.getFileEntry(inFileName, function(entry) {
        return entry.file(function(file) {
          var reader;
          reader = new FileReader();
          reader.onerror = inParams.onFail;
          reader.onabort = inParams.onFail;
          reader.onloadend = function(e) {
            var content, error, result;
            try {
              content = e.target.result;
              if (content) {
                result = JSON.parse(content);
              } else {
                if (inParams.failIfUndefined) {
                  throw "File is empty";
                } else {
                  result = null;
                }
              }
            } catch (err) {
              error = "FileSystem :: readAsJsonFile : Can't parse text to JSON: " + err;
            }
            if (error == null) {
              return typeof inParams.onSuccess === "function" ? inParams.onSuccess(result) : void 0;
            } else {
              return inParams.onFail(error);
            }
          };
          return reader.readAsText(file);
        });
      }, inParams.onFail);
    },
    /*
      # Reads a file as json or text and call an error callback if the file doesn't exist
      # inFileName: <String> File name with relative or absolute path
      # inParams: {
      #   onSuccess: <Function> Success callback
      #   onFail: <Function> Error callback
      #   json: <Boolean> If true, type is asked as json, else it's text
      # }
    */

    readFileIfExists: function(inFileName, inParams) {
      var onFail, _ref3;
      onFail = (_ref3 = inParams.onError) != null ? _ref3 : function() {
        return console.error("FileSystem :: readFileIfExists: Couldn't read file '" + inFileName + "'.");
      };
      return this.getFileEntry(inFileName, Uju.bind(this, function(entry) {
        var reader;
        reader = new FileReader();
        reader.onerror = onFail;
        reader.onabort = onFail;
        reader.onloadend = function(e) {
          var error, result;
          result = e.target.result;
          if (result != null) {
            if (inParams.json === true) {
              try {
                result = JSON.parse(e.target.result);
              } catch (err) {
                error = "FileSystem :: readAsJsonFile : Can't parse text to JSON: " + err;
              }
            }
            if (error != null) {
              onFail();
              return console.warn(error);
            } else {
              return inParams.onSuccess(result);
            }
          } else {
            return onFail();
          }
        };
        return reader.readAsText(entry);
      }), onFail, false);
    },
    /*
      # Open or create a file and writes in it
      # inFileName: <String> File name with relative or absolute path
      # data: <Blob> data to write.
      # onSuccess: <Function> Success callback
      # onFail: <Function> Error callback
    */

    writeText: function(inFileName, data, onSuccess, onFail) {
      onFail = onFail != null ? onFail : this._errorHandler;
      return this.getFileEntry(inFileName, function(entry) {
        return entry.createWriter(function(writer) {
          if (!(onSuccess == null)) {
            writer.onwriteend = onSuccess;
          }
          writer.onerror = onFail;
          return writer.write(Uju.isString(data) ? data : String(data));
        }, onFail);
      }, onFail);
    },
    /*
      # Open or create a file and writes at the end of it
      # inFileName: <String> File name with relative or absolute path
      # data: <String> data to write.
      # onSuccess: <Function> Success callback
      # onFail: <Function> Error callback
    */

    appendText: function(inFileName, data, onSuccess, onFail) {
      onFail = onFail != null ? onFail : this._errorHandler;
      return this.getFileEntry(inFileName, function(entry) {
        return entry.createWriter(function(writer) {
          if (!(onSuccess == null)) {
            writer.onwrite = onSuccess;
          }
          writer.onerror = onFail;
          writer.seek(writer.length);
          return writer.write(data);
        }, onFail);
      }, this._errorHandler);
    },
    /*
      # Get the list of entries of a directory
      # inDirectoryName: <String> Directory name with relative or absolute path
      # onSuccess: <Function> Success callback
      # onFail: <Function> Error callback
    */

    getDirectoryEntries: function(inDirectoryName, onSuccess, onFail) {
      if (onFail == null) {
        onFail = this._errorHandler;
      }
      return this.dir_root.getDirectory(inDirectoryName, {
        create: false
      }, Uju.bind(this, function(dirEntry) {
        var directoryReader;
        directoryReader = dirEntry.createReader();
        return directoryReader.readEntries(onSuccess, onFail);
      }), onFail);
    },
    /*
      # Get the list of entries of the vase directory
      # inDirectoryName: <String> Directory name with relative or absolute path
      # onSuccess: <Function> Success callback
      # onFail: <Function> Error callback
    */

    getRootEntries: function(onSuccess, onFail) {
      var directoryReader;
      if (onFail == null) {
        onFail = this._errorHandler;
      }
      directoryReader = this.dir_root.createReader();
      return directoryReader.readEntries(onSuccess, onFail);
    },
    /*
      * Download file and save it to the file system
      * @param <string> uri
      * @param <string> path
      * @param <json> opts = {
      *   <boolean> disableSecurity
      *   <function> onProgress(abort, event)
      *   <function> onSuccess(entry)
      *   <function> onFail(error)
      * }
      * @return <function> abort
    */

    downloadFile: function(uri, path, opts) {
      var fileTransfer, onAbort, _ref3;
      if ((_ref3 = opts.onFail) == null) {
        opts.onFail = this._errorHandler;
      }
      fileTransfer = new FileTransfer();
      onAbort = Uju.bind(this, function() {
        this.removeFile(path);
        return fileTransfer.abort();
      });
      if (opts.onProgress != null) {
        fileTransfer.onprogress = Uju.bind(this, function(progressEvent) {
          return opts.onProgress(progressEvent, Uju.bind(fileTransfer, onAbort));
        });
      }
      this.getFileEntry(path, Uju.bind(this, function(fileEntry) {
        return fileTransfer.download(this._encodeURI(uri), fileEntry.fullPath, opts.onSuccess, opts.onFail, opts.disableSecurity || false, {
          headers: opts.headers || {}
        });
      }));
      return Uju.bind(fileTransfer, onAbort);
    },
    /*
      * Upload a file
      * @param <string> url : url to upload to
      * @param <string> fileFullPath : full path retreived from a FileEntry
      * @param <json> opts : callbacks and options to pass to the cordova FileUploadOptions instance
      * @return <function> abort
    */

    uploadFile: function(url, fileFullPath, opts) {
      console.log("uploadFile: ", arguments);
      var ft, options, _ref3, _ref4, _ref5;
      if (opts == null) {
        opts = {};
      }
      if ((_ref3 = opts.onError) == null) {
        opts.onError = this._errorHandler;
      }
      options = new FileUploadOptions();
      if (opts.fileKey != null) {
        options.fileKey = opts.fileKey;
      }
      if (opts.fileName != null) {
        options.fileName = opts.fileName;
      }
      if (opts.mimeType != null) {
        options.mimeType = opts.mimeType;
      }
      if (opts.params != null) {
        options.params = opts.params;
      }
      if (opts.chunkedMode != null) {
        options.chunkedMode = opts.chunkedMode;
      }
      if (opts.httpMethod != null) {
        options.httpMethod = opts.httpMethod;
      }
      options.headers = (_ref4 = opts.headers) != null ? _ref4 : {};
      options.headers.Connection = "close";
      ft = new FileTransfer();
      ft.onprogress = Uju.bind(this, function(progressEvent) {
        if (opts.onProgress != null) {
          return opts.onProgress(progressEvent, ft.abort);
        }
      });
      error_handler = function(error) {console.error(error); opts.onError(error);};
      ft.upload(fileFullPath, this._encodeURI(url), opts.onSuccess, error_handler, options, (_ref5 = opts.trustAllHosts) != null ? _ref5 : false);
      return ft.abort;
    },
    _encodeURI: function(uri) {
      var i, item, newURL, splittedURL, _i, _len;
      newURL = "";
      splittedURL = uri.split("/");
      for (i = _i = 0, _len = splittedURL.length; _i < _len; i = ++_i) {
        item = splittedURL[i];
        if (i === 0) {
          newURL += item;
        } else {
          newURL += "/";
          newURL += encodeURIComponent(item);
        }
      }
      return newURL;
    },
    _fsRetrieved: function(inFilesystem) {
      var fsReady;
      fsReady = Uju.bind(this, function() {
        this.hub.provideService({
          component: this,
          contract: scope.Ubidreams.FileSystem.contract
        });
        this.hub.publish(this, "FileSystem/ready", {});
        if (this.readyFunction != null) {
          return this.readyFunction();
        } else {
          return console.warn("FileSystem :: _fsRetrieved :: FS is ready but no ready function passed in configuration");
        }
      });
      this.fs = inFilesystem;
      this.dir_root = this.fs.root;
      if (this.baseDirectory != null) {
        return this.dir_root.getDirectory(this.baseDirectory, {
          create: true,
          exclusive: false
        }, Uju.bind(this, function(dir) {
          this.dir_root = dir;
          return fsReady();
        }), Uju.bind(this, function(e) {
          alert("An unknown error occured with the file system. Offline mode may not work correctly.");
          return this._errorHandler(e);
        }));
      } else {
        return fsReady();
      }
    },
    _errorHandler: function(e) {
      if (Uju.isString(e)) {
        return console.error("FillSystem :: " + e);
      } else {
        switch (e.code) {
          case FileError.NOT_FOUND_ERR:
            return console.error("NOT_FOUND_ERR");
          case FileError.SECURITY_ERR:
            return console.error("SECURITY_ERR");
          case FileError.ABORT_ERR:
            return console.error("ABORT_ERR");
          case FileError.NOT_READABLE_ERR:
            return console.error("NOT_READABLE_ERR");
          case FileError.ENCODING_ERR:
            return console.error("ENCODING_ERR");
          case FileError.NO_MODIFICATION_ALLOWED_ERR:
            return console.error("NO_MODIFICATION_ALLOWED_ERR");
          case FileError.INVALID_STATE_ERR:
            return console.error("INVALID_STATE_ERR");
          case FileError.SYNTAX_ERR:
            return console.error("SYNTAX_ERR");
          case FileError.INVALID_MODIFICATION_ERR:
            return console.error("INVALID_MODIFICATION_ERR");
          case FileError.QUOTA_EXCEEDED_ERR:
            return console.error("QUOTA_EXCEEDED_ERR");
          case FileError.TYPE_MISMATCH_ERR:
            return console.error("TYPE_MISMATCH_ERR");
          case FileError.PATH_EXISTS_ERR:
            return console.error("PATH_EXISTS_ERR");
          default:
            return console.error("FileSystem :: Unknown Error");
        }
      }
    }
  };

}).call(this);
;
