(function(){var a,c,f;a="undefined"!==typeof window&&null!==window?window:this;a.FireStarter=null!=(c=a.FireStarter)?c:{};a.FireStarter.impls=null!=(f=a.FireStarter.impls)?f:{};a.FireStarter.impls.dfl={_hub:null,_logger:null,ctx:null,secs:null,startFunction:null,onSecurityFailed:null,getComponentName:function(){return"FireStarter"},configure:function(d,b){this._hub=d;this._logger=new a.Logger(this.getComponentName());null!=a.ContextDetector&&this._hub.requireService({component:this,contract:a.ContextDetector.contract,
field:"ctx"});null!=a.GateKeeper&&this._hub.requireService({component:this,contract:a.GateKeeper.contract,field:"secs",aggregate:!0});if(null!=(null!=b?b.startFunction:void 0))this.startFunction=b.startFunction;if(null!=(null!=b?b.onSecurityFailed:void 0))this.onSecurityFailed=b.onSecurityFailed},start:function(){var a;null==this.ctx?this._logger.error(""+this.getComponentName()+" unable to start : ContextDetector namespace not declared"):(this.startFunction=null!=(a=this.startFunction)?a:this._defaultStart,
this._startRoutine())},stop:function(){},_startRoutine:function(){var d,b;this.ctx.isHybrid()?document.addEventListener("deviceready",function(){return a.FireStarter.impls.dfl._securityCheckBeforeBoot()},!1):document.body.onload=function(){return a.FireStarter.impls.dfl._securityCheckBeforeBoot()};this.ctx.isHybrid()&&(d=document.getElementsByTagName("head")[0],b=document.createElement("script"),b.type="text/javascript",b.src="cordova.js",d.appendChild(b))},_defaultStart:function(){return this._logger.log("Firestarter default start method => Application booted")},
_securityCheckBeforeBoot:function(){var a,b,c,e;if(null==this.secs)this._logger.warn(""+this.getComponentName()+" no security applied : no GateKeeper service found");else{e=this.secs;b=0;for(c=e.length;b<c;b++)if(a=e[b],!a.isValid()){this._logger.error(""+this.getComponentName()+" one security policy not validated, /!\\ aborting boot /!\\");if(null!=this.onSecurityFailed)this.onSecurityFailed(a.__proxy__.getComponentName());return}}return this.startFunction()}}}).call(this);;
(function() {
  var scope, _ref, _ref1;

  scope = typeof window !== "undefined" && window !== null ? window : this;

  /**
      @namespace FireStarter
  */


  scope.FireStarter = (_ref = scope.FireStarter) != null ? _ref : {};

  /**
      @namespace FireStarter.impls
  */


  scope.FireStarter.impls = (_ref1 = scope.FireStarter.impls) != null ? _ref1 : {};

  /**
      <b>FireStarter</b> handles application boot logic :
      <ul>
        <li>cordova-*.js import in Hybrid context ;</li>
        <li>startup function registering on appropriate event.</li>
      </ul>
      <i>Example</i> : <br/>
      <pre><code>
      kickstarter = new HUBU.Hub().configure(null, { component_name : "starter" });
      kickstarter
              .registerComponent(new ContextDetector.impls.dfl())
              .registerComponent(new FireStarter.impls.dfl(), {
                  startFunction: <b>yourFunction</b>
              })
              .start();
       <pre></code>
      @class FireStarter.impls.dfl
  */


  scope.FireStarter.impls.dfl = {
    /**
      @memberOf FireStarter.impls.dfl
      @field
      @private
      @type {HUBU.Hub}
    */

    _hub: null,
    /**
      @memberOf FireStarter.impls.dfl
      @field
      @private
      @type {Logger}
    */

    _logger: null,
    /**
      <b>{ContextDetector}</b> service injection.
      @memberOf FireStarter.impls.dfl
      @field
      @private
      @type {ContextDetector}
    */

    ctx: null,
    /**
    <b>{GateKeeper}</b> services injection.
    @memberOf FireStarter.impls.dfl
    @field
    @private
    @type {GateKeeper}
    */

    secs: null,
    /**
      Callback function called when the application is ready. Depending on the context (Hybrid / Web) this function is
      registered on <b>body.onload</b> or on <b>document.deviceready</b>.
      @memberOf FireStarter.impls.dfl
      @function
      @private
      @return {null}
    */

    startFunction: null,
    onSecurityFailed: null,
    /**
      H-ubu component implementation.
      @memberOf FireStarter.impls.dfl
      @function
      @return {string} "FireStarter"
    */

    getComponentName: function() {
      return "FireStarter";
    },
    /**
      H-ubu component implementation.<br/>
      Start function should be passed in <b>inConfig</b> parameter as <b>startFunction</b> field. It is registered to
      the correct event (body.onload or document.deviceready) depending on the context.
      @memberOf FireStarter.impls.dfl
      @function
      @param {HUBU.Hub} inHub Hub where this component is plugged
      @param {object} inConfig Component configuration
      @param {function} inConfig.startFunction Function to call when the application is fully initialized
    */

    configure: function(inHub, inConfig) {
      this._hub = inHub;
      this._logger = new scope.Logger(this.getComponentName());
      if (scope.ContextDetector != null) {
        this._hub.requireService({
          component: this,
          contract: scope.ContextDetector.contract,
          field: "ctx"
        });
      }
      if (scope.GateKeeper != null) {
        this._hub.requireService({
          component: this,
          contract: scope.GateKeeper.contract,
          field: "secs",
          aggregate: true
        });
      }
      if ((inConfig != null ? inConfig.startFunction : void 0) != null) {
        this.startFunction = inConfig.startFunction;
      }
      if ((inConfig != null ? inConfig.onSecurityFailed : void 0) != null) {
        this.onSecurityFailed = inConfig.onSecurityFailed;
      }
    },
    /**
      H-ubu component implementation.
      @memberOf FireStarter.impls.dfl
      @function
    */

    start: function() {
      var _ref2;
      if (this.ctx == null) {
        this._logger.error("" + (this.getComponentName()) + " unable to start : ContextDetector namespace not declared");
        return;
      }
      this.startFunction = (_ref2 = this.startFunction) != null ? _ref2 : this._defaultStart;
      this._startRoutine();
    },
    /**
      H-ubu component implementation.
      @memberOf FireStarter.impls.dfl
      @function
    */

    stop: function() {},
    /**git@gitlab.ugit@gitlab.ubidreams.com:ubihcomponents/firestarter.gitbidreams.com:ubihcomponents/firestarter.git
      @memberOf FireStarter.impls.dfl
      @function
      @private
    */

    _startRoutine: function() {
      var head, script,
        _this = this;
      if (this.ctx.isHybrid()) {
        document.addEventListener("deviceready", function() {
          return scope.FireStarter.impls.dfl._securityCheckBeforeBoot();
        }, false);
      } else {
        document.body.onload = function() {
          return scope.FireStarter.impls.dfl._securityCheckBeforeBoot();
        };
      }
      if (this.ctx.isHybrid()) {
        head = document.getElementsByTagName("head")[0];
        script = document.createElement('script');
        script.type = 'text/javascript';
        script.src = 'cordova.js';
        head.appendChild(script);
      }
    },
    _defaultStart: function() {
      return this._logger.log("Firestarter default start method => Application booted");
    },
    _securityCheckBeforeBoot: function() {
      var sec, _i, _len, _ref2;
      if (this.secs == null) {
        this._logger.warn("" + (this.getComponentName()) + " no security applied : no GateKeeper service found");
      } else {
        _ref2 = this.secs;
        for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
          sec = _ref2[_i];
          if (!sec.isValid()) {
            this._logger.error("" + (this.getComponentName()) + " one security policy not validated, /!\\ aborting boot /!\\");
            if (this.onSecurityFailed != null) {
              this.onSecurityFailed(sec.__proxy__.getComponentName());
            }
            return;
          }
        }
      }
      return this.startFunction();
    }
  };

}).call(this);
;
