// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.Account = (_ref1 = scope.NumSync.Account) != null ? _ref1 : {};

  scope.NumSync.Account.contract = {};

  scope.NumSync.Account.impl = (function(_super) {
    __extends(impl, _super);

    impl.prototype.h_Main = null;

    impl.prototype.hUser = null;

    impl.prototype.hCW = null;

    impl.prototype.hMain = null;

    function impl() {
      impl.__super__.constructor.call(this);
      this.ui = "NumSync.Account.ui";
      this.hBS = void 0;
      this.i18n = void 0;
      return;
    }

    impl.prototype.configure = function(hub, configuration) {
      impl.__super__.configure.call(this, hub, configuration);
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.BrowserStorage.contract,
        field: "hBS"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.UserInfo.contract,
        field: "hUser"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.ConnectivityWatcher.contract,
        field: "hCW"
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.Main.contract,
        field: "hMain"
      });
      this.hub.subscribe(this, "ConnectivityWatcher/connection/lost", Uju.bind(this, function() {
        return this._onConnectionChange(false);
      }));
      this.hub.subscribe(this, "ConnectivityWatcher/connection/recovered", Uju.bind(this, function() {
        return this._onConnectionChange(true);
      }));
    };

    impl.prototype.start = function() {
      impl.__super__.start.call(this);
      this.widget.offline = this.hBS.get("offline") === "true" ? true : false;
      this.widget.username = this.hUser.getUserData().login;
      this.widget.language = this.i18n.getLanguage();
      this.i18n.i18nForEnyo(this.widget);
      if (this.hCW != null) {
        return this._onConnectionChange(this.hCW.hasConnection());
      } else {
        return this._onConnectionChange(true);
      }
    };


    /*
      * Triggered when connection has changed
      * @param <boolean> isOnline
     */

    impl.prototype._onConnectionChange = function(isOnline) {
      return this.widget._disableLanguage(!isOnline);
    };


    /*
      * Clear cache
      * @param <boolean> forgetMe: if true, delete user's data from FS
     */

    impl.prototype._logout = function(forgetMe) {
      if (forgetMe) {
        return this.hUser.deleteUser(Uju.bind(this, function() {
          return this.hMain.logout(true);
        }));
      } else {
        return this.hMain.logout(false);
      }
    };


    /*
      * Set offline mode
      * @param value: <boolean> true to enable
     */

    impl.prototype._setOfflineMode = function(value) {
      return this.hUser.setOffline(value);
    };


    /*
      * Set language
      * @param language: <string> "en" or "fr"
     */

    impl.prototype._setLanguage = function(language) {
      this.hUser.setLanguage(language);
      return this.i18n.setLanguage(language);
    };

    return impl;

  })(scope.Ubidreams.widgets.Abstract.impl);

  enyo.kind({
    name: "NumSync.Account.ui",
    kind: "Ubidreams.widgets.Modals",
    classes: "modals-level2 modal-account",
    swipe: true,
    start: "right",
    scrim: false,
    fullscreen: true,
    offline: false,
    language: void 0,
    username: "",
    _kind: "NumSync.Account",
    components: [
      {
        classes: "pages-header",
        components: [
          {
            name: "pushMenu",
            tag: "i",
            classes: "btn-left fa fa-bars",
            ontap: "_openMenu"
          }, {
            tag: "h1",
            i18n: [
              {
                key: "account_title"
              }
            ],
            classes: "title"
          }
        ]
      }, {
        kind: "Ubidreams.Scroller",
        top: "60px",
        components: [
          {
            classes: "info panel panel-default",
            components: [
              {
                classes: "panel-heading",
                components: [
                  {
                    tag: "i",
                    classes: "header-img fa fa-user"
                  }, {
                    name: "username",
                    tag: "h3",
                    classes: "panel-title"
                  }
                ]
              }, {
                classes: "panel-body",
                components: [
                  {
                    classes: "btn btn-default",
                    ontap: "_logout",
                    components: [
                      {
                        tag: "i",
                        classes: "fa fa-sign-out"
                      }, {
                        i18n: [
                          {
                            key: "logout"
                          }
                        ]
                      }, {
                        i18n: [
                          {
                            key: "logout_tip"
                          }
                        ]
                      }
                    ]
                  }, {
                    name: "clearAll",
                    classes: "btn btn-default",
                    ontap: "_logout",
                    components: [
                      {
                        tag: "i",
                        classes: "fa fa-trash-o"
                      }, {
                        i18n: [
                          {
                            key: "signout"
                          }
                        ]
                      }, {
                        i18n: [
                          {
                            key: "signout_tip"
                          }
                        ]
                      }
                    ]
                  }
                ]
              }
            ]
          }, {
            classes: "panel panel-default",
            components: [
              {
                classes: "panel-heading",
                components: [
                  {
                    tag: "h3",
                    classes: "panel-title",
                    i18n: [
                      {
                        key: "preferences"
                      }
                    ]
                  }
                ]
              }, {
                tag: "ul",
                classes: "list-group",
                components: [
                  {
                    tag: "li",
                    classes: "list-group-item clearfix",
                    components: [
                      {
                        classes: "pull-left",
                        i18n: [
                          {
                            key: "offline_mode"
                          }
                        ]
                      }, {
                        name: "cbOffline",
                        classes: "pull-right",
                        kind: "onyx.ToggleButton",
                        onActivate: "_offlineChanged"
                      }
                    ]
                  }, {
                    tag: "li",
                    classes: "list-group-item clearfix",
                    components: [
                      {
                        classes: "pull-left",
                        i18n: [
                          {
                            key: "language"
                          }
                        ]
                      }, {
                        name: "language",
                        kind: "NumSync.FlagCarousel",
                        classes: "pull-right",
                        onChange: "_languageChanged"
                      }
                    ]
                  }
                ]
              }
            ]
          }
        ]
      }
    ],
    rendered: function() {
      this.inherited(arguments);
      this.$.cbOffline.setValue(this.offline);
      this.$.language.setValue(this.language);
      return this.$.username.setContent(this.username);
    },
    _disableLanguage: function(disable) {
      if (disable) {
        return this.$.language.disable();
      } else {
        return this.$.language.enable();
      }
    },
    _openMenu: function(inSender, inEvent) {
      return enyo.Signals.send("showPushMenu", {});
    },
    _languageChanged: function(inSender, inEvent) {
      this._call("_setLanguage", inEvent.language);
      return enyo.Signals.send("updateHeader", {
        title: Ubidreams._i18n.get("header_cloud")
      });
    },
    _offlineChanged: function(inSender) {
      return this._call("_setOfflineMode", inSender.getValue());
    },
    _logout: function(inSender, inEvent) {
      if (confirm("Se déconnecter ?")) {
        return this._call("_logout", inSender.name === "clearAll");
      }
    }
  });

}).call(this);
