// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.CreateFolder = (_ref1 = scope.NumSync.CreateFolder) != null ? _ref1 : {};

  scope.NumSync.CreateFolder.impl = (function(_super) {
    __extends(impl, _super);

    function impl() {
      impl.__super__.constructor.call(this);
      this.ui = "NumSync.CreateFolder.ui";
      this.i18n = void 0;
      this.idCloudFolder = void 0;
      this.path = void 0;
      this.hFM = false;
      return;
    }

    impl.prototype.configure = function(hub, configuration) {
      impl.__super__.configure.call(this, hub, configuration);
      this.idCloudFolder = configuration.idCloudFolder;
      this.path = configuration.path;
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.FileManager.contract,
        field: "hFM"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
      return this.hub.subscribe(this, "app/keyboard", Uju.bind(this, this._onKeyboard));
    };

    impl.prototype.start = function() {
      impl.__super__.start.call(this);
      this.i18n.i18nForEnyo(this.widget);
    };

    impl.prototype._checkForm = function(name) {
      if (!name.length) {
        return false;
      }
      return true;
    };

    impl.prototype._sendForm = function(name) {
      var opts, path;
      opts = {
        onSuccess: Uju.bind(this, function() {
          return this.widget._creationSuccess();
        }),
        onError: Uju.bind(this.widget, this.widget._creationFailed)
      };
      if (this.idCloudFolder != null) {
        if (this.path != null) {
          path = this.path + "/" + name;
        } else {
          path = name;
        }
        return this.hFM.createFolder(this.idCloudFolder, path, opts);
      } else {
        return this.hFM.createRootFolder({
          name: name
        }, opts);
      }
    };

    impl.prototype._onKeyboard = function(event) {
      return this.widget.keyboardIsOpen(event.isOpen, event.keyboardHeight);
    };

    return impl;

  })(scope.Ubidreams.widgets.Abstract.impl);

  enyo.kind({
    name: "NumSync.CreateFolder.ui",
    kind: "Ubidreams.widgets.Modals",
    classes: "modals-level3 create-folder-modal",
    start: "bottom",
    size: "auto",
    _sending: false,
    components: [
      {
        classes: "modals-header",
        components: [
          {
            tag: "i",
            classes: "btn-right fa fa-times",
            ontap: "close"
          }, {
            classes: "title",
            i18n: [
              {
                key: "create_folder_bis"
              }
            ]
          }
        ]
      }, {
        classes: "modals-body",
        components: [
          {
            classes: "error-zone clearfix",
            name: "error",
            showing: false
          }, {
            classes: "input-group",
            components: [
              {
                name: "fName",
                kind: "enyo.Input",
                classes: "form-control",
                type: "text",
                i18n: [
                  {
                    key: "folder_name",
                    setter: "placeholder"
                  }
                ]
              }, {
                tag: "span",
                classes: "input-group-btn",
                components: [
                  {
                    classes: "btn btn-default",
                    content: "Ok",
                    ontap: "_validate"
                  }
                ]
              }
            ]
          }, {
            name: "fNameError",
            classes: "form-error",
            showing: false
          }
        ]
      }
    ],

    /*
      * Add an offset bottom for keyboard
     */
    keyboardIsOpen: function(isOpen, keyboardHeight) {
      if (isOpen) {
        return this.applyStyle("bottom", (keyboardHeight || 0) + "px");
      } else {
        return this.applyStyle("bottom", 0);
      }
    },

    /*
      * Send the form to the controller for validation
     */
    _validate: function() {
      var name, result;
      if (!this._sending) {
        name = this.$.fName.getValue();
        result = this._call("_checkForm", name);
        if (!result) {
          this.$.fNameError.destroyClientControls();
          this.$.fNameError.createComponent({
            tag: "i",
            classes: "fa fa-exclamation-triangle"
          }).render();
          this.$.fNameError.createComponent({
            tag: "span",
            content: Ubidreams._i18n.get("no_folder_name")
          }).render();
          return this.$.fNameError.show();
        } else {
          this._sending = true;
          this.$.fNameError.hide();
          return this._call("_sendForm", name);
        }
      }
    },

    /*
      * Triggered when the folder has been created
     */
    _creationSuccess: function() {
      this._sending = false;
      enyo.Signals.send("showModal", {
        clean: true,
        modal: {
          kind: "NumSync.Notification",
          type: NumSync.Notification.types.SUCCESS,
          message: Ubidreams._i18n.get("folder_created")
        }
      });
      return enyo.Signals.send("refreshFilesTree");
    },

    /*
      * Triggered when the folder failed to be created
     */
    _creationFailed: function(error) {
      this._sending = false;
      this.$.error.destroyClientControls();
      this.$.error.createComponents([
        {
          tag: "span",
          content: Ubidreams._i18n.get("create_folder_fail", [error])
        }
      ]);
      this.$.error.render();
      return this.$.error.show();
    }
  });

}).call(this);
