// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.EntryDetails = (_ref1 = scope.NumSync.EntryDetails) != null ? _ref1 : {};

  scope.NumSync.EntryDetails.contract = {};

  scope.NumSync.EntryDetails.impl = (function(_super) {
    __extends(impl, _super);

    impl.prototype.hCD = null;

    impl.prototype.hHP = null;

    impl.prototype.hFM = null;

    impl.prototype.hEH = null;

    impl.prototype.i18n = null;

    function impl() {
      impl.__super__.constructor.call(this);
      this.ui = "NumSync.EntryDetails.ui";
      this.entry = null;
    }

    impl.prototype.configure = function(hub, configuration) {
      impl.__super__.configure.call(this, hub, configuration);
      this.entry = configuration.entry;
      this.hub.requireService({
        component: this,
        contract: scope.ContextDetector.contract,
        field: "hCD"
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.HomePage.contract,
        field: "hHP"
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.FileManager.contract,
        field: "hFM"
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.EntryHelper.contract,
        field: "hEH"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.ConnectivityWatcher.contract,
        field: "hCW"
      });
      this.hub.subscribe(this, "ConnectivityWatcher/connection/lost", Uju.bind(this, function() {
        return this._onConnectionChange(false);
      }));
      return this.hub.subscribe(this, "ConnectivityWatcher/connection/recovered", Uju.bind(this, function() {
        return this._onConnectionChange(true);
      }));
    };

    impl.prototype.start = function() {
      impl.__super__.start.call(this);
      this.i18n.i18nForEnyo(this.widget);
      if (this.hCD.isIos() || this.entry.type !== NumSync.models.Entry.types.FILE) {
        this.widget.disableExport();
      }
      this.widget.setEntry(this.entry);
      if (this.hCW != null) {
        return this._onConnectionChange(this.hCW.hasConnection());
      } else {
        return this._onConnectionChange(true);
      }
    };

    impl.prototype._retrievePublicLink = function() {
      var idCF, path, _ref2;
      if ((_ref2 = this.entry.type) === NumSync.models.Entry.types.FILE || _ref2 === NumSync.models.Entry.types.FOLDER || _ref2 === NumSync.models.Entry.types.CLOUD_FOLDER) {
        idCF = this.entry.idCloudFolder || this.entry.id;
        path = this.entry.path || ".";
        return this.hFM.getPublicLink(idCF, path, {
          onSuccess: Uju.bind(this, function(publicLink) {
            this.entry._link_ = new NumSync.models.PublicLink(publicLink);
            this.widget.entry = this.entry;
            return this.widget.updateLink();
          }),
          onError: Uju.bind(this, function(error, status) {
            if (status !== NumSync.RESTapi.error.RESOURCE_NOT_FOUND) {
              return enyo.Signals.send("showModal", {
                clean: false,
                modal: {
                  kind: "NumSync.Notification",
                  type: NumSync.Notification.types.ERROR,
                  message: this.i18n.getTranslation("retrieving_pLink_fail") + (status === 0 ? ": " + error : ""),
                  timeout: 2000
                }
              });
            } else {
              this.widget.entry._link_ = null;
              return this.widget.updateLink();
            }
          })
        });
      }
    };

    impl.prototype._removeShare = function(notification) {
      var share, startProgress;
      startProgress = new Date().getTime();
      share = this.entry._share_;
      return this.hFM.deleteShare(share.id, {
        onResponse: Uju.bind(this, function(response) {
          var waiting;
          waiting = 1000 - (new Date().getTime() - startProgress);
          if (waiting < 0) {
            waiting = 0;
          }
          return setTimeout(Uju.bind(this, function() {
            notification.close(true);
            if (response.error != null) {
              return enyo.Signals.send("showModal", {
                clean: false,
                modal: {
                  kind: "NumSync.Notification",
                  type: NumSync.Notification.types.ERROR,
                  message: this.i18n.getTranslation("remove_share_err"),
                  timeout: 3000
                }
              });
            } else {
              this.entry._share_ = null;
              this.widget.updateSharees();
              return enyo.Signals.send("showModal", {
                clean: false,
                modal: {
                  kind: "NumSync.Notification",
                  type: NumSync.Notification.types.SUCCESS,
                  message: this.i18n.getTranslation("remove_share_success"),
                  timeout: 3000
                }
              });
            }
          }), waiting);
        })
      });
    };


    /*
      * Triggered when connection has changed
      * @param <boolean> isOnline
     */

    impl.prototype._onConnectionChange = function(isOnline) {
      this.widget.featuresDisabled = !isOnline;
      if (isOnline) {
        this.widget.enableActions();
        return this.widget.enableShareAndLink();
      } else {
        this.widget.disableActions();
        return this.widget.disableShareAndLink();
      }
    };


    /*
      * Call export native feature / sharing dialog (Android only)
      * @param <json> entry
     */

    impl.prototype._requestExport = function(entry) {
      return this.hEH.shareEntry(entry);
    };


    /*
      * Request remove entry
      * @param <json> entry
     */

    impl.prototype._requestRemove = function(entry) {
      return this.hEH.removeEntries([entry]);
    };


    /*
      * Request move entry
      * @param <json> entry
     */

    impl.prototype._requestMove = function(entry) {
      return this.hEH.moveEntries([entry]);
    };


    /*
      * Request rename entry
      * @param <json> entry
     */

    impl.prototype._requestRename = function(entry) {
      return this.hEH.renameEntry(entry);
    };

    return impl;

  })(scope.Ubidreams.widgets.Abstract.impl);

  enyo.kind({
    name: "NumSync.EntryDetails.ui",
    kind: "Ubidreams.widgets.Modals",
    classes: "modals-level2 modal-details",
    start: "right",
    swipe: true,
    scrim: false,
    fullscreen: true,
    featuresDisabled: false,
    published: {
      entry: {}
    },
    handlers: {
      onOpen: "onOpen",
      onClose: "onClose"
    },
    components: [
      {
        classes: "modals-header",
        components: [
          {
            classes: "title",
            name: "title"
          }, {
            tag: "i",
            classes: "btn-right fa fa-times",
            ontap: "close"
          }
        ]
      }, {
        kind: "Ubidreams.Scroller",
        top: "60px",
        components: [
          {
            name: "info",
            classes: "info panel panel-default",
            components: [
              {
                classes: "panel-heading",
                components: [
                  {
                    tag: "h3",
                    classes: "panel-title",
                    content: "Informations"
                  }
                ]
              }, {
                tag: "ul",
                classes: "list-group details-info",
                components: [
                  {
                    name: "pathWrapper",
                    tag: "li",
                    classes: "list-group-item row",
                    components: [
                      {
                        classes: "col-xs-5",
                        i18n: [
                          {
                            key: "path"
                          }
                        ]
                      }, {
                        classes: "col-xs-7",
                        name: "path",
                        style: "word-break: break-all"
                      }
                    ]
                  }, {
                    name: "modifiedWrapper",
                    tag: "li",
                    classes: "list-group-item row",
                    components: [
                      {
                        classes: "col-xs-5",
                        content: "modification"
                      }, {
                        classes: "col-xs-7",
                        name: "modified"
                      }
                    ]
                  }, {
                    name: "sizeWrapper",
                    tag: "li",
                    classes: "list-group-item row",
                    components: [
                      {
                        classes: "col-xs-5",
                        i18n: [
                          {
                            key: "size"
                          }
                        ]
                      }, {
                        classes: "col-xs-7",
                        name: "size"
                      }
                    ]
                  }, {
                    name: "typeWrapper",
                    tag: "li",
                    classes: "list-group-item row",
                    components: [
                      {
                        classes: "col-xs-5",
                        content: "type"
                      }, {
                        classes: "col-xs-7",
                        name: "type"
                      }
                    ]
                  }
                ]
              }
            ]
          }, {
            name: "sharing",
            classes: "sharing panel panel-default",
            components: [
              {
                classes: "panel-heading",
                components: [
                  {
                    name: "sharingTitle",
                    tag: "h3",
                    classes: "panel-title pull-left",
                    i18n: [
                      {
                        key: "sharing"
                      }
                    ]
                  }, {
                    name: "btShare",
                    tag: "i",
                    classes: "fa fa-plus pull-right",
                    ontap: "showShare"
                  }, {
                    name: "btRemoveShare",
                    tag: "i",
                    classes: "fa fa-trash-o pull-right",
                    ontap: "removeShare",
                    showing: false
                  }
                ]
              }, {
                tag: "ul",
                classes: "list-group",
                name: "sharees"
              }
            ]
          }, {
            name: "link",
            classes: "public-link panel panel-default"
          }, {
            name: "action",
            classes: "info panel panel-default",
            components: [
              {
                classes: "panel-heading",
                components: [
                  {
                    tag: "h3",
                    classes: "panel-title",
                    content: "Action"
                  }
                ]
              }, {
                classes: "actions",
                components: [
                  {
                    components: [
                      {
                        name: "rename",
                        classes: "tile btn btn-default",
                        ontap: "onButtonAction",
                        components: [
                          {
                            tag: "i",
                            classes: "fa fa-tag"
                          }, {
                            tag: "span",
                            i18n: [
                              {
                                key: "rename"
                              }
                            ]
                          }
                        ]
                      }, {
                        name: "remove",
                        classes: "tile btn btn-default",
                        ontap: "onButtonAction",
                        components: [
                          {
                            tag: "i",
                            classes: "fa fa-trash-o"
                          }, {
                            tag: "span",
                            i18n: [
                              {
                                key: "remove"
                              }
                            ]
                          }
                        ]
                      }
                    ]
                  }, {
                    components: [
                      {
                        name: "move",
                        classes: "tile btn btn-default",
                        ontap: "onButtonAction",
                        components: [
                          {
                            tag: "i",
                            classes: "fa fa-arrows"
                          }, {
                            tag: "span",
                            i18n: [
                              {
                                key: "move"
                              }
                            ]
                          }
                        ]
                      }, {
                        name: "export",
                        classes: "tile btn btn-default",
                        ontap: "onButtonAction",
                        components: [
                          {
                            tag: "i",
                            classes: "fa fa-upload"
                          }, {
                            tag: "span",
                            i18n: [
                              {
                                key: "export"
                              }
                            ]
                          }
                        ]
                      }
                    ]
                  }
                ]
              }
            ]
          }
        ]
      }
    ],
    entryChanged: function() {
      this.$.title.setContent(this.entry.getEntryName());
      if (this.entry.lastModified != null) {
        this.$.modified.setContent(moment(this.entry.lastModified).format("LL"));
      }
      if (this.entry.getSizeStr != null) {
        this.$.size.setContent(this.entry.getSizeStr());
      }
      switch (this.entry.type) {
        case NumSync.models.Entry.types.FOLDER:
          this.$.path.setContent(this.entry._parent_ + "/" + this.entry.path);
          this.$.sizeWrapper.destroy();
          this.$.typeWrapper.destroy();
          break;
        case NumSync.models.Entry.types.CLOUD_FOLDER:
          if (this.entry.myBox === true) {
            this.$.sharing.destroy();
            this.$.remove.destroy();
            this.$.rename.destroy();
            this.$.info.destroy();
            this.$.move.destroy();
            this.$.action.destroy();
          } else {
            this.$.info.destroy();
            this.$.move.destroy();
          }
          break;
        case NumSync.models.Entry.types.SHARED_FOLDER:
          if (this.entry.path !== ".") {
            this.$.path.setContent(this.entry.path);
          } else {
            this.$.path.setContent(this.entry.getEntryName());
          }
          this.$.modifiedWrapper.destroy();
          this.$.sizeWrapper.destroy();
          this.$.typeWrapper.destroy();
          this.$.link.destroy();
          if (this.entry.shareType !== NumSync.models.Share.rights.WRITE) {
            this.$.remove.destroy();
            this.$.rename.destroy();
            this.$.move.destroy();
            if (this.$["export"] == null) {
              this.$.action.destroy();
            }
          }
          break;
        case NumSync.models.Entry.types.FILE:
          this.$.path.setContent(this.entry._parent_ + "/" + this.entry.path);
          this.$.type.setContent(this.entry.path.split(".").pop());
          this.$.sharing.destroy();
      }
      this.updateSharees();
      return this.updateLink();
    },
    enableActions: function() {
      var _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8, _ref9;
      if ((_ref2 = this.$.move) != null) {
        _ref2.removeClass("disabled");
      }
      if ((_ref3 = this.$.move) != null) {
        _ref3.ontap = "onButtonAction";
      }
      if ((_ref4 = this.$.rename) != null) {
        _ref4.removeClass("disabled");
      }
      if ((_ref5 = this.$.rename) != null) {
        _ref5.ontap = "onButtonAction";
      }
      if ((_ref6 = this.$.remove) != null) {
        _ref6.removeClass("disabled");
      }
      if ((_ref7 = this.$.remove) != null) {
        _ref7.ontap = "onButtonAction";
      }
      if ((_ref8 = this.$["export"]) != null) {
        _ref8.removeClass("disabled");
      }
      return (_ref9 = this.$["export"]) != null ? _ref9.ontap = "onButtonAction" : void 0;
    },
    disableActions: function() {
      var _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8, _ref9;
      if ((_ref2 = this.$.move) != null) {
        _ref2.addClass("disabled");
      }
      if ((_ref3 = this.$.move) != null) {
        _ref3.ontap = "";
      }
      if ((_ref4 = this.$.rename) != null) {
        _ref4.addClass("disabled");
      }
      if ((_ref5 = this.$.rename) != null) {
        _ref5.ontap = "";
      }
      if ((_ref6 = this.$.remove) != null) {
        _ref6.addClass("disabled");
      }
      if ((_ref7 = this.$.remove) != null) {
        _ref7.ontap = "";
      }
      if ((_ref8 = this.$["export"]) != null) {
        _ref8.addClass("disabled");
      }
      return (_ref9 = this.$["export"]) != null ? _ref9.ontap = "" : void 0;
    },
    enableShareAndLink: function() {
      var _ref2, _ref3, _ref4;
      if ((_ref2 = this.$.btShare) != null) {
        _ref2.applyStyle("opacity", null);
      }
      if ((_ref3 = this.$.btLink) != null) {
        _ref3.applyStyle("opacity", null);
      }
      return (_ref4 = this.$.btRemoveShare) != null ? _ref4.applyStyle("opacity", null) : void 0;
    },
    disableShareAndLink: function() {
      var _ref2, _ref3, _ref4, _ref5;
      if ((_ref2 = this.$.btShare) != null) {
        _ref2.applyStyle("opacity", 0.1);
      }
      if ((_ref3 = this.$.btShare) != null) {
        _ref3.applyStyle("opacity", 0.1);
      }
      if ((_ref4 = this.$.btLink) != null) {
        _ref4.applyStyle("opacity", 0.1);
      }
      return (_ref5 = this.$.btRemoveShare) != null ? _ref5.applyStyle("opacity", 0.1) : void 0;
    },
    updateSharees: function() {
      var sharee, _i, _len, _ref2, _results;
      if (this.$.sharees == null) {
        return false;
      }
      this.$.sharees.destroyClientControls();
      if (this.entry.type === NumSync.models.Entry.types.SHARED_FOLDER) {
        Ubidreams._i18n.setKey(this.$.sharingTitle, "content", "shared_by", {
          variables: [this.entry.owner.login]
        });
        this.createComponent({
          tag: "li",
          classes: "list-group-item",
          container: this.$.sharees,
          content: Ubidreams._i18n.get(this.entry.shareType === NumSync.models.Share.rights.WRITE ? "modification_on" : "modification_off")
        }).render();
        this.$.btShare.hide();
        return this.$.btRemoveShare.hide();
      } else {
        Ubidreams._i18n.setKey(this.$.sharingTitle, "content", "sharing");
        if ((this.entry._share_ != null) && this.entry._share_.sharesByAccount.length > 0) {
          this.$.btRemoveShare.show();
          _ref2 = this.entry._share_.sharesByAccount;
          _results = [];
          for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
            sharee = _ref2[_i];
            _results.push(this.createComponent({
              tag: "li",
              classes: "list-group-item clearfix",
              components: [
                {
                  content: sharee.email,
                  classes: "pull-left"
                }, {
                  allowHtml: true,
                  classes: "pull-right text-right",
                  content: Ubidreams._i18n.get(sharee.shareType === NumSync.models.Share.rights.WRITE ? "modification_on_br" : "modification_off_br")
                }
              ],
              sharee: sharee,
              container: this.$.sharees
            }).render());
          }
          return _results;
        } else {
          this.$.btRemoveShare.hide();
          return this.createComponent({
            tag: "li",
            classes: "list-group-item",
            content: Ubidreams._i18n.get("no_sharing"),
            container: this.$.sharees
          }).render();
        }
      }
    },
    updateLink: function() {
      var link;
      if (this.$.link == null) {
        return;
      }
      this.$.link.destroyClientControls();
      link = this.entry._link_;
      if (link != null) {
        return this.createComponent({
          tag: null,
          container: this.$.link,
          components: [
            {
              classes: "panel-heading",
              components: [
                {
                  tag: "h3",
                  classes: "panel-title pull-left",
                  content: Ubidreams._i18n.get("publicLink")
                }, {
                  classes: "pull-right status",
                  components: [
                    {
                      tag: "span",
                      content: Ubidreams._i18n.get("status")
                    }, {
                      tag: "i",
                      classes: "fa fa-check-circle"
                    }
                  ]
                }
              ]
            }, {
              classes: "panel-body",
              ontap: "showPublicLink",
              components: [
                {
                  classes: "row",
                  components: [
                    {
                      classes: "col-xs-5",
                      content: Ubidreams._i18n.get("published")
                    }, {
                      classes: "col-xs-7",
                      name: "published",
                      content: moment(link.creationDate).format("LL")
                    }
                  ]
                }, {
                  classes: "row",
                  style: "margin-bottom: 10px",
                  components: [
                    {
                      classes: "col-xs-5",
                      content: Ubidreams._i18n.get("duration")
                    }, {
                      classes: "col-xs-7",
                      name: "duration",
                      content: link.getDuration()
                    }
                  ]
                }, {
                  name: "deposit",
                  content: Ubidreams._i18n.get("deposit_" + (link.uploadAllowed ? "on" : "off"))
                }, {
                  name: "protection",
                  content: Ubidreams._i18n.get("protection_" + (link.password ? "on" : "off"))
                }
              ]
            }
          ]
        }).render();
      } else {
        return this.createComponent({
          tag: null,
          container: this.$.link,
          components: [
            {
              classes: "panel-heading",
              components: [
                {
                  tag: "h3",
                  classes: "panel-title pull-left",
                  content: Ubidreams._i18n.get("publicLink")
                }, {
                  name: "btLink",
                  tag: "i",
                  classes: "fa fa-plus pull-right",
                  ontap: "showPublicLink"
                }
              ]
            }, {
              tag: "ul",
              classes: "list-group",
              components: [
                {
                  tag: "li",
                  classes: "list-group-item",
                  content: Ubidreams._i18n.get("no_publicLink")
                }
              ]
            }
          ]
        }).render();
      }
    },
    onOpen: function() {
      return this._call("_retrievePublicLink");
    },
    onClose: function() {
      return enyo.Signals.send("refreshFilesTree", {});
    },
    showPublicLink: function() {
      if (!this.featuresDisabled) {
        return enyo.Signals.send("showModal", {
          clean: false,
          modal: {
            className: "NumSync.PublicLink",
            config: {
              updateCallback: Uju.bind(this, function(link) {
                this.entry._link_ = link;
                return this.updateLink();
              }),
              widgetConf: {
                entry: this.entry
              }
            }
          }
        });
      }
    },
    showShare: function(inSender, inEvent) {
      if (!this.featuresDisabled) {
        return enyo.Signals.send("showModal", {
          clean: false,
          modal: {
            className: "NumSync.Sharing",
            config: {
              updateCallback: Uju.bind(this, function(share) {
                this.entry._share_ = share;
                return this.updateSharees();
              }),
              widgetConf: {
                entry: this.entry,
                sharee: inSender.sharee
              }
            }
          }
        });
      }
    },
    onButtonAction: function(inSender, inEvent) {
      var action;
      action = "_request" + inSender.name.charAt(0).toUpperCase() + inSender.name.slice(1);
      return this._call(action, this.entry);
    },
    disableExport: function() {
      return this.$["export"].destroy();
    },
    removeShare: function(inSender) {
      if (!this.featuresDisabled) {
        return navigator.notification.confirm(Ubidreams._i18n.get("remove_share"), Uju.bind(this, function(btnIdx) {
          if (btnIdx === 2) {
            return enyo.Signals.send("showModal", {
              clean: false,
              modal: {
                kind: "NumSync.Notification",
                type: NumSync.Notification.types.PENDING,
                message: Ubidreams._i18n.get("remove-pending")
              },
              callback: Uju.bind(this, function(modal) {
                return this._call("_removeShare", modal);
              })
            });
          }
        }), Ubidreams._i18n.get("remove_share_title"), [Ubidreams._i18n.get("no"), Ubidreams._i18n.get("yes")]);
      }
    }
  });

}).call(this);
