// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.PublicLink = (_ref1 = scope.NumSync.PublicLink) != null ? _ref1 : {};

  scope.NumSync.PublicLink.impl = (function(_super) {
    __extends(impl, _super);

    function impl() {
      impl.__super__.constructor.call(this);
      this.ui = "NumSync.PublicLink.ui";
      this.hFM = null;
    }

    impl.prototype.configure = function(hub, conf) {
      impl.__super__.configure.call(this, hub, conf);
      this.updateCallback = conf.updateCallback;
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.FileManager.contract,
        field: "hFM"
      });
      return this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
    };

    impl.prototype.start = function() {
      impl.__super__.start.call(this);
      return this.i18n.i18nForEnyo(this.widget);
    };

    impl.prototype._removeEntryLink = function(entry, notification) {
      var link, startProgress;
      startProgress = new Date().getTime();
      link = entry._link_;
      if (link != null) {
        return this.hFM.deletePublicLink(link.id, {
          onResponse: Uju.bind(this, function(response) {
            var waiting;
            waiting = 1000 - (new Date().getTime() - startProgress);
            if (waiting < 0) {
              waiting = 0;
            }
            return setTimeout(Uju.bind(this, function() {
              notification.close(true);
              if (response.error != null) {
                return enyo.Signals.send("showModal", {
                  clean: false,
                  modal: {
                    kind: "NumSync.Notification",
                    type: NumSync.Notification.types.ERROR,
                    message: this.i18n.getTranslation("remove_pl_err"),
                    timout: 3000
                  }
                });
              } else {
                if (typeof this.updateCallback === "function") {
                  this.updateCallback(null);
                }
                this.widget.close();
                return enyo.Signals.send("showModal", {
                  clean: false,
                  modal: {
                    kind: "NumSync.Notification",
                    type: NumSync.Notification.types.SUCCESS,
                    message: this.i18n.getTranslation("remove_pl_success"),
                    timout: 3000
                  }
                });
              }
            }), waiting);
          })
        });
      }
    };

    impl.prototype._saveEntryLink = function(entry, data, notification) {
      var callback;
      callback = Uju.bind(this, function(response) {
        var email, failures, _i, _len, _ref2, _ref3;
        notification.close(true);
        if (response.error == null) {
          if (typeof this.updateCallback === "function") {
            this.updateCallback(new NumSync.models.PublicLink(response.data));
          }
          this.widget.close();
          failures = "";
          if ((_ref2 = response.data.invalidEmails) != null ? _ref2.length : void 0) {
            _ref3 = response.data.invalidEmails;
            for (_i = 0, _len = _ref3.length; _i < _len; _i++) {
              email = _ref3[_i];
              failures += email + ", ";
            }
            failures = " " + this.i18n.getTranslation("notify_fail", [failures.substr(0, failures.length - 2)]);
          }
          return enyo.Signals.send("showModal", {
            clean: false,
            modal: {
              kind: "NumSync.Notification",
              type: NumSync.Notification.types.SUCCESS,
              message: Ubidreams._i18n.get("save_link_success") + failures,
              timout: 10000
            }
          });
        } else {
          return enyo.Signals.send("showModal", {
            clean: false,
            modal: {
              kind: "NumSync.Notification",
              type: NumSync.Notification.types.ERROR,
              message: Ubidreams._i18n.get("save_link_fail", [response.error.message]),
              timout: 3000
            }
          });
        }
      });
      if (entry._link_ != null) {
        return this.hFM.updatePublicLink(entry._link_.id, data.update, {
          onResponse: callback
        });
      } else {
        return this.hFM.createPublicLink(entry.idCloudFolder || entry.id, entry.path || ".", data, {
          onResponse: callback
        });
      }
    };

    return impl;

  })(scope.Ubidreams.widgets.Abstract.impl);

  enyo.kind({
    name: "NumSync.PublicLink.ui",
    kind: "Ubidreams.widgets.Modals",
    classes: "modals-level2 modal-public-link",
    start: "bottom",
    size: "percents",
    value: 100,
    scrim: false,
    fullscreen: true,
    published: {
      entry: {}
    },
    components: [
      {
        classes: "modals-header",
        components: [
          {
            name: "title",
            classes: "title"
          }, {
            tag: "i",
            classes: "btn-right fa fa-times",
            ontap: "close"
          }
        ]
      }, {
        kind: "Ubidreams.Scroller",
        top: "60px",
        bottom: "50px",
        components: [
          {
            classes: "modals-body",
            components: [
              {
                name: "info",
                classes: "panel panel-default",
                showing: false,
                components: [
                  {
                    classes: "panel-heading",
                    components: [
                      {
                        tag: "h3",
                        classes: "panel-title",
                        content: "Details"
                      }
                    ]
                  }, {
                    tag: "ul",
                    classes: "list-group",
                    components: [
                      {
                        tag: "li",
                        classes: "list-group-item",
                        components: [
                          {
                            classes: "clearfix",
                            components: [
                              {
                                i18n: [
                                  {
                                    key: "creation_date"
                                  }
                                ],
                                classes: "pull-left"
                              }, {
                                name: "creationDate",
                                classes: "pull-right"
                              }
                            ]
                          }
                        ]
                      }, {
                        tag: "li",
                        classes: "list-group-item",
                        components: [
                          {
                            classes: "clearfix",
                            components: [
                              {
                                i18n: [
                                  {
                                    key: "link"
                                  }
                                ],
                                classes: "pull-left"
                              }, {
                                name: "url",
                                classes: "pull-right pl-url",
                                tag: "p",
                                ontap: "openLinkInSystem"
                              }
                            ]
                          }
                        ]
                      }
                    ]
                  }
                ]
              }, {
                classes: "panel panel-default",
                components: [
                  {
                    classes: "panel-heading",
                    components: [
                      {
                        tag: "h3",
                        classes: "panel-title",
                        i18n: [
                          {
                            key: "duration"
                          }
                        ]
                      }
                    ]
                  }, {
                    classes: "styled-select",
                    components: [
                      {
                        name: "duration",
                        kind: "enyo.Select",
                        components: [
                          {
                            i18n: [
                              {
                                key: "day",
                                variables: [1]
                              }
                            ],
                            value: 1
                          }, {
                            i18n: [
                              {
                                key: "days",
                                variables: [2]
                              }
                            ],
                            value: 2
                          }, {
                            i18n: [
                              {
                                key: "days",
                                variables: [5]
                              }
                            ],
                            value: 5
                          }, {
                            i18n: [
                              {
                                key: "week",
                                variables: [1]
                              }
                            ],
                            value: 7
                          }, {
                            i18n: [
                              {
                                key: "weeks",
                                variables: [2]
                              }
                            ],
                            value: 14
                          }, {
                            i18n: [
                              {
                                key: "month",
                                variables: [1]
                              }
                            ],
                            value: 30
                          }, {
                            i18n: [
                              {
                                key: "months",
                                variables: [3]
                              }
                            ],
                            value: 90
                          }, {
                            i18n: [
                              {
                                key: "forever"
                              }
                            ],
                            variables: -1
                          }
                        ]
                      }
                    ]
                  }
                ]
              }, {
                classes: "protection panel panel-default",
                components: [
                  {
                    classes: "panel-heading",
                    components: [
                      {
                        tag: "h3",
                        classes: "panel-title",
                        content: "Protection"
                      }
                    ]
                  }, {
                    tag: "ul",
                    classes: "list-group",
                    components: [
                      {
                        tag: "li",
                        classes: "list-group-item",
                        components: [
                          {
                            classes: "clearfix",
                            components: [
                              {
                                i18n: [
                                  {
                                    key: "pw_placeholder"
                                  }
                                ],
                                classes: "pull-left"
                              }, {
                                name: "pwToggle",
                                kind: "onyx.ToggleButton",
                                classes: "pull-right",
                                onChange: "setPwdShowing"
                              }
                            ]
                          }, {
                            name: "password",
                            kind: "Input",
                            type: "password",
                            classes: "form-control",
                            showing: false
                          }
                        ]
                      }, {
                        name: "depositWrapper",
                        tag: "li",
                        classes: "list-group-item clearfix",
                        components: [
                          {
                            i18n: [
                              {
                                key: "file_deposit"
                              }
                            ],
                            classes: "pull-left"
                          }, {
                            name: "deposit",
                            kind: "onyx.ToggleButton",
                            classes: "pull-right"
                          }
                        ]
                      }
                    ]
                  }
                ]
              }, {
                name: "emailWrapper",
                classes: "panel panel-default",
                components: [
                  {
                    classes: "panel-heading",
                    components: [
                      {
                        tag: "h3",
                        classes: "panel-title",
                        i18n: [
                          {
                            key: "email"
                          }
                        ]
                      }
                    ]
                  }, {
                    name: "emails",
                    kind: "enyo.TextArea",
                    classes: "form-control",
                    attributes: {
                      rows: 5
                    },
                    i18n: [
                      {
                        setter: "placeholder",
                        key: "emails_ph"
                      }
                    ]
                  }
                ]
              }, {
                name: "messageWrapper",
                classes: "panel panel-default",
                components: [
                  {
                    classes: "panel-heading",
                    components: [
                      {
                        tag: "h3",
                        classes: "panel-title",
                        content: "Message"
                      }
                    ]
                  }, {
                    name: "message",
                    kind: "enyo.TextArea",
                    classes: "form-control",
                    attributes: {
                      rows: 5
                    },
                    i18n: [
                      {
                        key: "sharingMessage_ph",
                        setter: "placeholder"
                      }
                    ]
                  }
                ]
              }
            ]
          }
        ]
      }, {
        name: "footerUpdate",
        classes: "pages-footer",
        components: [
          {
            name: "left",
            classes: "left-part",
            ontap: "remove",
            components: [
              {
                tag: "i",
                classes: "fa fa-trash-o"
              }, {
                tag: "span",
                i18n: [
                  {
                    key: "remove"
                  }
                ]
              }
            ]
          }, {
            name: "right",
            classes: "right-part",
            ontap: "save",
            components: [
              {
                tag: "i",
                classes: "fa fa-floppy-o"
              }, {
                tag: "span",
                i18n: [
                  {
                    key: "save"
                  }
                ]
              }
            ]
          }
        ]
      }, {
        name: "footerCreate",
        classes: "modals-footer",
        components: [
          {
            kind: "enyo.Button",
            i18n: [
              {
                key: "save"
              }
            ],
            classes: "btn btn-default btn-submit",
            ontap: "save"
          }
        ]
      }
    ],
    create: function() {
      this.inherited(arguments);
      return this.entryChanged();
    },
    entryChanged: function() {
      var i, link, possibility, validity, _i, _len, _ref2;
      this.$.title.setContent("" + (Ubidreams._i18n.get("publicLink")) + " (" + (this.entry.getEntryName()) + ")");
      this.$.depositWrapper.setShowing(this.entry.type !== NumSync.models.Entry.types.FILE);
      link = this.entry._link_;
      if (link == null) {
        this.$.footerUpdate.hide();
        return;
      }
      this.$.info.show();
      this.$.creationDate.setContent(moment(link.creationDate).format("LL"));
      this.$.url.setContent(link.url);
      this.$.url.link = link.url;
      validity = null;
      link.validity = parseInt(link.validity);
      _ref2 = [1, 2, 5, 7, 14, 30, 90];
      for (i = _i = 0, _len = _ref2.length; _i < _len; i = ++_i) {
        possibility = _ref2[i];
        if (link.validity > 0 && link.validity <= possibility) {
          validity = i;
          break;
        }
      }
      if (validity == null) {
        validity = 7;
      }
      this.$.duration.setSelected(validity);
      if (link.password) {
        this.$.pwToggle.setActive(true);
        this.$.password.setValue(link.password);
      }
      this.$.deposit.setActive(link.uploadAllowed);
      this.$.footerCreate.hide();
      this.$.emailWrapper.hide();
      return this.$.messageWrapper.hide();
    },
    setPwdShowing: function(inSender) {
      return this.$.password.setShowing(inSender.getValue());
    },
    remove: function() {
      return navigator.notification.confirm(Ubidreams._i18n.get("remove_link"), Uju.bind(this, function(btnIdx) {
        if (btnIdx === 2) {
          return enyo.Signals.send("showModal", {
            clean: false,
            modal: {
              kind: "NumSync.Notification",
              type: NumSync.Notification.types.PENDING,
              message: Ubidreams._i18n.get("remove-pending")
            },
            callback: Uju.bind(this, function(modal) {
              return this._call("_removeEntryLink", this.entry, modal);
            })
          });
        }
      }), Ubidreams._i18n.get("remove_link_title"), [Ubidreams._i18n.get("no"), Ubidreams._i18n.get("yes")]);
    },
    save: function() {
      var email, emails, isEmail_re, payload, txt, _i, _len;
      payload = {
        update: {
          validity: parseInt(this.$.duration.getValue()),
          password: this.$.pwToggle.getActive() === false ? "" : this.$.password.getValue(),
          uploadAllowed: this.$.deposit.getActive()
        }
      };
      if (this.entry._link_ == null) {
        txt = this.$.emails.getValue().trim();
        if (txt) {
          emails = txt.split(" ");
          for (_i = 0, _len = emails.length; _i < _len; _i++) {
            email = emails[_i];
            isEmail_re = /^\s*[\w\-\+_]+(\.[\w\-\+_]+)*\@[\w\-\+_]+\.[\w\-\+_]+(\.[\w\-\+_]+)*\s*$/;
            if (isEmail_re.test(email) !== true) {
              navigator.notification.alert(Ubidreams._i18n.get("incorrect_notify_email", [email]), null, Ubidreams._i18n.get("publicLink_error"));
              return;
            }
          }
          payload.notify = {
            emails: emails,
            message: this.$.message.getValue()
          };
        }
      }
      return enyo.Signals.send("showModal", {
        clean: false,
        modal: {
          kind: "NumSync.Notification",
          type: NumSync.Notification.types.PENDING,
          message: Ubidreams._i18n.get("save_pending")
        },
        callback: Uju.bind(this, function(modal) {
          return this._call("_saveEntryLink", this.entry, payload, modal);
        })
      });
    },
    openLinkInSystem: function(inSender, inEvent) {
      return window.open(inSender.link, '_system');
    }
  });

}).call(this);
