// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.Sharing = (_ref1 = scope.NumSync.Sharing) != null ? _ref1 : {};

  scope.NumSync.Sharing.impl = (function(_super) {
    __extends(impl, _super);

    function impl() {
      impl.__super__.constructor.call(this);
      this.ui = "NumSync.Sharing.ui";
      this.hFM = null;
    }

    impl.prototype.configure = function(hub, conf) {
      impl.__super__.configure.call(this, hub, conf);
      this.updateCallback = conf.updateCallback;
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.FileManager.contract,
        field: "hFM"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
      return this.hub.subscribe(this, "app/keyboard", Uju.bind(this, this._onKeyboard));
    };

    impl.prototype.start = function() {
      impl.__super__.start.call(this);
      return this.i18n.i18nForEnyo(this.widget);
    };

    impl.prototype._addSharees = function(entry, data, notification) {
      var callback, idCloudFolder, path, _ref2, _ref3;
      callback = Uju.bind(this, function(response) {
        var email, failures, share, _i, _len, _ref2, _ref3;
        notification.close(true);
        if (response.error == null) {
          if (response.data.share != null) {
            share = new NumSync.models.Share(response.data.share);
          } else {
            share = entry._share_;
            share.sharesByAccount = share.sharesByAccount.concat(response.data.sharesByAccount);
          }
          if (typeof this.updateCallback === "function") {
            this.updateCallback(share);
          }
          failures = "";
          if ((_ref2 = response.data.unauthorizedEmails) != null ? _ref2.length : void 0) {
            _ref3 = response.data.unauthorizedEmails;
            for (_i = 0, _len = _ref3.length; _i < _len; _i++) {
              email = _ref3[_i];
              failures += email + ", ";
            }
            failures = " " + this.i18n.getTranslation("add_sharees_fails", [failures.substr(0, failures.length - 2)]);
          }
          this.widget.close();
          return enyo.Signals.send("showModal", {
            clean: false,
            modal: {
              kind: "NumSync.Notification",
              type: NumSync.Notification.types.SUCCESS,
              message: this.i18n.getTranslation("save_share_success") + failures,
              timeout: failures ? 10000 : void 0
            }
          });
        } else {
          return enyo.Signals.send("showModal", {
            clean: false,
            modal: {
              kind: "NumSync.Notification",
              type: NumSync.Notification.types.ERROR,
              message: this.i18n.getTranslation("save_share_fail", [response.error.message])
            }
          });
        }
      });
      if (entry._share_ == null) {
        idCloudFolder = (_ref2 = entry.idCloudFolder) != null ? _ref2 : entry.id;
        path = (_ref3 = entry.path) != null ? _ref3 : null;
        return this.hFM.createShare(idCloudFolder, path, data, {
          onResponse: callback
        });
      } else {
        return this.hFM.createSharees(entry._share_.id, data, {
          onResponse: callback
        });
      }
    };

    impl.prototype._onKeyboard = function(event) {
      return this.widget.keyboardIsOpen(event.isOpen, event.keyboardHeight);
    };

    return impl;

  })(scope.Ubidreams.widgets.Abstract.impl);

  enyo.kind({
    name: "NumSync.Sharing.ui",
    kind: "Ubidreams.widgets.Modals",
    classes: "modals-level2 modal-sharing",
    start: "bottom",
    scrim: false,
    fullscreen: true,
    published: {
      entry: {},
      sharee: {}
    },
    handlers: {
      onClose: "onClose"
    },
    components: [
      {
        classes: "modals-header",
        components: [
          {
            classes: "title",
            i18n: [
              {
                key: "sharing"
              }
            ]
          }, {
            tag: "i",
            classes: "btn-right fa fa-times",
            ontap: "close"
          }
        ]
      }, {
        name: "scroller",
        kind: "Ubidreams.Scroller",
        top: "60px",
        bottom: "50px",
        components: [
          {
            classes: "modals-body",
            components: [
              {
                kind: "NumSync.modals.Sharing_Right",
                name: "rights"
              }, {
                name: "emailWrapper",
                classes: "panel panel-default",
                components: [
                  {
                    classes: "panel-heading",
                    components: [
                      {
                        tag: "h3",
                        classes: "panel-title",
                        i18n: [
                          {
                            key: "email"
                          }
                        ]
                      }
                    ]
                  }, {
                    name: "emails",
                    kind: "enyo.TextArea",
                    classes: "form-control",
                    attributes: {
                      rows: 5
                    },
                    i18n: [
                      {
                        key: "emails_ph",
                        setter: "placeholder"
                      }
                    ],
                    onfocus: "_receiveFocus"
                  }
                ]
              }, {
                name: "messageWrapper",
                classes: "panel panel-default",
                components: [
                  {
                    classes: "panel-heading",
                    components: [
                      {
                        tag: "h3",
                        classes: "panel-title",
                        content: "Message"
                      }
                    ]
                  }, {
                    name: "message",
                    kind: "enyo.TextArea",
                    classes: "form-control",
                    attributes: {
                      rows: 5
                    },
                    i18n: [
                      {
                        key: "sharingMessage_ph",
                        setter: "placeholder"
                      }
                    ],
                    onfocus: "_receiveFocus"
                  }
                ]
              }
            ]
          }
        ]
      }, {
        name: "footerUpdate",
        classes: "pages-footer",
        components: [
          {
            name: "left",
            classes: "left-part",
            ontap: "remove",
            components: [
              {
                tag: "i",
                classes: "fa fa-trash-o"
              }, {
                tag: "span",
                i18n: [
                  {
                    key: "remove"
                  }
                ]
              }
            ]
          }, {
            name: "right",
            classes: "right-part",
            ontap: "save",
            components: [
              {
                tag: "i",
                classes: "fa fa-floppy-o"
              }, {
                tag: "span",
                i18n: [
                  {
                    key: "save"
                  }
                ]
              }
            ]
          }
        ]
      }, {
        name: "footerCreate",
        classes: "modals-footer",
        components: [
          {
            kind: "enyo.Button",
            i18n: [
              {
                key: "save"
              }
            ],
            classes: "btn btn-default btn-submit",
            ontap: "save"
          }
        ]
      }
    ],
    create: function() {
      this.inherited(arguments);
      return this.shareeChanged();
    },
    shareeChanged: function() {
      if (this.sharee != null) {
        this.$.rights.setShareeMail(this.sharee.email);
        this.$.rights.setModification(this.sharee.shareType === NumSync.models.Share.rights.WRITE);
        this.$.emailWrapper.hide();
        this.$.messageWrapper.hide();
        return this.$.footerCreate.hide();
      } else {
        this.$.footerUpdate.hide();
        return this.$.rights.setShareeMail(null);
      }
    },

    /*
      * Show or hide footer bar according to the keyboard state
     */
    keyboardIsOpen: function(isOpen, keyboardHeight) {
      if (isOpen) {
        this.$.footerCreate.setShowing(false);
        return this.$.scroller.applyStyle("bottom", (keyboardHeight || 0) + "px");
      } else {
        this.$.footerCreate.setShowing(true);
        return this.$.scroller.applyStyle("bottom", "50px");
      }
    },

    /*
      * Triggered when inputs receive focus
     */
    _receiveFocus: function(inSender, inEvent) {
      return setTimeout(Uju.bind(this, function() {
        return this.$.scroller.scrollToControl(inSender.parent);
      }), 250);
    },
    save: function() {
      var email, emails, isEmail_re, payload, txt, _i, _len;
      if (this.entry.sharee == null) {
        txt = this.$.emails.getValue().trim();
        if (txt) {
          emails = txt.split(" ");
          for (_i = 0, _len = emails.length; _i < _len; _i++) {
            email = emails[_i];
            isEmail_re = /^\s*[\w\-\+_]+(\.[\w\-\+_]+)*\@[\w\-\+_]+\.[\w\-\+_]+(\.[\w\-\+_]+)*\s*$/;
            if (isEmail_re.test(email) !== true) {
              navigator.notification.alert(Ubidreams._i18n.get("incorrect_notify_email", [email]), null, Ubidreams._i18n.get("share_error"));
              return;
            }
          }
          payload = {
            emails: emails,
            message: this.$.message.getValue(),
            shareType: this.$.rights.getValue()
          };
          return enyo.Signals.send("showModal", {
            clean: false,
            modal: {
              kind: "NumSync.Notification",
              type: NumSync.Notification.types.PENDING,
              message: Ubidreams._i18n.get("save_pending")
            },
            callback: Uju.bind(this, function(modal) {
              return this._call("_addSharees", this.entry, payload, modal);
            })
          });
        } else {
          navigator.notification.alert(Ubidreams._i18n.get("no_email", [email]), null, Ubidreams._i18n.get("share_error"));
        }
      } else {
        return this._call("updateShare", {
          shareType: this.$.rights.getValue(),
          email: this.sharee.email,
          shareId: this.entry._share_.id
        });
      }
    }
  });

  enyo.kind({
    name: "NumSync.modals.Sharing_Right",
    classes: "sharing-rights panel panel-default",
    published: {
      modification: false
    },
    components: [
      {
        classes: "panel-heading",
        components: [
          {
            name: "title",
            tag: "h3",
            classes: "panel-title"
          }
        ]
      }, {
        tag: "ul",
        classes: "list-group",
        components: [
          {
            tag: "li",
            classes: "list-group-item",
            name: "readOnly",
            ontap: "switch",
            components: [
              {
                i18n: [
                  {
                    key: "modification_off"
                  }
                ]
              }, {
                tag: "i",
                classes: "fa fa-check-circle",
                showing: false,
                name: "readOnlyImg"
              }
            ]
          }, {
            tag: "li",
            classes: "list-group-item",
            ontap: "switch",
            name: "modification",
            components: [
              {
                i18n: [
                  {
                    key: "modification_on"
                  }
                ]
              }, {
                tag: "i",
                classes: "fa fa-check-circle",
                showing: false,
                name: "modificationImg"
              }
            ]
          }
        ]
      }
    ],
    create: function() {
      this.inherited(arguments);
      return this.modificationChanged();
    },
    modificationChanged: function() {
      this.$.modificationImg.setShowing(this.modification);
      return this.$.readOnlyImg.setShowing(!this.modification);
    },
    getValue: function() {
      if (this.modification) {
        return NumSync.models.Share.rights.WRITE;
      } else {
        return NumSync.models.Share.rights.READ;
      }
    },
    "switch": function(inSender, inEvent) {
      return this.setModification(inSender.name === "modification");
    },
    setShareeMail: function(email) {
      if (email != null) {
        return this.$.title.setContent(Ubidreams._i18n.get("rights_for", [email]));
      } else {
        return this.$.title.setContent(Ubidreams._i18n.get("rights"));
      }
    }
  });

}).call(this);
