// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.UploadPanel = (_ref1 = scope.NumSync.UploadPanel) != null ? _ref1 : {};

  scope.NumSync.UploadPanel.impl = (function(_super) {
    __extends(impl, _super);

    function impl() {
      impl.__super__.constructor.call(this);
      this.ui = "NumSync.UploadPanel.ui";
      this.i18n = null;
      this.hUp = null;
      return;
    }

    impl.prototype.configure = function(hub, configuration) {
      impl.__super__.configure.call(this, hub, configuration);
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.Upload.contract,
        field: "hUp"
      });
      this.hub.subscribe(this, "Upload/updateView", Uju.bind(this, this._updateView));
    };

    impl.prototype.start = function() {
      impl.__super__.start.call(this);
      this.widget.setUploading(this.hUp.getUploadingForView());
      this.widget.setQueue(this.hUp.getQueueForView());
      this.hUp.setProgressTracker(Uju.bind(this, this._onUploadProgress));
      this.i18n.i18nForEnyo(this.widget);
    };

    impl.prototype.stop = function() {
      this.hUp.setProgressTracker(null);
      return impl.__super__.stop.call(this);
    };

    impl.prototype._onUploadProgress = function(progressEvent) {
      if (progressEvent.lengthComputable) {
        return this.widget.setPercentage(Math.floor(progressEvent.loaded / progressEvent.total * 100));
      } else {
        return console.warn("Can't display upload progress (but it's uploading)");
      }
    };

    impl.prototype._updateView = function(inEvent) {
      if (inEvent.queue != null) {
        this.widget.setQueue(inEvent.queue);
      }
      if (inEvent.uploading != null) {
        return this.widget.setUploading(inEvent.uploading);
      } else if (inEvent.uploading === null) {
        return this.widget.uploadDone();
      }
    };

    return impl;

  })(scope.Ubidreams.widgets.Abstract.impl);

  enyo.kind({
    name: "NumSync.UploadPanel.ui",
    kind: "Ubidreams.widgets.Modals",
    classes: "modals-level2 modal-upload",
    swipe: true,
    start: "right",
    scrim: false,
    fullscreen: true,
    _kind: "NumSync.UploadPanel",
    components: [
      {
        classes: "pages-header",
        components: [
          {
            name: "pushMenu",
            tag: "i",
            classes: "btn-left fa fa-bars",
            ontap: "_openMenu"
          }, {
            tag: "h1",
            i18n: [
              {
                key: "upload_title"
              }
            ],
            classes: "title"
          }
        ]
      }, {
        kind: "Ubidreams.Scroller",
        top: "60px",
        components: [
          {
            classes: "panel panel-default",
            components: [
              {
                classes: "panel-heading",
                components: [
                  {
                    tag: "h3",
                    classes: "panel-title",
                    i18n: [
                      {
                        key: "uploading"
                      }
                    ]
                  }
                ]
              }, {
                name: "uploading",
                classes: "panel-body",
                showing: false,
                components: [
                  {
                    kind: "NumSync.Entry",
                    name: "uploadingEntry",
                    button: NumSync.Entry.actions.NONE
                  }, {
                    classes: "progress progress-striped active",
                    components: [
                      {
                        name: "progressBar",
                        classes: "progress-bar progress-bar-info",
                        style: "width: 0",
                        components: [
                          {
                            name: "progress",
                            tag: "span",
                            i18n: [
                              {
                                key: "uploading_status",
                                variables: [0]
                              }
                            ]
                          }
                        ]
                      }
                    ]
                  }
                ]
              }, {
                name: "uploading_placeholder",
                classes: "placeholder",
                components: [
                  {
                    tag: "i",
                    classes: "fa fa-info-circle"
                  }, {
                    tag: "span",
                    i18n: [
                      {
                        key: "no_uploading"
                      }
                    ]
                  }
                ]
              }
            ]
          }, {
            classes: "panel panel-default",
            components: [
              {
                classes: "panel-heading",
                components: [
                  {
                    name: "queue_title",
                    tag: "h3",
                    classes: "panel-title",
                    i18n: [
                      {
                        key: "uploading_queue",
                        variables: [2]
                      }
                    ]
                  }
                ]
              }, {
                name: "queue",
                tag: "ul",
                classes: "list-group"
              }, {
                name: "queue_placeholder",
                classes: "placeholder",
                components: [
                  {
                    tag: "i",
                    classes: "fa fa-info-circle"
                  }, {
                    tag: "span",
                    i18n: [
                      {
                        key: "no_uploading_queue"
                      }
                    ]
                  }
                ]
              }
            ]
          }
        ]
      }
    ],
    _openMenu: function(inSender, inEvent) {
      return enyo.Signals.send("showPushMenu", {});
    },
    uploadDone: function() {
      this.setPercentage(100);
      this.setUploading(null);
      this.$.uploading.hide();
      return this.$.uploading_placeholder.show();
    },
    setPercentage: function(value) {
      this.$.progressBar.applyStyle("width", "" + value + "%");
      return Ubidreams._i18n.setKey(this.$.progress, "content", "uploading_status", {
        variables: [value]
      });
    },
    setUploading: function(entry) {
      if (entry != null) {
        this.$.uploading.show();
        this.$.uploading_placeholder.hide();
      }
      this.$.uploadingEntry.setEntry(entry);
      return this.setPercentage(0);
    },
    setQueue: function(entries) {
      var entry, _i, _len;
      this.$.queue.destroyClientControls();
      for (_i = 0, _len = entries.length; _i < _len; _i++) {
        entry = entries[_i];
        this.$.queue.createComponent({
          kind: "NumSync.Entry",
          entry: entry,
          button: NumSync.Entry.actions.NONE
        }).render();
      }
      this.$.queue_placeholder.setShowing(entries.length === 0);
      return Ubidreams._i18n.setKey(this.$.queue_title, "content", "uploading_queue", {
        variables: [entries.length]
      });
    }
  });

}).call(this);
