// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.CreateAccount = (_ref1 = scope.NumSync.CreateAccount) != null ? _ref1 : {};

  scope.NumSync.CreateAccount.impl = (function(_super) {
    __extends(impl, _super);

    function impl() {
      impl.__super__.constructor.call(this);
      this.ui = "NumSync.modals.createAccount";
      return;
    }

    impl.prototype.configure = function(hub, configuration) {
      impl.__super__.configure.call(this, hub, configuration);
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.BrowserStorage.contract,
        field: "h_BS"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.RESTapi.contract,
        field: "hRest"
      });
      this.hub.requireService({
        component: this,
        contract: scope.AjaxService.contract,
        field: "hAjax"
      });
      this.hub.subscribe(this, "app/keyboard", Uju.bind(this, this._onKeyboard));
    };

    impl.prototype.start = function() {
      impl.__super__.start.call(this);
      this.widget.language = this.i18n.getLanguage();
      return this.i18n.i18nForEnyo(this.widget);
    };

    impl.prototype._checkForm = function(formData) {
      var hasError, isEmail_re;
      hasError = false;
      if (!formData.firstname) {
        this.widget._setError("firstname", this.i18n.getTranslation("firstnameError"));
        hasError = true;
      } else {
        this.widget._setError("firstname", null);
      }
      if (!formData.lastname) {
        this.widget._setError("lastname", this.i18n.getTranslation("lastnameError"));
        hasError = true;
      } else {
        this.widget._setError("lastname", null);
      }
      isEmail_re = /^\s*[\w\-\+_]+(\.[\w\-\+_]+)*\@[\w\-\+_]+\.[\w\-\+_]+(\.[\w\-\+_]+)*\s*$/;
      if (isEmail_re.test(formData.email) !== true) {
        this.widget._setError("email", this.i18n.getTranslation("invalid_email"));
        hasError = true;
      } else {
        this.widget._setError("email", null);
      }
      if (formData.pw.length < 6) {
        this.widget._setError("pw", this.i18n.getTranslation("pw_too_short", [6]));
        hasError = true;
      } else {
        this.widget._setError("pw", null);
      }
      if (formData.pw !== formData.pw2) {
        hasError = true;
        this.widget._setError("pw2", this.i18n.getTranslation("pw_different"));
      } else {
        this.widget._setError("pw2", null);
      }
      if (!hasError) {
        this._formToSend = {
          login: formData.email,
          password: formData.pw,
          name: formData.lastname,
          firstName: formData.firstname,
          locale: formData.language,
          timeZone: formData.timezone
        };
      }
      return !hasError;
    };

    impl.prototype._submitForm = function(data) {
      if (this._formToSend == null) {
        this._formToSend = data;
      }
      if (this._formToSend != null) {
        this.hRest.createAccount(this._formToSend, Uju.bind(this, function(response) {
          if (response.error != null) {
            return this.widget._onCreationFail(response.error.message);
          } else {
            return this.widget._onCreation();
          }
        }));
        return this._formToSend = null;
      } else {
        throw "CreateAccount :: _submitForm :: Nothing to submit";
      }
    };

    impl.prototype._setLanguage = function(language) {
      this.h_BS.set("language", language);
      return this.i18n.setLanguage(language);
    };

    impl.prototype._onKeyboard = function(event) {
      return this.widget.keyboardIsOpen(event.isOpen, event.keyboardHeight);
    };

    return impl;

  })(scope.Ubidreams.widgets.Abstract.impl);

  enyo.kind({
    name: "NumSync.modals.createAccount",
    kind: "Ubidreams.widgets.Modals",
    id: "create-account-modal",
    classes: "modals-level2",
    start: "right",
    swipe: true,
    scrim: false,
    fullscreen: true,
    language: void 0,
    _flagsSlider: null,
    _currentStreight: 0,
    _error: false,
    components: [
      {
        classes: "modals-header",
        components: [
          {
            classes: "title",
            i18n: [
              {
                key: "create_account"
              }
            ]
          }, {
            tag: "i",
            classes: "btn-right fa fa-times",
            ontap: "close"
          }
        ]
      }, {
        name: "scroller",
        kind: "Ubidreams.Scroller",
        top: "60px",
        bottom: "50px",
        components: [
          {
            classes: "modals-body",
            components: [
              {
                classes: "error-zone clearfix",
                name: "error",
                showing: false
              }, {
                classes: "row",
                components: [
                  {
                    tag: "label",
                    classes: "col-sm-3",
                    i18n: [
                      {
                        key: "firstname"
                      }
                    ]
                  }, {
                    classes: "col-sm-9",
                    components: [
                      {
                        name: "firstname",
                        kind: "enyo.Input",
                        classes: "form-control",
                        i18n: [
                          {
                            key: "firstname",
                            setter: "placeholder"
                          }
                        ],
                        onfocus: "_receiveFocus"
                      }
                    ]
                  }
                ]
              }, {
                name: "firstnameError",
                classes: "form-error",
                showing: false
              }, {
                classes: "row",
                components: [
                  {
                    tag: "label",
                    classes: "col-sm-3",
                    i18n: [
                      {
                        key: "lastname"
                      }
                    ]
                  }, {
                    classes: "col-sm-9",
                    components: [
                      {
                        name: "lastname",
                        kind: "enyo.Input",
                        classes: "form-control",
                        i18n: [
                          {
                            key: "lastname",
                            setter: "placeholder"
                          }
                        ],
                        onfocus: "_receiveFocus"
                      }
                    ]
                  }
                ]
              }, {
                name: "lastnameError",
                classes: "form-error",
                showing: false
              }, {
                classes: "row",
                components: [
                  {
                    tag: "label",
                    classes: "col-sm-3",
                    content: "E-mail"
                  }, {
                    classes: "col-sm-9",
                    components: [
                      {
                        name: "email",
                        kind: "enyo.Input",
                        type: "email",
                        classes: "form-control",
                        i18n: [
                          {
                            key: "example_mail",
                            setter: "placeholder"
                          }
                        ],
                        onfocus: "_receiveFocus"
                      }
                    ]
                  }
                ]
              }, {
                name: "emailError",
                classes: "form-error",
                showing: false
              }, {
                classes: "row",
                components: [
                  {
                    tag: "label",
                    classes: "col-sm-3",
                    i18n: [
                      {
                        key: "pw_placeholder"
                      }
                    ]
                  }, {
                    classes: "col-sm-9",
                    components: [
                      {
                        name: "pw",
                        kind: "enyo.Input",
                        type: "password",
                        classes: "form-control",
                        i18n: [
                          {
                            key: "minimum_char",
                            setter: "placeholder",
                            variables: [6]
                          }
                        ],
                        oninput: "_passwordStrength",
                        onfocus: "_receiveFocus"
                      }
                    ]
                  }
                ]
              }, {
                name: "pwError",
                classes: "form-error",
                showing: false
              }, {
                classes: "row",
                components: [
                  {
                    tag: "label",
                    classes: "col-sm-3",
                    content: "Confirmation"
                  }, {
                    classes: "col-sm-9",
                    components: [
                      {
                        name: "pw2",
                        kind: "enyo.Input",
                        type: "password",
                        classes: "form-control",
                        i18n: [
                          {
                            key: "minimum_char",
                            setter: "placeholder",
                            variables: [6]
                          }
                        ],
                        onfocus: "_receiveFocus"
                      }
                    ]
                  }
                ]
              }, {
                name: "pw2Error",
                classes: "form-error",
                showing: false
              }, {
                classes: "row",
                components: [
                  {
                    classes: "col-sm-offset-3 col-sm-9 pwd-strength",
                    components: [
                      {
                        name: "weak",
                        classes: "weak",
                        i18n: [
                          {
                            key: "weak"
                          }
                        ]
                      }, {
                        name: "medium",
                        classes: "medium",
                        i18n: [
                          {
                            key: "average"
                          }
                        ]
                      }, {
                        name: "strong",
                        classes: "strong",
                        i18n: [
                          {
                            key: "strong"
                          }
                        ]
                      }
                    ]
                  }
                ]
              }, {
                classes: "row",
                components: [
                  {
                    tag: "label",
                    classes: "col-sm-3",
                    i18n: [
                      {
                        key: "language"
                      }
                    ]
                  }, {
                    name: "language",
                    kind: "NumSync.FlagCarousel",
                    classes: "col-sm-9",
                    onChange: "_languageChanged"
                  }
                ]
              }, {
                name: "langError",
                classes: "form-error",
                showing: false
              }, {
                classes: "row",
                components: [
                  {
                    tag: "label",
                    classes: "col-sm-3",
                    i18n: [
                      {
                        key: "timezone"
                      }
                    ]
                  }, {
                    classes: "col-sm-9",
                    components: [
                      {
                        name: "tzwrapper",
                        classes: "styled-select"
                      }
                    ]
                  }
                ]
              }
            ]
          }
        ]
      }, {
        name: "footer",
        classes: "modals-footer",
        components: [
          {
            name: "btnSubmit",
            allowHtml: true,
            classes: "btn btn-default btn-lg btn-block",
            status: 0,
            i18n: [
              {
                key: "save"
              }
            ],
            ontap: "_validate"
          }
        ]
      }
    ],
    rendered: function() {
      this.inherited(arguments);
      this.$.language.setValue(this.language);
      return this._fillTimezone();
    },

    /*
      * Show or hide footer bar according to the keyboard state
     */
    keyboardIsOpen: function(isOpen, keyboardHeight) {
      if (isOpen) {
        this.$.footer.setShowing(false);
        return this.$.scroller.applyStyle("bottom", (keyboardHeight || 0) + "px");
      } else {
        this.$.footer.setShowing(true);
        return this.$.scroller.applyStyle("bottom", "50px");
      }
    },

    /*
      * Triggered when inputs receive focus
     */
    _receiveFocus: function(inSender, inEvent) {
      return setTimeout(Uju.bind(this, function() {
        return this.$.scroller.scrollToControl(inSender.parent.parent);
      }), 250);
    },

    /*
      * Calculate password strength
     */
    _passwordStrength: function(inSender) {
      var mediumRegex, password, strongRegex, weakRegex;
      strongRegex = new RegExp("^(?=.{8,})(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9])(?=.*\\W).*$", "g");
      mediumRegex = new RegExp("^(?=.{7,})(((?=.*[A-Z])(?=.*[a-z]))|((?=.*[A-Z])(?=.*[0-9]))|((?=.*[a-z])(?=.*[0-9]))).*$", "g");
      weakRegex = new RegExp("(?=.{6,}).*", "g");
      this._cleanStreight();
      password = inSender.getValue();
      if (password === "") {
        return;
      }
      if (strongRegex.test(password)) {
        return this._applyStrong();
      } else if (mediumRegex.test(password)) {
        return this._applyMedium();
      } else if (weakRegex.test(password)) {
        return this._applyWeak();
      } else {
        return this._applyWeak();
      }
    },

    /*
      * Fill timezone list
     */
    _fillTimezone: function() {
      var list;
      this.$.tzwrapper.destroyClientControls();
      list = this.createComponent({
        container: this.$.tzwrapper,
        kind: "enyo.Select",
        name: "timezone",
        components: NumSync.config.TIMEZONES
      });
      list.render();
      return list.setSelected(43);
    },

    /*
      * Reset password strength indicator
     */
    _cleanStreight: function() {
      this.$.weak.removeClass("active");
      this.$.medium.removeClass("active");
      return this.$.strong.removeClass("active");
    },
    _applyWeak: function() {
      return this.$.weak.addClass("active");
    },
    _applyMedium: function() {
      this.$.weak.addClass("active");
      return this.$.medium.addClass("active");
    },
    _applyStrong: function() {
      this.$.weak.addClass("active");
      this.$.medium.addClass("active");
      return this.$.strong.addClass("active");
    },

    /*
      * Check form
     */
    _validate: function(inSender, inEvent) {
      if (inSender.status !== 0) {
        return;
      }
      if (this._call("_checkForm", {
        firstname: this.$.firstname.getValue(),
        lastname: this.$.lastname.getValue(),
        email: this.$.email.getValue(),
        pw: this.$.pw.getValue(),
        pw2: this.$.pw2.getValue(),
        language: this.$.language.getValue(),
        timezone: this.$.timezone.getValue()
      }) === true) {
        this._setButton(1);
        return this._call("_submitForm");
      }
    },

    /*
      * Add/remove a form error
      * @param control: <string> the name of the enyo input
      * @param message: <string> the error message or null if no error
     */
    _setError: function(controlName, message) {
      var control, errorContorl;
      control = this.$[controlName];
      errorContorl = this.$[controlName + "Error"];
      errorContorl.destroyClientControls();
      if (message == null) {
        control.addRemoveClass("invalid", false);
        return errorContorl.hide();
      } else {
        this._error = true;
        control.addRemoveClass("invalid", true);
        errorContorl.show();
        errorContorl.createComponent({
          tag: "i",
          classes: "fa fa-exclamation-triangle"
        }).render();
        errorContorl.createComponent({
          tag: "span",
          content: message
        }).render();
        if (control === this.$.pw || control === this.$.pw2) {
          this.$.pw.setValue("");
          this.$.pw.addRemoveClass("invalid", true);
          this.$.pw2.setValue("");
          return this.$.pw2.addRemoveClass("invalid", true);
        }
      }
    },

    /*
      * Called when the creation has succeeded
     */
    _onCreation: function() {
      this._clearForm();
      this._setButton(0);
      return enyo.Signals.send("showModal", {
        clean: true,
        modal: {
          kind: "NumSync.Notification",
          type: NumSync.Notification.types.SUCCESS,
          message: Ubidreams._i18n.get("account_created"),
          timeout: 30000
        }
      });
    },

    /*
      * Called when the creation has failed
      * @param error: <string> error message
     */
    _onCreationFail: function(error) {
      this.$.scroller.scrollToTop();
      this._setButton(0);
      this.$.error.destroyClientControls();
      this.$.error.createComponents([
        {
          classes: "pull-left",
          components: [
            {
              tag: "i",
              classes: "fa fa-meh-o"
            }
          ]
        }, {
          classes: "pull-left",
          components: [
            {
              tag: "b",
              content: Ubidreams._i18n.get("error_unknown") + ". "
            }, {
              tag: "br"
            }, {
              tag: null,
              content: error != null ? error : Ubidreams._i18n.get("error_unknown")
            }
          ]
        }
      ]);
      this.$.error.render();
      return this.$.error.show();
    },

    /*
      * Upate the submit button
      * @param status: <int>
      *   0: default, click to submit
      *   1: loading, click disabled
     */
    _setButton: function(status) {
      switch (status) {
        case 0:
          this.$.btnSubmit.setContent(Ubidreams._i18n.get("save"));
          break;
        case 1:
          this.$.btnSubmit.setContent(Ubidreams._i18n.get("sending"));
      }
      return this.$.btnSubmit.status = status;
    },

    /*
      * Empty form inputs
     */
    _clearForm: function() {
      this.$.firstname.setValue("");
      this.$.lastname.setValue("");
      this.$.email.setValue("");
      this.$.pw.setValue("");
      return this.$.pw2.setValue("");
    },
    _languageChanged: function(inSender, inEvent) {
      return this._call("_setLanguage", inEvent.language);
    }
  });

}).call(this);
