// Generated by CoffeeScript 1.7.1
(function() {
  enyo.kind({
    name: "NumSync.models.File",
    kind: "NumSync.models.Entry",
    published: {
      idCloudFolder: void 0,
      path: void 0,
      size: void 0,
      lastModified: void 0,
      _link_: void 0,
      _parent_: void 0
    },
    create: function() {
      this.inherited(arguments);
      return this.setType(NumSync.models.Entry.types.FILE);
    },
    getEntryName: function() {
      return this.path.split("/").pop();
    },

    /*
      * Convert number of bytes into human readable format
      * @param <int> precision: [DEFAULT=2] Number of digits after the decimal separator
      * @return string
     */
    getSizeStr: function(precision) {
      var bytes, gigabyte, kilobyte, megabyte, terabyte;
      if (precision == null) {
        precision = 2;
      }
      bytes = this.size;
      kilobyte = 1024;
      megabyte = kilobyte * 1024;
      gigabyte = megabyte * 1024;
      terabyte = gigabyte * 1024;
      if ((bytes >= 0) && (bytes < kilobyte)) {
        return bytes + " B";
      } else if ((bytes >= kilobyte) && (bytes < megabyte)) {
        return (bytes / kilobyte).toFixed(precision) + " KB";
      } else if ((bytes >= megabyte) && (bytes < gigabyte)) {
        return (bytes / megabyte).toFixed(precision) + " MB";
      } else if ((bytes >= gigabyte) && (bytes < terabyte)) {
        return (bytes / gigabyte).toFixed(precision) + " GB";
      } else if (bytes >= terabyte) {
        return (bytes / terabyte).toFixed(precision) + " TB";
      } else {
        return bytes + " B";
      }
    }
  });

}).call(this);
