// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.HomePage = (_ref1 = scope.NumSync.HomePage) != null ? _ref1 : {};

  scope.NumSync.HomePage.contract = {
    getCurrentFolderInfos: function() {}
  };

  scope.NumSync.HomePage.impl = (function(_super) {
    __extends(impl, _super);

    function impl() {
      impl.__super__.constructor.call(this);
      this.ui = "NumSync.filesTree.Main";
      this.contract = scope.NumSync.HomePage.contract;
      this.i18n = void 0;
      this.hFM = void 0;
      this.hIH = void 0;
      this.hEH = void 0;
      this.hCW = void 0;
      this.i18n = void 0;
      this._sharedFolders = [];
      return;
    }

    impl.prototype.configure = function(hub, configuration) {
      var _ref2;
      impl.__super__.configure.call(this, hub, configuration);
      this._filter = ((_ref2 = configuration.data) != null ? _ref2.filter : void 0) || "all";
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.FileManager.contract,
        field: "hFM"
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.ImportHandler.contract,
        field: "hIH"
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.EntryHelper.contract,
        field: "hEH"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.ConnectivityWatcher.contract,
        field: "hCW"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
      this.hub.subscribe(this, "ConnectivityWatcher/connection/lost", Uju.bind(this, function() {
        return this._onConnectionChange(false);
      }));
      return this.hub.subscribe(this, "ConnectivityWatcher/connection/recovered", Uju.bind(this, function() {
        return this._onConnectionChange(true);
      }));
    };

    impl.prototype.start = function() {
      impl.__super__.start.call(this);
      this.hub.subscribe(this, "FilesTreeLight/closed", Uju.bind(this.widget, this.widget._bindBackButton));
      if (this.widget.getLight() === false) {
        document.addEventListener("resume", Uju.bind(this, this._checkImport), false);
      }
      this._checkImport();
      this.widget.setFilter(this._filter);
      this._getRootFolders(Uju.bind(this.widget, this.widget.initWithRootFolders), Uju.bind(this, function(error) {
        this.widget.noContentFromFS();
        return enyo.Signals.send("showModal", {
          clean: false,
          modal: {
            kind: "NumSync.Notification",
            type: NumSync.Notification.types.ERROR,
            message: this.i18n.getTranslation("error_retrieve_home", [error])
          }
        });
      }));
      if (this.hCW != null) {
        return this._onConnectionChange(this.hCW.hasConnection());
      } else {
        return this._onConnectionChange(true);
      }
    };


    /*
      * Get current folder infos : return payload from an Entry model
     */

    impl.prototype.getCurrentFolderInfos = function() {
      return this.widget.getCurrentFolderEntry();
    };


    /*
      * Check import with ImportHandler component
     */

    impl.prototype._checkImport = function() {
      if (this.widget.getLight() === false) {
        return this.hIH.checkImport();
      }
    };


    /*
      * Triggered when connection has changed
      * @param <boolean> isOnline
     */

    impl.prototype._onConnectionChange = function(isOnline) {
      return this.widget.disableActionButtonFromHeader(!isOnline);
    };


    /*
      * Request open entry (called from files tree kind)
      * @param <json> entry
      * @param <function> opts : options with callbacks
     */

    impl.prototype._requestOpenEntry = function(entry, opts) {
      return this.hEH.openEntry(entry, opts);
    };


    /*
      * Request remove entries (called from files tree kind)
      * @param <array[<json>]> entries
     */

    impl.prototype._requestRemoveEntries = function(entries) {
      return this.hEH.removeEntries(entries);
    };


    /*
      * Request move entries (called from files tree kind)
      * @param <array[<json>]> entries
     */

    impl.prototype._requestMoveEntries = function(entries) {
      return this.hEH.moveEntries(entries);
    };


    /*
      * Get root folders from FileManager
      * @param <function> complete
     */

    impl.prototype._getRootFolders = function(onSuccess, onError) {
      return async.waterfall([
        Uju.bind(this, function(callback) {
          return this.hFM.getRootFolders({
            onSuccess: function(folders) {
              return callback(null, folders);
            },
            onError: function(error) {
              return callback(error);
            }
          });
        }), Uju.bind(this, function(folders, callback) {
          return this.hFM.getShares({
            onSuccess: Uju.bind(this, function(sharedFolders) {
              var folder, parallel, share, sharedFoldersToMe, _i, _j, _len, _len1;
              this._sharedFolders = [];
              sharedFoldersToMe = [];
              for (_i = 0, _len = sharedFolders.length; _i < _len; _i++) {
                folder = sharedFolders[_i];
                if (!folder.mine) {
                  sharedFoldersToMe.push(folder);
                } else {
                  this._sharedFolders.push(folder);
                }
              }
              parallel = [];
              for (_j = 0, _len1 = sharedFoldersToMe.length; _j < _len1; _j++) {
                share = sharedFoldersToMe[_j];
                parallel.push(Uju.bind(this, function(share_, callback_) {
                  if (share_.path === ".") {
                    return this.hFM.getRootFolderInfo(share_.idCloudFolder, {
                      onSuccess: function(cloudFolder) {
                        share_._parent_ = cloudFolder.name;
                        return callback_(null, share_);
                      },
                      onError: function() {
                        callback_(null, share_);
                        return console.warn("HomePage :: _getRootFolders :: Can't retrieve name for shared cloud folder id " + share_.idCloudFolder);
                      }
                    });
                  } else {
                    return callback_(null, share_);
                  }
                }, share));
              }
              return async.parallel(parallel, Uju.bind(this, function(err, results) {
                return callback(null, folders.concat(results));
              }));
            }),
            onError: function(error) {
              return callback(error);
            }
          });
        })
      ], function(error, folders) {
        if (error == null) {
          return onSuccess(folders);
        } else {
          return onError(error);
        }
      });
    };


    /*
      * Get folder content from FileManager
      * @param <string> cloudFolderId: a cloud folder ID
      * @param <string> path: a folder's subpath
      * @param <json> opts: onSuccess and onError callbacks
     */

    impl.prototype._getFolderContent = function(cloudFolderId, path, opts) {
      return this.hFM.getFolderContent(cloudFolderId, path, opts);
    };


    /*
      * Retrieve folders shared by me
      * @param <function> callback
     */

    impl.prototype._updateMyShares = function(callback) {
      return this.hFM.getShares({
        onSuccess: Uju.bind(this, function(shares) {
          var share, _i, _len;
          this._sharedFolders = [];
          for (_i = 0, _len = shares.length; _i < _len; _i++) {
            share = shares[_i];
            if (share.mine === true) {
              this._sharedFolders.push(share);
            }
          }
          return callback();
        }),
        onError: function() {
          return callback();
        }
      });
    };


    /*
      * Check if an entry is shared with users
      * @param <json> entry
     */

    impl.prototype._getShareForEntry = function(entry) {
      var share, _i, _len, _ref2;
      _ref2 = this._sharedFolders;
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        share = _ref2[_i];
        switch (entry.type) {
          case NumSync.models.Entry.types.FOLDER:
            if (entry.idCloudFolder === share.idCloudFolder && entry.path === share.path) {
              return share;
            }
            break;
          case NumSync.models.Entry.types.CLOUD_FOLDER:
            if (entry.id === share.idCloudFolder) {
              return share;
            }
        }
      }
      return void 0;
    };

    return impl;

  })(scope.Ubidreams.widgets.Abstract.impl);

}).call(this);
