// Generated by CoffeeScript 1.7.1
(function() {
  var scope, _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  scope = typeof window !== "undefined" && window !== null ? window : this;

  scope.NumSync = (_ref = scope.NumSync) != null ? _ref : {};

  scope.NumSync.LoginPage = (_ref1 = scope.NumSync.LoginPage) != null ? _ref1 : {};

  scope.NumSync.LoginPage.contract = {};

  scope.NumSync.LoginPage.impl = (function(_super) {
    __extends(impl, _super);

    impl.prototype.hBS = null;

    impl.prototype.hREST = null;

    impl.prototype.hUser = null;

    impl.prototype.hFM = null;

    impl.prototype.hCS = null;

    function impl() {
      impl.__super__.constructor.call(this);
      this.ui = "NumSync.LoginPage.ui";
      this.i18n = void 0;
      this.noInit = true;
    }

    impl.prototype.getComponentName = function() {
      return 'LoginPage';
    };

    impl.prototype.configure = function(hub, configuration) {
      impl.__super__.configure.call(this, hub, configuration);
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.BrowserStorage.contract,
        field: "hBS"
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.RESTapi.contract,
        field: "hREST"
      });
      this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.i18n.contract,
        field: "i18n"
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.FileManager.contract,
        field: "hFM"
      });
      this.hub.requireService({
        component: this,
        contract: scope.NumSync.UserInfo.contract,
        field: "hUser"
      });
      this.hub.requireService({
        component: this,
        contract: scope.ContextDetector.contract,
        field: "hCtx"
      });
      return this.hub.requireService({
        component: this,
        contract: scope.Ubidreams.ConnectivityWatcher.contract,
        field: "hCW"
      });
    };

    impl.prototype.start = function() {
      impl.__super__.start.call(this);
      return this._checkStoredData();
    };


    /*
      * Display enyo widget
     */

    impl.prototype._initWidget = function() {
      this.drawWidget();
      return this.i18n.i18nForEnyo(this.widget);
    };


    /*
      * Check stored data : user, token cookies
     */

    impl.prototype._checkStoredData = function() {
      var serverUrl, token, user;
      user = this.hUser.getUserData();
      serverUrl = scope.NumSync.config.NUMSYNC_API_BASEURL === 'null' ? this.hBS.get("hostname") : scope.NumSync.config.NUMSYNC_API_BASEURL;
      this.widget.restoreData(user != null ? user.login : void 0, user != null ? user.password : void 0, serverUrl);
      token = this.hBS.get("token");
      if (token) {
        if (!this.hCW.hasConnection()) {
          if (this.hBS.get("offline") !== "true") {
            this.widget.showNotification(NumSync.Notification.types.ERROR, this.i18n.getTranslation("auth_fail_offline_off"));
            return this._initWidget();
          } else {
            return this._login(user.id);
          }
        } else {
          if (token === "EXPIRED") {
            this.widget.showNotification(NumSync.Notification.types.EXPIRED, this.i18n.getTranslation("error_expired_token"));
            return this._initWidget();
          } else {
            this.hREST.setToken(token);
            return this._login(user.id);
          }
        }
      } else {
        return this._initWidget();
      }
    };


    /*
      * Check login method
      * @param <string> login
      * @param <string> password
      * @param <boolean> rememberMe
     */

    impl.prototype._saveHostname = function(hostname) {
      return this.hBS.set("hostname", hostname);
    };

    impl.prototype._tryLogin = function(login, password, rememberMe) {
      this.widget.showNotification(NumSync.Notification.types.PENDING, this.i18n.getTranslation("auth_loading"));
      return setTimeout(Uju.bind(this, function() {
        if (this.hCW.hasConnection()) {
          return this.hREST.auth({
            login: login,
            password: password
          }, rememberMe, Uju.bind(this, function(userId) {
            if (userId != null) {
              this.widget.showNotification(NumSync.Notification.types.SUCCESS, this.i18n.getTranslation("auth_success"));
              return this._login(userId);
            } else {
              return this.widget.showNotification(NumSync.Notification.types.ERROR, this.i18n.getTranslation("auth_fail"));
            }
          }));
        } else {
          return this.hUser.getUser(login, Uju.bind(this, function(user) {
            var data, _ref2;
            if (user != null) {
              if (password === user.password) {
                if (user.offline) {
                  this.i18n.setLanguage(user.language);
                  this.hBS.set("language", user.language);
                  this.hBS.set("offline", (_ref2 = user.offline) != null ? _ref2 : false);
                  this.hREST.setToken(this.hBS.get("token"));
                  data = {
                    login: login,
                    id: user.id
                  };
                  if (rememberMe === true) {
                    data.password = password;
                  }
                  this.hUser.setUserData(data);
                  this._login(data.id);
                  return this.widget.showNotification(NumSync.Notification.types.SUCCESS, this.i18n.getTranslation("login_offline"));
                } else {
                  return this.widget.showNotification(NumSync.Notification.types.ERROR, this.i18n.getTranslation("auth_fail_offline_off"));
                }
              } else {
                return this.widget.showNotification(NumSync.Notification.types.ERROR, this.i18n.getTranslation("auth_fail"));
              }
            } else {
              return this.widget.showNotification(NumSync.Notification.types.ERROR, this.i18n.getTranslation("auth_fail_offline"));
            }
          }));
        }
      }), 1000);
    };


    /*
      * Log the user redirecting to the home page
     */

    impl.prototype._login = function(id) {
      var showApp;
      showApp = Uju.bind(this, function() {
        this.hub.unregisterComponent(this);
        return this.hub.registerComponent(new scope.NumSync.Main.impl(), {
          container: "body",
          emptyContainer: false
        });
      });
      if (this.hCtx.isHybrid()) {
        return this.hFM.init(id, {
          onSuccess: showApp,
          onError: function() {
            return navigator.notification.alert("An error happened while initializing file system. Please contact the support.");
          }
        });
      } else {
        return showApp();
      }
    };

    return impl;

  })(scope.Ubidreams.widgets.Abstract.impl);

  enyo.kind({
    name: "NumSync.LoginPage.ui",
    id: "login-page",
    classes: "app-pages",
    components: [
      {
        classes: "pages-header",
        components: [
          {
            kind: "enyo.Image",
            classes: "company-logo",
            src: "Resources/logo_app.png"
          }
        ]
      }, {
        kind: "Ubidreams.Scroller",
        top: "60px",
        components: [
          {
            id: "login-form",
            components: [
              {
                id: "input_login",
                name: "login",
                kind: "enyo.Input",
                type: "email",
                classes: "form-control",
                placeholder: "Login",
                value: "",
                oninput: "_checkPlaceholder",
                selectOnFocus: true
              }, {
                name: "password",
                kind: "enyo.Input",
                type: "password",
                classes: "form-control",
                value: "",
                oninput: "_checkPlaceholder",
                i18n: [
                  {
                    setter: "placeholder",
                    key: "pw_placeholder"
                  }
                ],
                selectOnFocus: true
              }, {
                name: "hostname",
                kind: "enyo.Input",
                type: "text",
                classes: "form-control",
                value: "",
                oninput: "_checkPlaceholder",
                i18n: [
                  {
                    setter: "placeholder",
                    key: "hostname"
                  }
                ],
                selectOnFocus: true
              }, {
                components: [
                  {
                    name: "rememberMe",
                    kind: "enyo.Checkbox",
                    id: "rememberme"
                  }, {
                    tag: "label",
                    attributes: {
                      "for": "rememberme"
                    },
                    i18n: [
                      {
                        key: "rememberMe"
                      }
                    ]
                  }
                ]
              }, {
                classes: "help-links",
                i18n: [
                  {
                    key: "forgotten_pw"
                  }
                ],
                ontap: "_requestShowModal",
                modal: {
                  className: "NumSync.sendPassword"
                }
              }, {
                classes: "btn btn-primary btn-block",
                i18n: [
                  {
                    key: "connection"
                  }
                ],
                ontap: "_submitForm"
              }
            ]
          }
        ]
      }
    ],

    /*
      * Show a notfication modal for authentification status
      * @param <int> type : type of notification (PENDING, SUCCESS, ERROR, EXPIRED)
      * @param <string> message
     */
    showNotification: function(type, message) {
      return enyo.Signals.send("showModal", {
        clean: true,
        modal: {
          kind: "NumSync.Notification",
          type: type,
          message: message
        }
      });
    },

    /*
      * Restore registrered user data
      * @param <string> login
      * @param <string> password
     */
    restoreData: function(login, password, hostname) {
      if (login && password) {
        this.$.login.setValue(login);
        this.$.password.setValue(password);
        this.$.rememberMe.setChecked(true);
        this._checkPlaceholder(this.$.login);
        this._checkPlaceholder(this.$.password);
      }
      if (hostname) {
        this.$.hostname.setValue(hostname);
        if (scope.NumSync.config.NUMSYNC_API_BASEURL !== 'null') {
          this.$.hostname.addRemoveClass("hidden", true);
        }
        return this._checkPlaceholder(this.$.hostname);
      }
    },

    /*
      * Triggered when login button is clicked
     */
    _submitForm: function(inSender, inEvent) {
      var invalid;
      invalid = false;
      if (this.$.login.getValue().trim() === "") {
        this.$.login.addRemoveClass("invalid", true);
        invalid = true;
      } else {
        this.$.login.addRemoveClass("invalid", false);
      }
      if (this.$.password.getValue().trim() === "") {
        this.$.password.addRemoveClass("invalid", true);
        invalid = true;
      } else {
        this.$.password.addRemoveClass("invalid", false);
      }
      if (!invalid) {
        this._loseFocus();
        scope.NumSync.config.NUMSYNC_API_BASEURL = this.$.hostname.getValue().trim();
        console.log("connecting to " + scope.NumSync.config.NUMSYNC_API_BASEURL);
        this._call("_saveHostname", scope.NumSync.config.NUMSYNC_API_BASEURL);
        return this._call("_tryLogin", this.$.login.getValue(), this.$.password.getValue(), this.$.rememberMe.getChecked());
      }
    },

    /*
      * Triggered when forgotten password or create account buttons are clicked
     */
    _requestShowModal: function(inSender, inEvent) {
      var _modal;
      if (Uju.isString(inSender.modal)) {
        _modal = {
          kind: "NumSync.modals." + inSender.modal
        };
      } else {
        _modal = inSender.modal;
      }
      return enyo.Signals.send("showModal", {
        clean: true,
        modal: _modal
      });
    },

    /*
      * Check if placeholder must be visible or not (fix for Android)
     */
    _checkPlaceholder: function(inSender, inEvent) {
      if (inSender._placeholder == null) {
        inSender._placeholder = inSender.placeholder;
      }
      if (inSender.value.length === 0) {
        return inSender.setPlaceholder(inSender._placeholder);
      } else {
        return inSender.setPlaceholder("");
      }
    },

    /*
      * Fix to close keyboard on iOS
     */
    _loseFocus: function() {
      this.$.login.hasNode().blur();
      return this.$.password.hasNode().blur();
    }
  });

}).call(this);
