// Generated by CoffeeScript 1.7.1
(function() {
  enyo.kind({
    name: "NumSync.Header.ui",
    classes: "pages-header",
    published: {
      title: null,
      type: null,
      onBackTap: null
    },
    components: [
      {
        kind: "enyo.Signals",
        updateHeader: "_onUpdateHeader"
      }, {
        kind: "enyo.Signals",
        onModalsClosed: "_onModalsClosed"
      }
    ],
    actionBtnDisabled: false,
    create: function() {
      this.inherited(arguments);
      this.bindBackButton();
      if ((this.title == null) && (this.type == null)) {
        return this._initDefaultHeader();
      }
    },
    titleChanged: function() {
      if (this.title === "DEFAULT") {
        this._initDefaultHeader();
      }
      return this.$.title.setContent(this.title);
    },
    typeChanged: function() {
      return this._initHeader(this.type, this.title);
    },
    bindBackButton: function(callback) {
      this.onBackTap = callback;
      return NumSync.backActions.homePage = Uju.bind(this, this._resetHeader);
    },
    disableActionButton: function(disable) {
      this.actionBtnDisabled = disable;
      if (disable) {
        return this._actionBtnDisabled();
      } else {
        return this._actionBtnEnabled();
      }
    },
    _initDefaultHeader: function() {
      this.title = Ubidreams._i18n.get("header_cloud");
      this.type = "files";
      return this._initHeader(this.type, this.title);
    },

    /*
      * @param <string> type : "files", "back", "selections"
      * @param <string> title
     */
    _initHeader: function(type, title) {
      this.destroyClientControls();
      switch (type) {
        case "files":
          this.createComponents([
            {
              name: "pushMenu",
              tag: "i",
              classes: "btn-left fa fa-bars",
              ontap: "_openMenu"
            }, {
              tag: "h1",
              name: "title",
              content: title,
              classes: "title"
            }, {
              name: "actionsMenu",
              tag: "i",
              classes: "btn-right fa fa-cog",
              ontap: "_openMenu"
            }
          ], {
            container: this
          });
          break;
        case "back":
          this.createComponents([
            {
              name: "pushMenu",
              tag: "i",
              classes: "btn-left fa fa-arrow-left",
              ontap: "_resetHeader"
            }, {
              tag: "h1",
              name: "title",
              content: title,
              classes: "title"
            }, {
              name: "actionsMenu",
              tag: "i",
              classes: "btn-right fa fa-cog",
              ontap: "_openMenu"
            }
          ], {
            container: this
          });
          break;
        case "selections":
          this.createComponents([
            {
              tag: "h1",
              name: "title",
              content: title,
              classes: "title"
            }, {
              tag: "i",
              classes: "btn-right fa fa-times",
              ontap: "_resetHeader"
            }
          ], {
            container: this
          });
          break;
        case "import":
          this.createComponents([
            {
              tag: "h1",
              name: "title",
              content: title,
              classes: "title"
            }, {
              tag: "i",
              classes: "btn-right fa fa-times",
              ontap: "_hideImportModal"
            }
          ], {
            container: this
          });
          break;
        case "back-import":
          this.createComponents([
            {
              name: "pushMenu",
              tag: "i",
              classes: "btn-left fa fa-arrow-left",
              ontap: "_resetHeader"
            }, {
              tag: "h1",
              name: "title",
              content: title,
              classes: "title"
            }, {
              tag: "i",
              classes: "btn-right fa fa-times",
              ontap: "_hideImportModal"
            }
          ], {
            container: this
          });
      }
      this.render();
      if (this.actionBtnDisabled) {
        return this._actionBtnDisabled();
      }
    },
    _onUpdateHeader: function(inSender, inEvent) {
      if (inEvent.title != null) {
        this.setTitle(inEvent.title);
      }
      if (inEvent.type != null) {
        return this.setType(inEvent.type);
      }
    },
    _actionBtnDisabled: function() {
      var _ref, _ref1;
      if ((_ref = this.$.actionsMenu) != null) {
        _ref.ontap = "";
      }
      return (_ref1 = this.$.actionsMenu) != null ? _ref1.applyStyle("opacity", 0.1) : void 0;
    },
    _actionBtnEnabled: function() {
      var _ref, _ref1;
      if ((_ref = this.$.actionsMenu) != null) {
        _ref.ontap = "_openMenu";
      }
      return (_ref1 = this.$.actionsMenu) != null ? _ref1.applyStyle("opacity", null) : void 0;
    },
    _openMenu: function(inSender, inEvent) {
      if (inSender.name === "actionsMenu") {
        enyo.Signals.send("showModal", {
          modal: {
            className: "NumSync.actionsMenu",
            config: {
              field: "actionsMenu"
            }
          }
        });
      }
      if (inSender.name === "pushMenu") {
        return enyo.Signals.send("showPushMenu", {});
      }
    },
    _resetHeader: function() {
      switch (this.type) {
        case "selections":
          enyo.Signals.send("requestSelections", {
            selecting: false
          });
          enyo.Signals.send("toggleFooter", {
            show: false
          });
          return true;
        case "back":
        case "back-import":
          if (this.onBackTap != null) {
            return this.onBackTap();
          }
          return false;
      }
      return false;
    },
    _hideImportModal: function() {
      return enyo.Signals.send("hideFilesTreeLight", {});
    }
  });

}).call(this);
