// Generated by CoffeeScript 1.7.1
(function() {
  enyo.kind({
    name: "Ubidreams.Scroller",
    kind: "enyo.Scroller",
    touch: true,
    horizontal: "hidden",
    classes: "ubi-scroller",
    style: "position: absolute; z-index: 1;",
    handlers: {
      ondragfinish: "_dragfinish"
    },
    published: {
      pullCallback: void 0
    },
    top: 0,
    bottom: 0,
    left: 0,
    right: 0,
    _loading: false,
    pullDiv: null,
    rendered: function() {
      this.inherited(arguments);
      this.applyStyle("top", this.top);
      this.applyStyle("bottom", this.bottom);
      this.applyStyle("left", this.left);
      this.applyStyle("right", this.right);
      return this.pullCallbackChanged();
    },

    /*
      * On scroll, update pull icon acording to the scroll position
     */
    scroll: function(inSender, inEvent) {
      var topOffset;
      if (!this._loading && (this.pullCallback != null)) {
        topOffset = inSender.getScrollTop();
        if (topOffset < 0) {
          this.pullDiv.setShowing(true);
          this.pullDiv.applyStyle("top", (topOffset * -1) + "px");
        } else {
          this.pullDiv.setShowing(false);
          this.pullDiv.applyStyle("top", null);
        }
        if (topOffset >= -50) {
          this.pullDiv.rotate(1);
        } else {
          this.pullDiv.rotate(2);
        }
      }
      return false;
    },

    /*
      * On dragfinish, if the scroll -offset is greater than the pull div height, then call load callback
     */
    _dragfinish: function(inSender) {
      var topOffset;
      if (!this._loading && (this.pullCallback != null)) {
        topOffset = inSender.getScrollTop();
        if (topOffset <= -50) {
          this._loading = true;
          this.pullDiv.applyStyle("top", null);
          this.pullDiv.rotate(3);
          this.addClass("refresh-active");
          if (this.pullDiv.getShowing() === true) {
            return this.pullCallback(enyo.bind(this, this._loadingOver, new Date().getTime()));
          }
        }
      }
    },

    /*
      * Called when laoding is over. Must be called from outside of the component
      * @param <int> start : refresh start time
      * @param <function> onEnd : triggered when pull to refresh animation is finished
     */
    _loadingOver: function(start) {
      var duration, end, timeout;
      end = new Date().getTime();
      duration = end - start;
      timeout = duration < 250 ? 250 - duration : 0;
      return setTimeout(Uju.bind(this, function() {
        this._loading = false;
        this.pullDiv.rotate(1);
        return this.removeClass("refresh-active");
      }), timeout);
    },

    /*
      * Create pull div when pull callback changes
     */
    pullCallbackChanged: function() {
      var container;
      if (Uju.isFunction(this.pullCallback)) {
        container = document.createElement("div");
        container.className = "scroller-pulldown";
        this.hasNode().appendChild(container);
        this.pullDiv = new Ubidreams.Scroller_PullElement();
        return this.pullDiv.renderInto(container);
      }
    }
  });

  enyo.kind({
    name: "Ubidreams.Scroller_PullElement",
    classes: "pulldown-elmt",
    addBefore: null,
    showing: false,
    components: [
      {
        tag: "i",
        name: "icon",
        classes: "scroller-pulldown-icon"
      }, {
        tag: "span",
        name: "label",
        classes: "scroller-pulldown-label",
        content: "Pull to refresh."
      }
    ],
    rendered: function() {
      this.inherited(arguments);
      return this.rotate(1);
    },
    rotate: function(status) {
      if (this.$.icon.status !== status && this.getShowing() === true) {
        this.$.icon.addRemoveClass("fa fa-arrow-down", status !== 3);
        this.$.icon.addRemoveClass("fa fa-spinner fa-spin", status === 3);
        this.$.icon.addRemoveClass("spi-default", status === 1);
        this.$.icon.addRemoveClass("spi-pulling", status === 2);
        switch (status) {
          case 1:
            this.$.label.setContent("Pull to refresh");
            break;
          case 2:
            this.$.label.setContent("Release to refresh");
            break;
          case 3:
            this.$.label.setContent("Refreshing ...");
        }
        return this.$.icon.status = status;
      }
    }
  });

}).call(this);
