// Generated by CoffeeScript 1.7.1
(function() {
  enyo.kind({
    name: "NumSync.filesTree.Main",
    classes: "page page-home enyo-fit",
    handlers: {
      ondrag: "_drag",
      ondragstart: "_resetDrag",
      ondragfinish: "_resetDrag",
      onBottomReached: "_reachBottom"
    },
    published: {
      filter: "",
      light: false,
      settings: null
    },
    components: [
      {
        kind: "enyo.Signals",
        requestSelections: "_onRequestSelection"
      }, {
        kind: "enyo.Signals",
        refreshFilesTree: "refreshSignal"
      }, {
        kind: "enyo.Signals",
        toggleFooter: "_onToggleFooter"
      }, {
        kind: "enyo.Signals",
        createFolderInTree: "_showCreateFolderModal"
      }, {
        kind: "enyo.Signals",
        requestFilesTreeLight: "_showFilesTreeLight"
      }, {
        name: "header",
        kind: "NumSync.Header.ui"
      }, {
        name: "treeWrapper",
        classes: "tree-wrapper"
      }, {
        name: "footer",
        kind: "NumSync.Footer.ui",
        showing: false
      }
    ],
    create: function() {
      this.inherited(arguments);
      this._currentPanel = -1;
      this._selectedEntries = [];
      this._history = [];
      this._selecting = false;
      this._lastError = null;
      this._panelToFill = null;
      this._panelToRefresh = null;
      this._replay = [];
      this._replayIsActive = false;
      this._isRefreshing = false;
      this._bindBackButton();
      if (this.light === true) {
        this.$.header.setType("import");
        this.$.footer.setType("import");
        return this.settingsChanged();
      } else {
        return this._createTreePanel();
      }
    },
    settingsChanged: function() {
      var i, trace, _i, _len, _ref, _results;
      if (this.settings.history != null) {
        this._history = this.settings.history;
      }
      if (this.settings.replay != null) {
        if (this.settings.replay.length > 0) {
          this._replayIsActive = true;
          _ref = this.settings.replay;
          _results = [];
          for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
            trace = _ref[i];
            if (i === this.settings.replay.length - 1) {
              this._replayIsActive = false;
            }
            this._createTreePanel(true);
            _results.push(this._fillTreePanel(trace.entries));
          }
          return _results;
        } else {
          return this._createTreePanel();
        }
      }
    },

    /*
      * Init files tree with root folders
      * @param <array> rootFolders
     */
    initWithRootFolders: function(rootFolders) {
      var _ref, _ref1;
      if (((_ref = this.settings) != null ? (_ref1 = _ref.replay) != null ? _ref1.length : void 0 : void 0) > 0) {
        return;
      }
      return this._fillTreePanel(rootFolders);
    },

    /*
      * Triggered when no content is retrieved from File System in offline mode
     */
    noContentFromFS: function() {
      this.$.treeWrapper.destroyClientControls();
      return this.createComponent({
        container: this.$.treeWrapper,
        classes: "tree-icon",
        components: [
          {
            tag: "i",
            classes: "fa fa fa-chain-broken"
          }
        ]
      }).render();
    },

    /*
      * Refresh current panel
      * @param <function> endRefresh
     */
    refreshSignal: function(inSender, inEvent) {
      return this.refresh(void 0);
    },
    refresh: function(endRefresh) {
      var currentFolderEntry, onError, onSuccess;
      if (this._isRefreshing) {
        return;
      }
      this._isRefreshing = true;
      onSuccess = Uju.bind(this, function(entries) {
        this._fillTreePanel(entries, true);
        if (!(endRefresh == null)) {
          endRefresh();
        }
        this._isRefreshing = false;
        if (this._lastError != null) {
          this._showErrorNotification(this._lastError);
          return this._lastError = null;
        }
      });
      onError = Uju.bind(this, function(error) {
        this.cleanCurrent(true);
        this._lastError = error;
        if (!(endRefresh == null)) {
          endRefresh();
        }
        return this._isRefreshing = false;
      });
      this._panelToRefresh = this._currentPanel;
      this._replay.pop();
      currentFolderEntry = this.getCurrentFolderEntry();
      if (currentFolderEntry != null) {
        return this._retrieveFolderContent(currentFolderEntry, onSuccess, onError);
      } else {
        return this._call("_getRootFolders", onSuccess, onError);
      }
    },

    /*
      * Get folder entry corresponding to the current panel
      * (the parent folder for the panel content)
     */
    getCurrentFolderEntry: function() {
      return this._history[this._history.length - 1];
    },

    /*
      * Get entries of the current tree panel
     */
    getCurrentEntries: function() {
      var entries, _ref, _ref1;
      entries = ((_ref = this.$["RootPanel" + this._currentPanel]) != null ? _ref.getCurrentEntries() : void 0) || ((_ref1 = this.$["AdditionalPanel" + this._currentPanel]) != null ? _ref1.getCurrentEntries() : void 0) || [];
      return entries;
    },

    /*
      * Clean the current panel
      * @param <boolean> noTransition : default to false
     */
    cleanCurrent: function(noTransition) {
      var onTransitionEnd, panelToDestroy;
      if (this._history.length === 0) {
        return false;
      }
      this._history.pop();
      this._replay.pop();
      panelToDestroy = this.$["panel" + this._currentPanel];
      if (noTransition === true) {
        panelToDestroy.removeClass("transition");
      } else {
        if (!panelToDestroy.hasClass("transition")) {
          panelToDestroy.addClass("transition");
        }
      }
      panelToDestroy.applyStyle("transform", "translate3d(100%, 0, 0)");
      panelToDestroy.applyStyle("-webkit-transform", "translate3d(100%, 0, 0)");
      this._currentPanel--;
      this._updateHeader();
      this._disableCurrentEntries(false);
      onTransitionEnd = Uju.bind(this, function() {
        panelToDestroy.destroy();
        if (this.light === false) {
          return this.refresh();
        }
      });
      if (noTransition) {
        onTransitionEnd();
      } else {
        setTimeout(onTransitionEnd, 200);
      }
      return true;
    },

    /*
      * Open files tree light modal with files tree infos
     */
    _showFilesTreeLight: function(inSender, inEvent) {
      var config;
      config = {};
      config.widgetConf = inEvent.widgetConf || {};
      config.widgetConf.settings = {};
      config.widgetConf.settings.history = Uju.clone(this._history);
      config.widgetConf.settings.replay = this._replay;
      return enyo.Signals.send("showModal", {
        clean: false,
        modal: {
          className: "NumSync.filesTreeLight",
          config: config
        }
      });
    },

    /*
      * Open create folder modal with files tree infos
     */
    _showCreateFolderModal: function() {
      var current, idCloudFolder, path;
      current = this.getCurrentFolderEntry();
      if (current != null) {
        if (current.type === NumSync.models.Entry.types.CLOUD_FOLDER) {
          idCloudFolder = current.id;
          path = null;
        } else {
          idCloudFolder = current.idCloudFolder;
          if (current.path === ".") {
            path = null;
          } else {
            path = current.path;
          }
        }
      }
      return enyo.Signals.send("showModal", {
        modal: {
          className: "NumSync.CreateFolder",
          config: {
            idCloudFolder: idCloudFolder,
            path: path
          }
        }
      });
    },

    /*
      * Disable action button from header which allow to show the actions menu
      * @param <boolean> disable
     */
    disableActionButtonFromHeader: function(disable) {
      return this.$.header.disableActionButton(disable);
    },

    /*
      * Request remove entry from controller with multiple entries
     */
    _requestRemoveMultiple: function() {
      return this._call("_requestRemoveEntries", this._selectedEntries);
    },

    /*
      * Request move entry from controller with multiple entries
     */
    _requestMoveMultiple: function() {
      return this._call("_requestMoveEntries", this._selectedEntries);
    },

    /*
      * Callback for android back button
     */
    _bindBackButton: function() {
      return this.$.header.bindBackButton(Uju.bind(this, this._onBackTap));
    },

    /*
      * Error notification modal
     */
    _showErrorNotification: function(error) {
      return enyo.Signals.send("showModal", {
        clean: true,
        modal: {
          kind: "NumSync.Notification",
          type: NumSync.Notification.types.ERROR,
          message: error
        }
      });
    },
    _resetDrag: function() {
      return this.dragged = false;
    },

    /*
      * Show pushMenu on swipe
     */
    _drag: function(inSender, inEvent) {
      if (!this.dragged && !this._selecting && Math.abs(inEvent.dy) < 15 && inEvent.dx > 50) {
        this.dragged = true;
        return enyo.Signals.send("showPushMenu");
      }
    },

    /*
      * Triggered when "toggleFooter" signal is received
     */
    _onToggleFooter: function(inSender, inEvent) {
      if (inEvent.show === true) {
        this.$.footer.setShowing(true);
        return this.$.treeWrapper.addClass("offset-footer");
      } else {
        this.$.footer.setShowing(false);
        return this.$.treeWrapper.removeClass("offset-footer");
      }
    },

    /*
      * Triggered when "requestSelections" signal is received
     */
    _onRequestSelection: function(inSender, inEvent) {
      var entry, enyoEntry, right, _i, _len, _ref;
      this._selectedEntries = [];
      this._selecting = inEvent.selecting;
      _ref = this.getCurrentEntries();
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        enyoEntry = _ref[_i];
        entry = enyoEntry.getEntry();
        if (this._selecting) {
          right = entry.shareType || entry._right_;
          if ((right == null) || right === NumSync.models.Share.rights.WRITE) {
            enyoEntry.setButton(NumSync.Entry.actions.SELECTION);
          } else {
            enyoEntry.setButton(NumSync.Entry.actions.NONE);
          }
        } else {
          enyoEntry.setButton(NumSync.Entry.actions.INFORMATION);
        }
      }
      if (!this._selecting) {
        return this._updateHeader();
      }
    },

    /*
      * BackTap event from Header
     */
    _onBackTap: function(inSender, inEvent) {
      return this.cleanCurrent();
    },

    /*
      * Create a new tree panel in the tree wrapper
      * @param <boolean> noTransition : default to false
     */
    _createTreePanel: function(noTransition) {
      var panel;
      this._currentPanel++;
      this._panelToFill = this._currentPanel;
      panel = this.createComponent({
        kind: "NumSync.filesTree.PanelWrapper",
        name: "panel" + this._currentPanel,
        container: this.$.treeWrapper
      });
      panel.render();
      if (this._currentPanel > 0) {
        panel.applyStyle("transform", "translate3d(100%, 0, 0)");
        panel.applyStyle("-webkit-transform", "translate3d(100%, 0, 0)");
      } else {
        if (this.light === true) {
          this._onToggleFooter(this, {
            show: true
          });
        }
      }
      return setTimeout(Uju.bind(this, function() {
        if (noTransition !== true) {
          panel.addClass("transition");
        }
        panel.applyStyle("transform", "translate3d(0, 0, 0)");
        panel.applyStyle("-webkit-transform", "translate3d(0, 0, 0)");
        return this._updateHeader();
      }), 200);
    },

    /*
      * Fill a tree panel previously created
      * @param <array> entries
      * @param <boolean> refresh
     */
    _fillTreePanel: function(entries, refresh) {
      this._replay.push({
        entries: entries
      });
      if (this._currentPanel > 0) {
        return this._createAdditionalPanel(entries, refresh);
      } else {
        return this._createRootPanel(entries, refresh);
      }
    },

    /*
      * Update header
     */
    _updateHeader: function() {
      var currentFolderEntry;
      currentFolderEntry = this.getCurrentFolderEntry() || {};
      if (this._history.length === 0) {
        this.$.header.setTitle("DEFAULT");
      } else {
        this.$.header.setTitle(currentFolderEntry.getEntryName() || "");
      }
      if (this._currentPanel === 0) {
        if (this.light === true) {
          return this.$.header.setType("import");
        } else {
          return this.$.header.setType("files");
        }
      } else {
        if (this.light === true) {
          return this.$.header.setType("back-import");
        } else {
          return this.$.header.setType("back");
        }
      }
    },

    /*
      * Create the root panel with current entries
      * @param <arrray> entries
      * @param <boolean> refresh
     */
    _createRootPanel: function(entries, refresh) {
      var currentPanel, panel;
      if (this._currentPanel !== 0) {
        return;
      }
      if (refresh) {
        if (this._panelToRefresh !== this._currentPanel) {
          return;
        }
      } else {
        if (this._panelToFill !== this._currentPanel) {
          return;
        }
      }
      currentPanel = this.$["panel" + this._currentPanel].$.scroller;
      currentPanel.destroyClientControls();
      if (entries.length === 0) {
        this._createPanelFromKind("NumSync.filesTree.EmptyRoot");
      } else {
        panel = this._createPanelFromKind("NumSync.filesTree.RootPanel");
        panel.addEntries(entries);
      }
      if (refresh) {
        return this._panelToRefresh = null;
      } else {
        return this._panelToFill = null;
      }
    },

    /*
      * Create an additional panel with current entries
      * @param <array> entries
      * @param <boolean> refresh
     */
    _createAdditionalPanel: function(entries, refresh) {
      var currentPanel, panel;
      if (this._currentPanel < 1) {
        return;
      }
      if (refresh) {
        if (this._panelToRefresh !== this._currentPanel) {
          return;
        }
      } else {
        if (this._panelToFill !== this._currentPanel) {
          return;
        }
      }
      currentPanel = this.$["panel" + this._currentPanel].$.scroller;
      currentPanel.destroyClientControls();
      if (entries.length === 0) {
        this._createPanelFromKind("NumSync.filesTree.EmptyPanel");
      } else {
        panel = this._createPanelFromKind("NumSync.filesTree.AdditionalPanel");
        panel.addEntries(entries);
      }
      if (refresh) {
        return this._panelToRefresh = null;
      } else {
        return this._panelToFill = null;
      }
    },

    /*
      * Create panel method
      * @param <string> kind
      * @return <enyo> panel
     */
    _createPanelFromKind: function(kind) {
      var currentPanel, panel;
      currentPanel = this.$["panel" + this._currentPanel].$.scroller;
      currentPanel.destroyClientControls();
      panel = this.createComponent({
        kind: kind,
        container: currentPanel,
        name: kind.split(".").pop() + this._currentPanel
      });
      panel.render();
      return panel;
    },

    /*
      * Create an new entry for the current tree panel
     */
    _createEntry: function(entry, container) {
      var button, comp_entry, current, entry_, i, _i, _len, _ref, _ref1, _results;
      if (this.light) {
        button = NumSync.Entry.actions.LIGHT;
      } else {
        button = NumSync.Entry.actions.INFORMATION;
      }
      switch (entry.type) {
        case NumSync.models.Entry.types.FILE:
          entry_ = new NumSync.models.File(entry);
          break;
        case NumSync.models.Entry.types.FOLDER:
          entry_ = new NumSync.models.Folder(entry);
          break;
        case NumSync.models.Entry.types.CLOUD_FOLDER:
          entry_ = new NumSync.models.CloudFolder(entry);
          break;
        case NumSync.models.Entry.types.SHARED_FOLDER:
          entry_ = new NumSync.models.Share(entry);
      }
      entry_._share_ = this._call("_getShareForEntry", entry);
      current = this.getCurrentFolderEntry();
      if (current != null) {
        if (!this._replayIsActive) {
          entry_._parent_ = current.getEntryName();
        }
        if (current.type === NumSync.models.Entry.types.SHARED_FOLDER || (current._right_ != null)) {
          entry_._right_ = (_ref = current._right_) != null ? _ref : current.shareType;
        }
      }
      this.createComponent({
        kind: "NumSync.Entry",
        entry: entry_,
        container: container,
        tag: "li",
        classes: "list-group-item",
        onEntrySelect: "_onEntrySelected",
        onEntryTap: "_onEntryTap",
        button: button
      }).render();
      _ref1 = this.getCurrentEntries();
      _results = [];
      for (i = _i = 0, _len = _ref1.length; _i < _len; i = ++_i) {
        comp_entry = _ref1[i];
        if (i % 2 === 0) {
          comp_entry.addClass("even");
          _results.push(comp_entry.removeClass("odd"));
        } else {
          comp_entry.addClass("odd");
          _results.push(comp_entry.removeClass("even"));
        }
      }
      return _results;
    },

    /*
      * Triggered when an entry is selected (checked or unchecked)
     */
    _onEntrySelected: function(inSender, inEvent) {
      var entry;
      entry = inSender.getEntry();
      if (inEvent.selected) {
        this._selectedEntries.push(entry);
      } else {
        this._selectedEntries.splice(this._selectedEntries.indexOf(entry), 1);
      }
      if (this._selectedEntries.length > 0) {
        return this.$.footer.enableButtons(true, this._currentPanel > 0);
      } else {
        return this.$.footer.disableButtons();
      }
    },

    /*
      * Triggered when an entry is clicked
     */
    _onEntryTap: function(inSender, inEvent) {
      var entry, notExist, onOpen;
      this._disableCurrentEntries(true);
      entry = inSender.getEntry();
      if (entry.type === NumSync.models.Entry.types.FILE) {
        notExist = Uju.bind(this, function() {
          inSender.destroy();
          if (this.getCurrentEntries().length === 0) {
            return this._createPanelFromKind("NumSync.filesTree.EmptyPanel");
          }
        });
        onOpen = Uju.bind(this, function() {
          return this._disableCurrentEntries(false);
        });
        return this._call("_requestOpenEntry", entry, {
          notExist: notExist,
          onOpen: onOpen
        });
      } else {
        this._history.push(entry);
        this._createTreePanel();
        return this._retrieveFolderContent(entry, Uju.bind(this, function(entries) {
          return this._fillTreePanel(entries);
        }), Uju.bind(this, function(error) {
          enyo.Signals.send("showModal", {
            modal: {
              kind: "NumSync.Notification",
              type: NumSync.Notification.types.ERROR,
              message: error
            }
          });
          return this.cleanCurrent(true);
        }));
      }
    },

    /*
      * Retrieve a folder's content from the controller
     */
    _retrieveFolderContent: function(folder, onSuccess, onError) {
      var idCloudFolder;
      switch (folder.type) {
        case NumSync.models.Entry.types.CLOUD_FOLDER:
          idCloudFolder = folder.id;
          break;
        default:
          idCloudFolder = folder.idCloudFolder;
      }
      return this._call("_updateMyShares", Uju.bind(this, function() {
        return this._call("_getFolderContent", idCloudFolder, folder.path, {
          onSuccess: onSuccess,
          onError: onError
        });
      }));
    },

    /*
      * Disable or enable current entries
      * @param <boolean> disable : true for disable entries else false
     */
    _disableCurrentEntries: function(disable) {
      var current_entry, _i, _len, _ref, _results;
      _ref = this.getCurrentEntries();
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        current_entry = _ref[_i];
        _results.push(current_entry.setDisabled(disable));
      }
      return _results;
    },
    _reachBottom: function() {
      if (this._currentPanel > 0) {
        return this.$["AdditionalPanel" + this._currentPanel].loadMoreEntries();
      }
    }
  });

  enyo.kind({
    name: "NumSync.filesTree.PanelWrapper",
    events: {
      onBottomReached: ""
    },
    handlers: {
      onScroll: "_onScroll"
    },
    classes: "tree-panel",
    components: [
      {
        name: "scroller",
        kind: "Ubidreams.Scroller",
        classes: "ios-no-offset",
        components: [
          {
            classes: "tree-icon",
            components: [
              {
                tag: "i",
                classes: "fa fa-spinner fa-spin"
              }
            ]
          }
        ]
      }
    ],
    rendered: function() {
      this.inherited(arguments);
      if (this.owner.light === false) {
        return this.$.scroller.setPullCallback(Uju.bind(this.owner, this.owner.refresh));
      }
    },
    _onScroll: function(inSender, event) {
      var _ref, _ref1;
      if (((_ref = event.scrollBounds) != null ? _ref.top : void 0) > ((_ref1 = event.scrollBounds) != null ? _ref1.maxTop : void 0) - 200) {
        this.doBottomReached();
      }
      return true;
    }
  });

  enyo.kind({
    name: "NumSync.filesTree.RootPanel",
    tag: null,
    components: [
      {
        name: "foldersWrapper",
        classes: "panel panel-default",
        showing: false,
        components: [
          {
            classes: "panel-heading",
            components: [
              {
                tag: "h3",
                classes: "panel-title",
                i18n: [
                  {
                    key: "folders_basic"
                  }
                ]
              }
            ]
          }, {
            tag: "ul",
            classes: "list-group",
            name: "folders"
          }
        ]
      }, {
        name: "sharedWrapper",
        classes: "panel panel-default",
        showing: false,
        components: [
          {
            classes: "panel-heading",
            components: [
              {
                tag: "h3",
                classes: "panel-title",
                i18n: [
                  {
                    key: "folders_shared"
                  }
                ]
              }
            ]
          }, {
            tag: "ul",
            classes: "list-group",
            name: "sharedFolders"
          }, {
            name: "shared_placeholder",
            classes: "shared-folders-placeholder",
            components: [
              {
                tag: "i",
                classes: "fa fa-info-circle"
              }, {
                tag: "span",
                i18n: [
                  {
                    key: "no_shared_folders"
                  }
                ]
              }
            ]
          }
        ]
      }
    ],
    rendered: function() {
      this.inherited(arguments);
      Ubidreams._i18n.translate(this);
      if (this.owner.filter === "all" || this.owner.filter === "myfolders") {
        this.$.foldersWrapper.setShowing(true);
      }
      if (this.owner.filter === "all" || this.owner.filter === "shared") {
        return this.$.sharedWrapper.setShowing(true);
      }
    },
    addEntries: function(entries) {
      var container, entry, _i, _len;
      container = null;
      for (_i = 0, _len = entries.length; _i < _len; _i++) {
        entry = entries[_i];
        if (entry.type === NumSync.models.Entry.types.CLOUD_FOLDER) {
          container = this.$["folders"];
        } else {
          container = this.$.sharedFolders;
        }
        this.owner._createEntry(entry, container);
      }
      if (this.$.shared_placeholder != null) {
        if (this.$.sharedFolders.getClientControls().length > 0) {
          return this.$.shared_placeholder.hide();
        } else {
          return this.$.shared_placeholder.show();
        }
      }
    },
    getCurrentEntries: function() {
      var entries, _ref, _ref1;
      entries = [];
      entries = entries.concat(((_ref = this.$["folders"]) != null ? _ref.getClientControls() : void 0) || [], ((_ref1 = this.$["sharedFolders"]) != null ? _ref1.getClientControls() : void 0) || []);
      return entries;
    }
  });

  enyo.kind({
    name: "NumSync.filesTree.AdditionalPanel",
    tag: null,
    components: [
      {
        classes: "panel panel-default",
        components: [
          {
            tag: "ul",
            classes: "list-group",
            name: "folders"
          }, {
            tag: "ul",
            classes: "list-group",
            name: "files"
          }
        ]
      }
    ],
    addEntries: function(entries, sort) {
      var container, entry, _i, _len, _ref, _results;
      container = null;
      sort = sort || true;
      if (sort) {
        entries.sort(function(a, b) {
          var strcmp;
          strcmp = function(str1, str2) {
            return str1.localeCompare(str2);
          };
          if (a.type === b.type) {
            return strcmp(a.path.toUpperCase(), b.path.toUpperCase());
          } else if (a.type === NumSync.models.Entry.types.FOLDER) {
            return -1;
          } else {
            return 1;
          }
        });
      }
      this.furtherEntries = entries.slice(21);
      _ref = entries.slice(0, 21);
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        entry = _ref[_i];
        switch (entry.type) {
          case NumSync.models.Entry.types.FOLDER:
            container = this.$["folders"];
            break;
          case NumSync.models.Entry.types.FILE:
            container = this.$["files"];
            break;
          default:
            throw "HomePage :: _createAdditionalPanel :: " + entry.type + " isn't a correct type.";
        }
        _results.push(this.owner._createEntry(entry, container));
      }
      return _results;
    },
    loadMoreEntries: function() {
      return this.addEntries(this.furtherEntries, false);
    },
    getCurrentEntries: function() {
      var entries, _ref, _ref1;
      entries = [];
      entries = entries.concat(((_ref = this.$["folders"]) != null ? _ref.getClientControls() : void 0) || [], ((_ref1 = this.$["files"]) != null ? _ref1.getClientControls() : void 0) || []);
      return entries;
    }
  });

  enyo.kind({
    name: "NumSync.filesTree.EmptyPanel",
    tag: "p",
    i18n: [
      {
        key: "folder_empty"
      }
    ],
    classes: "empty-folder",
    create: function() {
      this.inherited(arguments);
      return Ubidreams._i18n.translate(this);
    }
  });

  enyo.kind({
    name: "NumSync.filesTree.EmptyRoot",
    tag: null,
    components: [
      {
        classes: "jumbotron",
        components: [
          {
            classes: "container",
            components: [
              {
                tag: "h1",
                i18n: [
                  {
                    key: "welcome"
                  }
                ]
              }, {
                tag: "p",
                i18n: [
                  {
                    key: "no_root"
                  }
                ]
              }, {
                tag: "p",
                components: [
                  {
                    kind: "Button",
                    classes: "btn btn-primary btn-lg",
                    i18n: [
                      {
                        key: "create_first_folder"
                      }
                    ],
                    ontap: "_requestFolderModal"
                  }
                ]
              }
            ]
          }
        ]
      }
    ],
    create: function() {
      this.inherited(arguments);
      return Ubidreams._i18n.translate(this);
    },
    _requestFolderModal: function() {
      return enyo.Signals.send("showModal", {
        modal: {
          className: "NumSync.CreateFolder"
        }
      });
    }
  });

}).call(this);
